PROGRAM CONFIG;
{$I-}
USES CRT;
VAR ZF,QF:FILE;
    DD:DWORD;
    BUFFER:ARRAY[0..63999] OF BYTE;
    RL:DWORD;
FUNCTION COPYTOZFWS(FN:STRING):BOOLEAN;
BEGIN
 ASSIGN(QF,FN);
 RESET(QF,1);
 IF IORESULT<>0 THEN
 BEGIN
  COPYTOZFWS:=FALSE;
  EXIT;
 END;
 DD:=FILESIZE(QF)+4;
 BLOCKWRITE(ZF,DD,4);
 REPEAT
  BLOCKREAD(QF,BUFFER,64000,RL);
  BLOCKWRITE(ZF,BUFFER,RL);
 UNTIL RL=0;
 CLOSE(QF);
 COPYTOZFWS:=TRUE;
END;
FUNCTION UPSTR(S:STRING):STRING;
VAR I:DWORD;
BEGIN
 FOR I:=1 TO LENGTH(S) DO S[I]:=UPCASE(S[I]);
 UPSTR:=S;
END;
{ Aufgaben des CONFIG-Programs }
TYPE PCONFIGE=^TCONFIGE;
     TCONFIGE=RECORD
      NEXT,LAST:PCONFIGE;
      FILEN:STRING;
      PARA:STRING;
      COUNT:DWORD;
     END;
VAR FIRSTCONFIGE:PCONFIGE;
PROCEDURE ADDCONFIG;
VAR P:PCONFIGE;
BEGIN
 NEW(P);
 WRITE('Treiberdatei : ');
 READLN(P^.FILEN);
 P^.FILEN:=UPSTR(P^.FILEN);
 WRITE('Parameter    :');
 READLN(P^.PARA);
 WRITE('Wie oft ?    : ');
 READLN(P^.COUNT);
 P^.NEXT:=FIRSTCONFIGE;
 P^.LAST:=NIL;
 IF FIRSTCONFIGE<>NIL THEN FIRSTCONFIGE^.LAST:=P;
 FIRSTCONFIGE:=P;
END;
PROCEDURE REMOVECONFIG;
VAR P,P2:PCONFIGE;
    S:STRING;
BEGIN
 WRITE('Treiberdatei : ');
 READLN(S);
 S:=UPSTR(S);
 P:=FIRSTCONFIGE;
 WHILE P<>NIL DO
 BEGIN
  P2:=P^.NEXT;
  IF P^.FILEN=S THEN
  BEGIN
   WRITELN('Lsche (',P^.COUNT,')');
   IF P^.LAST<>NIL THEN P^.LAST^.NEXT:=P2 ELSE FIRSTCONFIGE:=P2;
   IF P2<>NIL THEN P2^.LAST:=P^.LAST;
  END;
  P:=P2;
 END;
END;
PROCEDURE LISTCONFIG;
VAR L:DWORD;
    P:PCONFIGE;
BEGIN
 WRITELN('Treiber : ');
 P:=FIRSTCONFIGE;
 L:=0;
 WHILE P<>NIL DO
 BEGIN
  WRITELN(P^.FILEN,' (',P^.COUNT,')');
  INC(L);
  IF (L=24) AND (P^.NEXT<>NIL) THEN
  BEGIN
   WRITELN('Taste drcken...');
   READKEY;
   L:=0;
  END;
  P:=P^.NEXT;
 END;
 WRITELN('Taste drcken...');
 READKEY;
END;
PROCEDURE CHANGECONFIG;
VAR C:CHAR;
BEGIN
 REPEAT
  WRITELN('Befehle : ');
  WRITELN(' Treiber auflisten                [L]');
  WRITELN(' Treiber zur Konfig. hinzufgen   [+]');
  WRITELN(' Trieber von Konfig. entfernen    [-]');
  WRITELN(' Zurck                           [ESC]');
  WRITE('CONFIG:');
  C:=UPCASE(READKEY);
  WRITELN(C);
  CASE C OF
   '+':ADDCONFIG;
   '-':REMOVECONFIG;
   'L':LISTCONFIG;
  END;
 UNTIL C=#27;
END;
PROCEDURE LOADCONFIG;
VAR F:TEXT;
    P:PCONFIGE;
    S,S2,S3:STRING;
    E:INTEGER;
BEGIN
 ASSIGN(F,'BOOT.CFG');
 RESET(F);
 IF IORESULT=0 THEN
 BEGIN
  REPEAT
   READLN(F,S);
   READLN(F,S2);
   READLN(F,S3);
   IF S<>'' THEN
   BEGIN
    NEW(P);
    P^.FILEN:=UPSTR(S);
    P^.PARA:=S2;
    VAL(S3,P^.COUNT,E);
    P^.NEXT:=FIRSTCONFIGE;
    P^.LAST:=NIL;
    IF FIRSTCONFIGE<>NIL THEN FIRSTCONFIGE^.LAST:=P;
    FIRSTCONFIGE:=P;
   END;
  UNTIL S='';
  CLOSE(F);
 END;
END;
PROCEDURE CREATEBOOTBLOCK;
VAR P:PCONFIGE;
    I:DWORD;
BEGIN
 ASSIGN(ZF,'BOOT.DAT');
 REWRITE(ZF,1);
 P:=FIRSTCONFIGE;
 I:=1;
 WHILE P<>NIL DO
 BEGIN
  INC(I,P^.COUNT);
  P:=P^.NEXT;
 END;
 BLOCKWRITE(ZF,I,4);
 WRITELN('Anzahl Module : ',I);
 DD:=0; { Kernel hat keine Parameter zur Zeit }
 BLOCKWRITE(ZF,DD,4);
 IF NOT COPYTOZFWS('KERNEL32.K32') THEN
 BEGIN
  WRITELN('KERNEL32.K32 nicht gefunden !');
  CLOSE(ZF);
  ERASE(ZF);
  EXIT;
 END;
 P:=FIRSTCONFIGE;
 WHILE P<>NIL DO
 BEGIN
  WRITELN('Binde ',P^.FILEN,' ein...');
  FOR I:=1 TO P^.COUNT DO
  BEGIN
   DD:=LENGTH(P^.PARA);
   IF DD<>0 THEN INC(DD,4);
   BLOCKWRITE(ZF,DD,4);
   BLOCKWRITE(ZF,P^.PARA[1],LENGTH(P^.PARA));
   IF NOT COPYTOZFWS(P^.FILEN) THEN
   BEGIN
    WRITELN(P^.FILEN+' nicht gefunden !');
    CLOSE(ZF);
    ERASE(ZF);
    EXIT;
   END;
  END;
  P:=P^.NEXT;
 END;
 DD:=0;
 BLOCKWRITE(ZF,DD,4);
 BLOCKWRITE(ZF,DD,4);
 CLOSE(ZF);
END;
PROCEDURE SAVECONFIG;
VAR S:STRING;
    F:TEXT;
    P:PCONFIGE;
BEGIN
 ASSIGN(F,'BOOT.CFG');
 REWRITE(F);
 P:=FIRSTCONFIGE;
 WHILE P<>NIL DO
 BEGIN
  WRITELN(F,P^.FILEN);
  WRITELN(F,P^.PARA);
  WRITELN(F,P^.COUNT);
  P:=P^.NEXT;
 END;
 CLOSE(F);
END;
PROCEDURE WRITERS3_LINEAR;
VAR F,W:FILE;
    BUFFER:ARRAY[0..511] OF BYTE;
BEGIN
 WRITELN('Disk-Image schreiben');
 ASSIGN(W,'DISK.IMG');
 REWRITE(W,1);
 ASSIGN(F,'BOOTSEC.BTS');
 RESET(F,1);
 IF IORESULT<>0 THEN
 BEGIN
  WRITELN('missing BOOTSEC.BTS');
  CLOSE(W);
  ERASE(W);
  EXIT;
 END;
 BLOCKREAD(F,BUFFER,512,RL);
 BUFFER[510]:=$55;
 BUFFER[511]:=$AA;
 BLOCKWRITE(W,BUFFER,512);
 ASSIGN(F,'LS\LINEAR.LOA');
 RESET(F,1);
 IF IORESULT<>0 THEN
 BEGIN
  WRITELN('missing LS\LINEAR.LOA');
  CLOSE(W);
  ERASE(W);
  EXIT;
 END;
 REPEAT
  BLOCKREAD(F,BUFFER,512,RL);
  IF RL<>0 THEN BLOCKWRITE(W,BUFFER,512);
 UNTIL RL=0;
 CLOSE(F);
 ASSIGN(F,'KERNEL16.K16');
 RESET(F,1);
 IF IORESULT<>0 THEN
 BEGIN
  WRITELN('missing KERNEL16.K16');
  CLOSE(W);
  ERASE(W);
  EXIT;
 END;
 REPEAT
  BLOCKREAD(F,BUFFER,512,RL);
  IF RL<>0 THEN BLOCKWRITE(W,BUFFER,512);
 UNTIL RL=0;
 CLOSE(F);
 ASSIGN(F,'BOOT.DAT');
 RESET(F,1);
 IF IORESULT<>0 THEN
 BEGIN
  WRITELN('missing BOOT.DAT');
  CLOSE(W);
  ERASE(W);
 END;
 REPEAT
  BLOCKREAD(F,BUFFER,512,RL);
  IF RL<>0 THEn BLOCKWRITE(W,BUFFER,512);
 UNTIL RL=0;
 CLOSE(F);
 CLOSE(W);
END;
PROCEDURE WRITERS3;
VAR C:CHAR;
BEGIN
 REPEAT
  WRITELN('Bitte whlen :');
  WRITELN(' RS3 Linear (Floppy)   [L]');
  C:=UPCASE(READKEY);
  CASE C OF
   'L':WRITERS3_LINEAR;
  END;
 UNTIL C=#27;
END;
VAR C:CHAR;
BEGIN
 LOADCONFIG;
 REPEAT
  WRITELN('Befehle : ');
  WRITELN(' Bootblock erstellen           [B]');
  WRITELN(' Konfiguration ndern          [K]');
  WRITELN(' RS3 Image                     [W]');
  WRITELN(' Programm beenden              [ESC]');
  WRITE(':');
  C:=UPCASE(READKEY);
  WRITELN(C);
  CASE C OF
   'K':CHANGECONFIG;
   'B':CREATEBOOTBLOCK;
   'W':WRITERS3_LINEAR;
  END;
 UNTIL C=#27;
 SAVECONFIG;
END.
