PROGRAM DESKTOP;
USES ALLBAS,GUI,GUIOBJ,GRAPH,PICSERV,KEYB,DEBUG,DEBDISKS,DIRDISKS,TASKS,FS,USER;
VAR M:PKERNELDEBUGWINDOW;
    I:PINPUTLINE;
    DIRHAND:POINTER;
    STDUSER:POINTER;
{$I DESKTOP.INC}
FUNCTION EXTRACTPAR(VAR S:STRING):STRING;
VAR I:DWORD;
    F:BOOLEAN;
BEGIN
 EXTRACTPAR:='';
 I:=1;
 F:=TRUE;
 WHILE (I<=BYTE(S[0])) AND ((S[I]<>' ') OR F) DO
 BEGIN
  IF S[I]<>' ' THEN F:=FALSE;
  IF NOT F THEN EXTRACTPAR:=EXTRACTPAR+S[I];
  INC(I);
 END;
 STR_DELETE(S,1,I-1);
END;
FUNCTION ISASCIINUMBER(S:STRING):BOOLEAN;
VAR I:DWORD;
BEGIN
 WHILE (BYTE(S[0])<>0) AND (S[1]=' ') DO STR_DELETE(S,1,1);
 IF S[0]=#0 THEN
 BEGIN
  ISASCIINUMBER:=FALSE;
  EXIT;
 END;
 IF S[1]='$' THEN
 BEGIN
  FOR I:=2 TO BYTE(S[0]) DO
  BEGIN
   IF NOT (((S[I]>='0') AND (S[I]<='9')) OR
           ((S[I]>='A') AND (S[I]<='F')) OR
           ((S[I]>='a') AND (S[I]<='f'))) THEN
   BEGIN
    ISASCIINUMBER:=FALSE;
    EXIT;
   END;
  END;
 END
 ELSE
 BEGIN
  FOR I:=1 TO BYTE(S[0]) DO
  BEGIN
   IF NOT ((S[I]>='0') AND (S[I]<='9')) THEN
   BEGIN
    ISASCIINUMBER:=FALSE;
    EXIT;
   END;
  END;
 END;
 ISASCIINUMBER:=TRUE;
END;
FUNCTION ASCIITOINT(S:STRING):DWORD;
VAR I:DWORD;
BEGIN
 WHILE (BYTE(S[0])<>0) AND (S[1]=' ') DO STR_DELETE(S,1,1);
 ASCIITOINT:=0;
 IF S[0]=#0 THEN EXIT;
 IF S[1]='$' THEN
 BEGIN
  FOR I:=2 TO BYTE(S[0]) DO
  BEGIN
   ASCIITOINT:=ASCIITOINT SHL 4;
   IF (S[I]>='0') AND (S[I]<='9') THEN INC(ASCIITOINT,BYTE(S[I])-$30) ELSE
   IF (S[I]>='A') AND (S[I]<='F') THEN INC(ASCIITOINT,BYTE(S[I])-$37) ELSE
   IF (S[I]>='a') AND (S[I]<='f') THEN INC(ASCIITOINT,BYTE(S[I])-$57) ELSE
   BEGIN
    ASCIITOINT:=$FFFFFFFF;
    EXIT;
   END;
  END;
 END
 ELSE
 BEGIN
  FOR I:=1 TO BYTE(S[0]) DO
  BEGIN
   ASCIITOINT:=ASCIITOINT*10;
   IF (S[I]>='0') AND (S[I]<='9') THEN INC(ASCIITOINT,BYTE(S[I])-$30) ELSE
   BEGIN
    ASCIITOINT:=$FFFFFFFF;
    EXIT;
   END;
  END;
 END;
END;
PROCEDURE DUMPSECTOR(S:STRING);
VAR P,P2:STRING;
    BUFFER:ARRAY[0..511] OF BYTE;
    HAND:TDIRDISKHAND5;
BEGIN
 P:=EXTRACTPAR(S);
 P2:=EXTRACTPAR(S);
 IF (NOT ISASCIINUMBER(P)) OR (NOT ISASCIINUMBER(P2)) THEN
 BEGIN
  WRITELNSTR('Error : Number expected !');
  EXIT;
 END;
 DWORD(HAND.DISK):=ASCIITOINT(P);
 HAND.ADDR:=ASCIITOINT(P2);
 WRITELNSTR('Read sector '+INTSTR(HAND.ADDR)+' from '+HEXSTR(DWORD(HAND.DISK),8));
 HAND.TSS:=GETTASKHANDLE();
 HAND.DATA:=@BUFFER;
 WRITELNSTR('SEND CMD');
 READBLOCK(@HAND);
 WRITELNSTR('SLEEP');
 DISABLETASK(HAND.TSS);
 WRITELNSTR('STAT CHECK');
 WHILE HAND.STATE<>1 DO SCHEDULE;
 WRITELNSTR('RETURNED');
END;
PROCEDURE LISTDRIVERS;
VAR P:PDRIVER;
    GR:DWORD;
BEGIN
 STARTREADINGDRIVERLIST(GR);
 P:=GETFIRSTDRIVER();
 WRITESTR('[Drivers]ͻ');
 WRITESTR(' Typ       Id        Description                                            ');
 WRITESTR('Ķ');
 WHILE P<>NIL DO
 BEGIN
  WRITESTR(' '+FORMATRSTR(HEXSTR(P^.TYP),8)+'  '+FORMATRSTR(HEXSTR(P^.ID),8)+'  '+FORMATLSTR(P^.DESC,54)+' ');
  P:=P^.NEXT;
 END;
 WRITESTR('ͼ');
 STOPREADINGDRIVERLIST(GR);
END;
PROCEDURE FS_MD(P:PCHAR);
VAR E:DWORD;
BEGIN
 E:=CREATEDIR(DIRHAND,P,0,0,0,STDUSER); { Noch werde keine Rechte gesetzt. }
 WRITELNSTR('CREATEDIR : '+HEXSTR(E)+' ('+STRPAS(P)+')');
END;
PROCEDURE FS_EXISTS(P:PCHAR);
BEGIN
 IF NAMEEXISTS(DIRHAND,P,STDUSER)=0 THEN
 BEGIN
  WRITELNSTR(STRPAS(P)+' existiert.');
 END ELSE WRITELNSTR(STRPAS(P)+' existiert nicht.');
END;
PROCEDURE FS_DIR(P:PCHAR);
VAR ERR:DWORD;
    BUFFER:ARRAY[0..1023] OF CHAR;
    PC:PCHAR;
    CLASS:DWORD;
BEGIN
 WRITELNSTR('Verzeichnisinhalt :');
 PC:=@BUFFER;
 ERR:=FINDFIRST(DIRHAND,P,STDUSER,PC,CLASS);
 WHILE ERR=0 DO
 BEGIN
  WRITELNSTR('# '+STRPAS(PC));
  ERR:=FINDNEXT(DIRHAND,PC,CLASS);
 END;
 FINDCLOSE(DIRHAND);
END;
PROCEDURE FS_RD(P:PCHAR);
VAR ERR:DWORD;
BEGIN
 ERR:=DESTROYDIR(DIRHAND,P,STDUSER);
 WRITELNSTR('Errcode : '+HEXSTR(ERR));
END;
PROCEDURE FS_CD(P:PCHAR);
VAR ERR:DWORD;
BEGIN
 ERR:=CHANGEDIR(DIRHAND,P,STDUSER);
 WRITELNSTR('Errcode : '+HEXSTR(ERR));
END;
PROCEDURE FS_TYPE(P:PCHAR);
VAR ERR:DWORD;
    F:POINTER;
BEGIN
 ERR:=OPENFILE(DIRHAND,F,P,0,STDUSER);
 WRITELNSTR('OPENFILE : '+HEXSTR(ERR));
 IF ERR=0 THEN
 BEGIN
  ERR:=CLOSEFILE(F);
  WRITELNSTR('CLOSEFILE : '+HEXSTR(ERR));
 END;
END;
PROCEDURE EXECCMD(SENDER:PINPUTLINE);
VAR S,CMD:STRING;
    P:PDESKTOPCMDDESC;
BEGIN
 S:=SENDER^.GETTEXT;
 SENDER^.SETTEXT('');
 CMD:=UPSTR(EXTRACTPAR(S));
 WHILE S[1]=' ' DO STR_DELETE(S,1,1);
 S:=S+#0;
 IF CMD='SHUTDOWN' THEN SHUTDOWN(NIL) ELSE
 IF CMD='LDRVS' THEN LISTDRIVERS ELSE
 IF CMD='LDISKS' THEN WRITEDISKLIST ELSE
 IF CMD='DUMPSEC' THEN DUMPSECTOR(S) ELSE
 IF CMD='LTASKS' THEN WRITETASKLIST ELSE
 IF CMD='MD' THEN FS_MD(PCHAR(@S[1])) ELSE
 IF CMD='EXISTS' THEN FS_EXISTS(@S[1]) ELSE
 IF CMD='DIR' THEN FS_DIR(@S[1]) ELSE
 IF CMD='CD' THEN FS_CD(@S[1]) ELSE
 IF CMD='RD' THEN FS_RD(@S[1]) ELSE
 IF CMD='TYPE' THEN FS_TYPE(@S[1]) ELSE
 BEGIN
  { Externe Befehle scannen... }
  P:=FIRSTDESKTOPCMD;
  WHILE P<>NIL DO
  BEGIN
   IF P^.CMD=CMD THEN
   BEGIN
    P^.PROC(PCHAR(@S[1]));
    BREAK;
   END;
   P:=P^.NEXT;
  END;
 END;
END;
BEGIN
 STARTDRIVERINITIALIZATION;
 ADDDRIVER(@DESKTOPDRV);
 STOPDRIVERINITIALIZATION;
 WRITELNSTR('Befehle : ');
 WRITELNSTR(' shutdown     : System ordnungsgem herunterfahren');
 WRITELNSTR(' ldrvs        : Installierte Treiber auflisten');
 WRITELNSTR(' ldisks       : Installierte Laufwerke auflisten');
 WRITELNSTR(' dumpsec      : Laufwerkssektor lesen');
 WRITELNSTR(' ltasks       : Alle Prozesse und Tasks auflisten');
 WRITELNSTR(' dir          : Verzeichnis anzeigen');
 WRITELNSTR(' cd           : Verzeichnis wechseln');
 WRITELNSTR(' md           : Verzeichnis erstellen');
 WRITELNSTR(' rd           : Verzeichnis lschen');
 WRITELNSTR('Tasten :');
 WRITELNSTR(' [PAUSE]      : System abbrupt beenden');
 NEW(DESK,INIT(RGB_BLUE));
 NEW(NORMALAREA,INIT(DESK,NIL,0,0,GRAPH.HEIGHT-25,GRAPH.WIDTH,TRUE));
 NEW(B_END,INIT(DESK,NIL,GRAPH.WIDTH-100,GRAPH.HEIGHT-25,25,100,TRUE,'Shutdown',NIL,FON_STANDARD,12));
 B_END^.ONCLICKP:=@S_END;
 NEW(I,INIT(DESK,NIL,0,GRAPH.HEIGHT-25,25,GRAPH.WIDTH-100,TRUE,FON_STANDARD,12));
 NEW(M,INIT(NORMALAREA,0,0,GRAPH.HEIGHT-25,GRAPH.WIDTH,TRUE)); 
 I^.ONRETURNP:=@EXECCMD;
 I^.FOCUS;
 DESK^.REDRAW;
 STDUSER:=CREATEUSER();
 SETROOTFLAG(STDUSER);
 CREATEDIRHAND(DIRHAND,'',STDUSER);
 WRITELNSTR('Dirhandle : '+HEXSTR(DWORD(DIRHAND)));
END.
