PROGRAM FS;
USES USER,MEMORY;
{$I ..\INCLUDE\FS.DEF}
{ Das LOCK in DIRHAND wird gar nicht benutzt...sollte aber ! }
CONST MAXFILENAMELEN=1023;
CONST FS2_CREATEDIRP=0;
      FS2_DESTROYDIRP=1;
      FS2_FINDFIRSTP=2;
      FS2_FINDNEXTP=3;
      FS2_NAMEEXISTSP=4;
      FS2_CHECKNAMEP=5;
      FS2_RELEASEPP=6;
TYPE FS2_CREATEDIR=FUNCTION(BAS:POINTER;NAME:PCHAR;RI,WI,AI:DWORD):DWORD;
TYPE FS2_DESTROYDIR=FUNCTION(P:POINTER):DWORD;
TYPE FS2_FINDFIRST=FUNCTION(VAR P:POINTER;BUF:PCHAR;VAR CLASS:DWORD):DWORD;
TYPE FS2_FINDNEXT=FUNCTION(VAR P:POINTER;BUF:PCHAR;VAR CLASS:DWORD):DWORD;
TYPE FS2_NAMEEXISTS=FUNCTION(P:POINTER;NAME:PCHAR;VAR CLASS:DWORD;VAR DATA,CALL:POINTER;VAR RI,WI,AI:DWORD):DWORD;
TYPE FS2_CHECKNAME=FUNCTION(NAME:PCHAR):DWORD;
TYPE FS2_RELEASEP=PROCEDURE(DATA:POINTER);
TYPE PDIRNODE=^TDIRNODE;
     PFILENODE=^TFILENODE;
     TDIRNODE=RECORD
      NEXT,LAST,FATHER,CHILD:PDIRNODE;
      FILES:PFILENODE;
      RI,WI,AI:DWORD;
      NAME:PCHAR;
      USERS:DWORD;
      LOCK:TLOCK;
      PTYP:DWORD;
      DATA:POINTER;
      CALL:PPOINTERARRAY;
     END;
     PDIRHAND=^TDIRHAND;
     TDIRHAND=RECORD
      LOCK:TLOCK;
      ANODE:PDIRNODE;
      { Search-Part }
      BAS:PDIRNODE;
      POS:POINTER;
      PLOCK:TLOCK;
      SUBHAND:PDIRHAND; { Nur eine Verschachtelung...fr Find* }
     END;
     TFILENODE=RECORD
      NEXT,LAST:PFILENODE;
      FATHER:PDIRNODE;
      RI,WI,AI:DWORD;
      USERS:DWORD;
      NAME:PCHAR;
      PTYP:DWORD;
      DATA:POINTER;
      CALL:PPOINTERARRAY;
     END;
     PFILEHAND=^TFILEHAND;
     TFILEHAND=RECORD
      FILENODE:PFILENODE;
      PTYP:DWORD;
      DATA:POINTER;
      CALL:PPOINTERARRAY;
     END;
VAR ROOTNODE:PDIRNODE;
    ROOTNODES:DWORD;
{ Vorsicht...Lock vorrausgesetzt }
FUNCTION TEST_NAME(BAS:PDIRNODE;NAME:PCHAR):LONGBOOL;
BEGIN
 BAS:=BAS^.CHILD;
 WHILE (BAS<>NIL) DO
 BEGIN
  IF BAS^.NAME=NAME THEN
  BEGIN
   TEST_NAME:=TRUE;
   EXIT;
  END;
 END;
 TEST_NAME:=FALSE;
END;
{ Hilfsfunktion, nur Intern verwenden ! }
{ Erstellt ein DIRNODE-Eintrag ! }
FUNCTION CR_FILENODE(BAS:PDIRNODE;VAR R:PFILENODE;NAME:PCHAR;RI,WI,AI,PTYP:DWORD;DATA,CALL:POINTER):DWORD;
VAR LEN:DWORD;
    P:PFILENODE;
BEGIN
 NEW(P); {SPP}
 LEN:=LENGTH(NAME);
 GETMEM(P^.NAME,LEN+1);
 MOVE(NAME^,P^.NAME^,LEN+1);
 P^.RI:=RI;
 P^.WI:=WI;
 P^.AI:=AI;
 P^.PTYP:=PTYP;
 P^.DATA:=DATA;
 P^.CALL:=CALL;
 P^.LAST:=NIL;
 P^.USERS:=0;
 P^.FATHER:=BAS;
 P^.NEXT:=BAS^.FILES;
 IF P^.NEXT<>NIL THEN P^.NEXT^.LAST:=P;
 BAS^.FILES:=P;
 R:=P;
 CR_FILENODE:=FS_SUCCESSFULL;
END;
FUNCTION CR_DIRNODE(VAR BAS:PDIRNODE;NAME:PCHAR;RI,WI,AI,PTYP:DWORD;DATA,CALL:POINTER):DWORD;
VAR LEN:DWORD;
    P:PDIRNODE;
BEGIN
 NEW(P); { SPP }
 LEN:=LENGTH(NAME);
 GETMEM(P^.NAME,LEN+1); { SPP }
 MOVE(NAME^,P^.NAME^,LEN+1);
 P^.RI:=RI;
 P^.WI:=WI;
 P^.AI:=AI;
 P^.PTYP:=PTYP;
 P^.DATA:=DATA;
 P^.CALL:=CALL;
 P^.LAST:=NIL;
 P^.CHILD:=NIL;
 P^.FILES:=NIL;
 P^.FATHER:=BAS;
 P^.USERS:=0;
 RESETATOM(@P^.LOCK);
 IF BAS=NIL THEN P^.NEXT:=NIL ELSE
 BEGIN
  P^.NEXT:=BAS^.CHILD;
  IF P^.NEXT<>NIL THEN P^.NEXT^.LAST:=P;
  BAS^.CHILD:=P;
 END;
 BAS:=P;
 CR_DIRNODE:=FS_SUCCESSFULL;
END;
FUNCTION COPYFILENMAX(VAR C1:PCHAR;C2:PCHAR):DWORD;
VAR LEN:DWORD;
BEGIN
 { Kopiere solange, bis zum nchsten Trennzeichen oder bis zum Ende }
 { Ein Trennzeichen ist hier / ! }
 IF C1^=#0 THEN
 BEGIN
  C2^:=#0;
  COPYFILENMAX:=1;
  EXIT;
 END;
 COPYFILENMAX:=1;
 LEN:=MAXFILENAMELEN;
 WHILE (LEN>0) DO
 BEGIN
  IF C1^='/' THEN
  BEGIN
   INC(C1);   
   COPYFILENMAX:=0;
   BREAK;
  END;
  C2^:=C1^;
  INC(C1);
  INC(C2);
  IF C1^=#0 THEN BREAK;
 END;
 C2^:=#0;
END;
FUNCTION ENTER_DIRNODE(BAS:PDIRHAND;NAME:PCHAR;ZUSER:POINTER):DWORD;
VAR NODE,P:PDIRNODE;
    CLASS:DWORD;
    DATA,CALL:PPOINTERARRAY;
    RI,WI,AI:DWORD;
BEGIN
 NODE:=BAS^.ANODE;
 P:=NODE^.CHILD;
 WHILE P<>NIL DO
 BEGIN
  IF COMPARE(NAME,P^.NAME) THEN
  BEGIN
   IF CHECKUSERID(ZUSER,P^.RI) THEN
   BEGIN
    INC(P^.USERS);
    BAS^.ANODE:=P;
    ENTER_DIRNODE:=FS_SUCCESSFULL;
   END ELSE ENTER_DIRNODE:=FS_NOPERM;
   EXIT;
  END;
  P:=P^.NEXT;
 END;
 GETLOCK(@NODE^.LOCK);
 IF FS2_NAMEEXISTS(NODE^.CALL^[FS2_NAMEEXISTSP])(NODE^.DATA,NAME,CLASS,DATA,CALL,RI,WI,AI)=0 THEN
 BEGIN
  IF (CLASS AND 2<>0) THEN
  BEGIN
   ENTER_DIRNODE:=CR_DIRNODE(NODE,NAME,RI,WI,AI,2,DATA,CALL);
   BAS^.ANODE:=NODE;
   INC(NODE^.USERS);
  END
  ELSE
  BEGIN
   FS2_RELEASEP(CALL^[FS2_RELEASEPP])(DATA);
   ENTER_DIRNODE:=FS_NODIRECTORY;
  END;
 END ELSE ENTER_DIRNODE:=FS_NOTPRESENT;
 FREELOCK(@NODE^.LOCK);
END;
FUNCTION LEAVE_DIRNODE(HND:PDIRHAND):DWORD;
VAR F,P:PDIRNODE;
BEGIN
 P:=HND^.ANODE;
 F:=P^.FATHER;
 IF F<>NIL THEN
 BEGIN
  GETLOCK(@F^.LOCK);
  DEC(P^.USERS);
  IF P^.USERS=0 THEN
  BEGIN
   IF P^.LAST<>NIL THEN P^.LAST^.NEXT:=P^.NEXT ELSE F^.CHILD:=P^.NEXT;
   IF P^.NEXT<>NIL THEN P^.NEXT^.LAST:=P^.LAST;
   FS2_RELEASEP(P^.CALL^[FS2_RELEASEPP])(P^.DATA);
   FREEMEM(P^.NAME,LENGTH(P^.NAME)+1);
   DISPOSE(P);
  END;
  HND^.ANODE:=F;
  LEAVE_DIRNODE:=FS_SUCCESSFULL;
  FREELOCK(@F^.LOCK);
 END ELSE LEAVE_DIRNODE:=FS_ROOTDIR;
END;
PROCEDURE GOTOROOT_DIRNODE(HND:PDIRHAND);
BEGIN
 WHILE HND^.ANODE^.FATHER<>NIL DO LEAVE_DIRNODE(HND);
END;
FUNCTION CR_DIRHAND(VAR HAND:PDIRHAND):DWORD;
BEGIN
 IF ROOTNODE=NIL THEN
 BEGIN
  CR_DIRHAND:=FS_NOROOTDIR;
  EXIT;
 END;
 NEW(HAND);
 RESETATOM(@HAND^.LOCK);
 RESETATOM(@HAND^.PLOCK);
 INC(ROOTNODE^.USERS);
 HAND^.ANODE:=ROOTNODE;
 CR_DIRHAND:=FS_SUCCESSFULL;
END;
PROCEDURE DESTROYDIRHAND(VAR HAND:PDIRHAND);
VAR P,F:PDIRNODE;
BEGIN
 GOTOROOT_DIRNODE(HAND);
 DISPOSE(HAND);
END;
FUNCTION COPYDIRHAND(HAND1:PDIRHAND;VAR HAND2:PDIRHAND):DWORD;
VAR P:PDIRNODE;
BEGIN
 NEW(HAND2); {SSP}
 HAND2^:=HAND1^;
 P:=HAND1^.ANODE;
 WHILE P<>NIL DO
 BEGIN
  INC(P^.USERS);
  P:=P^.FATHER;
 END;
 COPYDIRHAND:=FS_SUCCESSFULL;
END;
{ Diese Funktion bereitet einen Zugriff vor, damit sich nicht jede
  Prozedur um alles kmmern mup :) }
{ Der Rckgabewert ist ein gltiges Verzeichnishandle
  und in FN steht nur noch ein simpler Dateiname...damit wird das
  ganze zum Klacks }
FUNCTION PREPAREFN(VAR HND:PDIRHAND;FN,ZN:PCHAR;ZUSER:POINTER):DWORD;
BEGIN
 IF HND<>NIL THEN PREPAREFN:=COPYDIRHAND(HND,HND) ELSE PREPAREFN:=CR_DIRHAND(HND);
 IF PREPAREFN<>0 THEN EXIT;
 WHILE COPYFILENMAX(FN,ZN)=0 DO
 BEGIN
  IF ZN<>'.' THEN
  BEGIN
   IF ZN='' THEN GOTOROOT_DIRNODE(HND) ELSE
   IF ZN='..' THEN PREPAREFN:=LEAVE_DIRNODE(HND) ELSE
    PREPAREFN:=ENTER_DIRNODE(HND,ZN,ZUSER);
  END;
  IF PREPAREFN<>0 THEN
  BEGIN
   DESTROYDIRHAND(HND);
   EXIT;
  END;
 END;
 PREPAREFN:=FS_SUCCESSFULL;
END;
FUNCTION PREPAREDIR(VAR HND:PDIRHAND;FN,ZN:PCHAR;ZUSER:POINTER):DWORD;
BEGIN
 PREPAREDIR:=PREPAREFN(HND,FN,ZN,ZUSER);
 IF PREPAREDIR=0 THEN
 BEGIN
  IF (ZN<>'') AND (ZN<>'.') THEN
  BEGIN   
   IF ZN='..' THEN PREPAREDIR:=LEAVE_DIRNODE(HND) ELSE
    PREPAREDIR:=ENTER_DIRNODE(HND,ZN,ZUSER);
  END;
  IF PREPAREDIR<>0 THEN DESTROYDIRHAND(HND);
 END;
END;
FUNCTION CREATEDIRHAND(VAR HAND:PDIRHAND;PATH:PCHAR;ZUSER:POINTER):DWORD;
VAR BUFFER:ARRAY[0..MAXFILENAMELEN] OF BYTE;
BEGIN
 HAND:=NIL;
 CREATEDIRHAND:=PREPAREDIR(HAND,PATH,@BUFFER,ZUSER);
END;
FUNCTION SETROOTFS(DATA,CALL:POINTER):LONGBOOL;
VAR P:PDIRNODE;
BEGIN
 SETROOTFS:=TRYTOSETDWORD(@ROOTNODES);
 IF SETROOTFS THEN
 BEGIN
  P:=NIL;
  CR_DIRNODE(P,'',0,0,0,2,DATA,CALL); { Kein Nutzer zugeordnet ! }
  ROOTNODE:=P;
 END;
END;
FUNCTION CREATEDIR(HND:PDIRHAND;FN:PCHAR;RI,WI,AI:DWORD;ZUSER:POINTER):DWORD;
VAR BUFFER:ARRAY[0..MAXFILENAMELEN] OF CHAR;
    PC:PCHAR;
    NODE:PDIRNODE;
    CLASS:DWORD;
    DATA,CALL:POINTER;
BEGIN
 PC:=@BUFFER;
 CREATEDIR:=PREPAREFN(HND,FN,PC,ZUSER);
 IF CREATEDIR=0 THEN
 BEGIN
  NODE:=HND^.ANODE;
  CREATEDIR:=FS2_CHECKNAME(NODE^.CALL^[FS2_CHECKNAMEP])(PC);
  IF CREATEDIR=0 THEN
  BEGIN
   IF CHECKUSERID(ZUSER,NODE^.AI) THEN
   BEGIN
    GETLOCK(@NODE^.LOCK);
    IF (FS2_NAMEEXISTS(NODE^.CALL^[FS2_NAMEEXISTSP])(NODE^.DATA,PC,CLASS,DATA,CALL,CLASS,CLASS,CLASS)<>0) THEN
    BEGIN
     CREATEDIR:=FS2_CREATEDIR(NODE^.CALL^[FS2_CREATEDIRP])(NODE^.DATA,PC,RI,WI,AI);     
    END
    ELSE
    BEGIN
     FS2_RELEASEP(NODE^.CALL^[FS2_RELEASEPP])(NODE^.DATA);
     CREATEDIR:=FS_PRESENT;
    END;
    FREELOCK(@NODE^.LOCK);
   END ELSE CREATEDIR:=FS_NOPERM;
  END;
  DESTROYDIRHAND(HND);
 END;
END;
FUNCTION DESTROYDIR(HND:PDIRHAND;FN:PCHAR;ZUSER:POINTER):DWORD;
VAR BUFFER:ARRAY[0..MAXFILENAMELEN] OF CHAR;
    PC:PCHAR;
    NODE:PDIRNODE;
    CLASS:DWORD;
    DATA,CALL:PPOINTERARRAY;
    RI,WI,AI:DWORD;
BEGIN
 PC:=@BUFFER;
 DESTROYDIR:=PREPAREFN(HND,FN,PC,ZUSER);
 IF DESTROYDIR=0 THEN
 BEGIN
  NODE:=HND^.ANODE;
  IF CHECKUSERID(ZUSER,NODE^.WI) THEN
  BEGIN
   GETLOCK(@NODE^.LOCK);
   IF NOT TEST_NAME(NODE,PC) THEN
   BEGIN
    IF (FS2_NAMEEXISTS(NODE^.CALL^[FS2_NAMEEXISTSP])(NODE^.DATA,PC,CLASS,DATA,CALL,RI,WI,AI)=0) THEN
    BEGIN
     IF (CLASS AND 2)<>0 THEN DESTROYDIR:=FS2_DESTROYDIR(CALL^[FS2_DESTROYDIRP])(DATA) ELSE
     BEGIN
      DESTROYDIR:=FS_NODIRECTORY;
     END;
     FS2_RELEASEP(CALL^[FS2_RELEASEPP])(DATA);
    END ELSE DESTROYDIR:=FS_NOTPRESENT;
   END ELSE DESTROYDIR:=FS_USED;
   FREELOCK(@NODE^.LOCK);
  END ELSE DESTROYDIR:=FS_NOPERM;
  DESTROYDIRHAND(HND);
 END;
END;
FUNCTION NAMEEXISTS(HND:PDIRHAND;FN:PCHAR;ZUSER:POINTER):DWORD;
VAR BUFFER:ARRAY[0..MAXFILENAMELEN] OF CHAR;
    PC:PCHAR;
    NODE:PDIRNODE;
    CLASS:DWORD;
    DATA,CALL:PPOINTERARRAY;
BEGIN
 PC:=@BUFFER;
 NAMEEXISTS:=PREPAREFN(HND,FN,PC,ZUSER);
 IF NAMEEXISTS=0 THEN
 BEGIN
  NODE:=HND^.ANODE;
  NAMEEXISTS:=FS2_NAMEEXISTS(NODE^.CALL^[FS2_NAMEEXISTSP])(NODE^.DATA,PC,CLASS,DATA,CALL,CLASS,CLASS,CLASS);
  FS2_RELEASEP(CALL^[FS2_RELEASEPP])(DATA);
  DESTROYDIRHAND(HND);
 END;
END;
FUNCTION FINDFIRST(HND:PDIRHAND;DIR:PCHAR;ZUSER:POINTER;BUF:PCHAR;VAR CLASS:DWORD):DWORD;
VAR BUFFER:ARRAY[0..MAXFILENAMELEN] OF CHAR;
    PC:PCHAR;
    NODE:PDIRNODE;
    HND2:PDIRHAND;
BEGIN
 PC:=@BUFFER;
 GETLOCK(@HND^.PLOCK);
 HND2:=HND;
 FINDFIRST:=PREPAREDIR(HND2,DIR,PC,ZUSER);
 HND^.SUBHAND:=HND2;
 HND^.BAS:=HND2^.ANODE;
 HND^.POS:=HND2^.ANODE^.DATA;
 IF FINDFIRST=0 THEN
 BEGIN
  FINDFIRST:=FS2_FINDFIRST(HND^.BAS^.CALL^[2])(HND^.POS,BUF,CLASS);
 END;
END;
FUNCTION FINDNEXT(HND:PDIRHAND;BUF:PCHAR;VAR CLASS:DWORD):DWORD;
BEGIN
 FINDNEXT:=FS2_FINDNEXT(HND^.BAS^.CALL^[3])(HND^.POS,BUF,CLASS);
END;
FUNCTION FINDCLOSE(HND:PDIRHAND):DWORD;
BEGIN
 FS2_RELEASEP(HND^.BAS^.CALL^[FS2_RELEASEPP])(HND^.POS);
 DESTROYDIRHAND(HND^.SUBHAND);
 FREELOCK(@HND^.PLOCK);
END;
FUNCTION CHANGEDIR(HND:PDIRHAND;DIR:PCHAR;ZUSER:POINTER):DWORD;
VAR BUFFER:ARRAY[0..MAXFILENAMELEN] OF CHAR;
    ZN:PCHAR;
VAR RL:DWORD;
BEGIN
 ZN:=@BUFFER;
 CHANGEDIR:=FS_SUCCESSFULL;
 WHILE COPYFILENMAX(DIR,ZN)=0 DO
 BEGIN
  IF ZN<>'.' THEN
  BEGIN
   IF ZN='' THEN GOTOROOT_DIRNODE(HND) ELSE
   IF ZN='..' THEN
   BEGIN
    CHANGEDIR:=LEAVE_DIRNODE(HND);
   END ELSE CHANGEDIR:=ENTER_DIRNODE(HND,ZN,ZUSER);
  END;
  IF CHANGEDIR<>0 THEN
  BEGIN
   DESTROYDIRHAND(HND);
   EXIT;
  END;
 END;
 IF CHANGEDIR=0 THEN
 BEGIN
  IF (ZN<>'') AND (ZN<>'.') THEN
  BEGIN   
   IF ZN='..' THEN
   BEGIN
    CHANGEDIR:=LEAVE_DIRNODE(HND);
   END ELSE
    CHANGEDIR:=ENTER_DIRNODE(HND,ZN,ZUSER);
  END;
 END;
END;
FUNCTION OPENFILE(HND:PDIRHAND;VAR FHND:PFILEHAND;FN:PCHAR;OTYP:DWORD;ZUSER:POINTER):DWORD;
VAR NODE:PDIRNODE;
    BUFFER:ARRAY[0..MAXFILENAMELEN] OF CHAR;
    PC:PCHAR;
    DATA,CALL:PPOINTERARRAY;
    CLASS:DWORD;
    RI,WI,AI:DWORD;
BEGIN
 IF OTYP>3 THEN
 BEGIN
  OPENFILE:=FS_ILLEGALPARAM;
  EXIT;
 END;
 PC:=@BUFFER;
 OPENFILE:=PREPAREFN(HND,FN,PC,ZUSER);
 IF OPENFILE<>0 THEN EXIT;
 NODE:=HND^.ANODE;
 GETLOCK(@NODE^.LOCK);
 { Es besteht kein Zwang, da die Datei vorhanden sein mu ! }
 { Eine Routine einschieben, die bei bedarf eine Datei erstellt ! }
 { Es gibt hier ein Problem : Schreibrechte/Appendrechte im Verzeichnis !!! }
 IF FS2_NAMEEXISTS(NODE^.CALL^[FS2_NAMEEXISTSP])(NODE^.DATA,PC,CLASS,DATA,CALL,RI,WI,AI)=0 THEN
 BEGIN
  IF (CLASS AND 1<>0) THEN
  BEGIN
   
  END ELSE OPENFILE:=FS_NOFILE;
  FS2_RELEASEP(CALL^[FS2_RELEASEPP])(DATA);
 END
 ELSE
 BEGIN
   { Hier kann ne Datei erstelt werden wenn :
      NODE^.AI ok ist
      OTYP=1,2,3 : Schreiben/Schreiben+Lesen/Append ist
   }
  IF OTYP=0 THEN OPENFILE:=FS_NOTPRESENT ELSE
  BEGIN
   IF CHECKUSERID(ZUSER,NODE^.AI) THEN
   BEGIN
    WRITELNSTR('An ner Stelle wo ne Datei erstellt werden wrde...');
   END ELSE OPENFILE:=FS_NOPERM;
  END;
 END;
 WRITELNSTR('Open-File called');
 FREELOCK(@NODE^.LOCK);
 DESTROYDIRHAND(HND);
END;
FUNCTION CLOSEFILE(VAR FHND:PFILEHAND):DWORD;
BEGIN
 DISPOSE(FHND);
 WRITELNSTR('Close-File called');
 CLOSEFILE:=FS_SUCCESSFULL;
END;
CONST FS_PROT2:ARRAY[0..0] OF POINTER=(
       @SETROOTFS);
CONST FS_PROT1:ARRAY[0..11] OF POINTER=(
       @CREATEDIRHAND,
       @DESTROYDIRHAND,
       @COPYDIRHAND,
       @CREATEDIR,
       @DESTROYDIR,
       @NAMEEXISTS,
       @FINDFIRST,
       @FINDNEXT,
       @FINDCLOSE,
       @CHANGEDIR,
       @OPENFILE,
       @CLOSEFILE);
VAR FS_USERS:DWORD;
    SHUTDOWNTASK:POINTER;
    SHUTDOWNMODE:LONGBOOL;
PROCEDURE UNINSTALLFSDRV;
BEGIN
 SHUTDOWNTASK:=GETTASKHANDLE();
 SHUTDOWNMODE:=TRUE;
 IF FS_USERS<>0 THEN DISABLETASK(SHUTDOWNTASK);
 SIGNALSHUTDOWNOK;
 HALT;
END;
PROCEDURE FREEFSPROT(NR:DWORD);
BEGIN
 CASE NR OF
  1,2:
  BEGIN
   DECATOM(@FS_USERS);
   IF SHUTDOWNMODE AND (FS_USERS=0) THEN ENABLETASK(SHUTDOWNTASK);
  END;
 END;
END;
CONST FS_PROT0:ARRAY[0..1] OF POINTER=(
       @UNINSTALLFSDRV,
       @FREEFSPROT);
FUNCTION DOCK_FS(NR:DWORD):POINTER;
BEGIN
 CASE NR OF
  0:DOCK_FS:=@FS_PROT0;
  1:
  BEGIN
   INCATOM(@FS_USERS);
   DOCK_FS:=@FS_PROT1;
  END;
  2:
  BEGIN
   INCATOM(@FS_USERS);
   DOCK_FS:=@FS_PROT2;
  END;
  ELSE DOCK_FS:=NIL;
 END;
END;
CONST FSDRV:TDRIVER=(NEXT:NIL;LAST:NIL;TYP:$14;ID:0;GETPROT:@DOCK_FS;
                     DESC:'File system driver');
BEGIN
 STARTDRIVERINITIALIZATION;
 ADDDRIVER(@FSDRV);
 STOPDRIVERINITIALIZATION;
END.
