PROGRAM IDLE;
{$ASMMODE INTEL}
USES IRQS,TIMER,KEYB;
VAR IDLETASK:POINTER;
PROCEDURE DEINITIALIZEIDLEDRV;
BEGIN
 WRITELNSTR('IDLE UNI.');
 DESTROYTASK(IDLETASK,NIL);
 WRITELNSTR('IDLE DONE.');
 SIGNALSHUTDOWNOK;
 HALT;
END;
PROCEDURE FREEIDLEPROT(NR:DWORD);
BEGIN
END;
CONST IDLE_PROT0:ARRAY[0..1] OF POINTER=(
       @DEINITIALIZEIDLEDRV,
       @FREEIDLEPROT);
FUNCTION DOCK_IDLE(NR:DWORD):POINTER;
BEGIN
 CASE NR OF
  0:DOCK_IDLE:=@IDLE_PROT0;
  ELSE DOCK_IDLE:=NIL;
 END;
END;
CONST IDLEDRV:TDRIVER=(NEXT:NIL;LAST:NIL;TYP:0;ID:0;GETPROT:@DOCK_IDLE;
                       DESC:'[]Idle');
PROCEDURE IDLEPROC;
BEGIN
 ASM
   STI
 END;
 REPEAT
  SCHEDULE;
 UNTIL FALSE;
END;
VAR I:DWORD;
BEGIN
 STARTDRIVERINITIALIZATION;
 IDLETASK:=CREATETASK(GETSYSTEMPROCESS(),@IDLEPROC,0,'Idle');
 ADDDRIVER(@IDLEDRV); 
 STOPDRIVERINITIALIZATION;
END.
