UNIT TEXT;
INTERFACE
VAR SHOW:PROCEDURE;
    FILL:PROCEDURE(C:CHAR;A:BYTE);
    PUTCHAR:PROCEDURE(X,Y:LONGINT;C:CHAR;A:BYTE);
    PUTSTRING:PROCEDURE(X,Y:LONGINT;S:STRING;A:BYTE);
    CLEARLINE:PROCEDURE(Y:LONGINT;C:CHAR;A:BYTE);
    SETCURSOR:PROCEDURE(X,Y:LONGINT);
FUNCTION INITMODE(HEIGHT,WIDTH:DWORD):BOOLEAN;
IMPLEMENTATION
VAR GETMODEINFO:PROCEDURE(MODE:DWORD;VAR HEIGHT,WIDTH:DWORD);
    TXT_INIT:FUNCTION(MODE:DWORD):POINTER;
    TXT_DONE:PROCEDURE;
    TXT_DRV:PDRIVER;
FUNCTION INITMODE(HEIGHT,WIDTH:DWORD):BOOLEAN;
VAR I:DWORD;
    H,B:DWORD;
    P:PPOINTERARRAY;
BEGIN
 I:=0;
 REPEAT
  GETMODEINFO(I,H,B);
  IF (H=HEIGHT) AND (B=WIDTH) THEN
  BEGIN
   P:=TXT_INIT(I);
   POINTER(SHOW):=P^[0];
   POINTER(FILL):=P^[1];
   POINTER(PUTCHAR):=P^[2];
   POINTER(PUTSTRING):=P^[3];
   POINTER(CLEARLINE):=P^[4];
   POINTER(SETCURSOR):=P^[5];
   INITMODE:=TRUE;
   EXIT;
  END;
  INC(I);
 UNTIL (H=0);
 INITMODE:=FALSE;
END;
PROCEDURE INITTEXT;
VAR P:PPOINTERARRAY;
BEGIN
 P:=WAITFORADRIVER(7,1,TXT_DRV);
 IF P=NIL THEN HALT('Protocol(1) for GRAPH not supported.');
 POINTER(GETMODEINFO):=P^[0];
 POINTER(TXT_INIT):=P^[1];
 POINTER(TXT_DONE):=P^[2];
END;
INITIALIZATION
 INITTEXT;
FINALIZATION
 SIGNALEXIT(TXT_DRV,1);
END.
