PROGRAM PICSERV;
USES GRAPH,FONTS;
{$I MOUSEP.INC}
{$I STDFON.INC}
CONST PICSERV_PROT1:ARRAY[0..0] OF POINTER=(
       @GETMOUSEPICTURE);
VAR PICSERVUSERS:DWORD;
    SHUTDOWNTASK:POINTER;
    SHUTDOWNMODE:BOOLEAN;
PROCEDURE DEINITIALIZEPICSERVDRV;
BEGIN
 SHUTDOWNTASK:=GETTASKHANDLE();
 SHUTDOWNMODE:=TRUE;
 IF PICSERVUSERS<>0 THEN DISABLETASK(SHUTDOWNTASK);
 WRITELNSTR('PICSERV DONE.');
 SIGNALSHUTDOWNOK;
 HALT;
END;
PROCEDURE FREEPICSERVPROT(NR:DWORD);
BEGIN
 CASE NR OF
  1:
  BEGIN
   DECATOM(@PICSERVUSERS);
   IF (SHUTDOWNMODE) AND (PICSERVUSERS=0) THEN ENABLETASK(SHUTDOWNTASK);
  END;
 END;
END;
CONST PICSERV_PROT0:ARRAY[0..1] OF POINTER=(
       @DEINITIALIZEPICSERVDRV,
       @FREEPICSERVPROT);
FUNCTION DOCK_PICSERV(NR:DWORD):POINTER;
BEGIN
 CASE NR OF
  0:DOCK_PICSERV:=@PICSERV_PROT0;
  1:
  BEGIN
   INCATOM(@PICSERVUSERS);
   DOCK_PICSERV:=@PICSERV_PROT1;
  END;
  ELSE DOCK_PICSERV:=NIL;
 END;
END;
CONST PICSERVDRV:TDRIVER=(NEXT:NIL;LAST:NIL;TYP:$E;ID:0;GETPROT:@DOCK_PICSERV;
                          DESC:'Picture server (1)');
BEGIN
 STARTDRIVERINITIALIZATION;
 ADDFONT(@RSTDFON);
 ADDDRIVER(@PICSERVDRV);
 STOPDRIVERINITIALIZATION;
END.
