PROGRAM USER;
USES MEMORY;
TYPE PUSERID=^TUSERID;
     TUSERID=RECORD
      NEXT,LAST:PUSERID;
      ID:DWORD;
     END;
TYPE PUSER=^TUSER;
     TUSER=RECORD
      ROOT:LONGBOOL;
      FIRSTID:PUSERID;
     END;
FUNCTION CREATEUSER:PUSER;
BEGIN
 NEW(CREATEUSER);
 CREATEUSER^.ROOT:=FALSE;
 CREATEUSER^.FIRSTID:=NIL;
END;
PROCEDURE DESTROYUSER(P:PUSER);
VAR I,I2:PUSERID;
BEGIN
 I:=P^.FIRSTID;
 WHILE I<>NIL DO
 BEGIN
  I2:=I^.NEXT;
  DISPOSE(I);
  I:=I2;
 END;
 DISPOSE(P);
END;
PROCEDURE SETROOTFLAG(P:PUSER);
BEGIN
 P^.ROOT:=TRUE;
END;
FUNCTION CHECKUSERID(P:PUSER;ID:DWORD):LONGBOOL;
VAR I:PUSERID;
BEGIN
 IF (P^.ROOT) OR (ID=0) THEN
 BEGIN
  CHECKUSERID:=TRUE;
  EXIT;
 END;
 I:=P^.FIRSTID;
 WHILE I<>NIL DO
 BEGIN
  IF I^.ID=ID THEN
  BEGIN
   CHECKUSERID:=TRUE;
   EXIT;
  END;
  I:=I^.NEXT;
 END;
 CHECKUSERID:=FALSE;
END;
CONST USER_PROT1:ARRAY[0..3] OF POINTER=(
       @CREATEUSER,
       @DESTROYUSER,
       @SETROOTFLAG,
       @CHECKUSERID);
VAR SHUTDOWNMODE:BOOLEAN;
    SHUTDOWNTASK:POINTER;
    USER_USERS:DWORD;
PROCEDURE DEINITIALIZEUSERDRV;
BEGIN
 SHUTDOWNTASK:=GETTASKHANDLE();
 SHUTDOWNMODE:=TRUE;
 IF USER_USERS<>0 THEN DISABLETASK(SHUTDOWNTASK);
 SIGNALSHUTDOWNOK;
 HALT;
END;
PROCEDURE FREEUSERPROT(NR:DWORD);
BEGIN
 CASE NR OF
  1:
  BEGIN
   DECATOM(@USER_USERS);
   IF SHUTDOWNMODE AND (USER_USERS=0) THEN ENABLETASK(SHUTDOWNTASK);
  END;
 END;
END;
CONST USER_PROT0:ARRAY[0..1] OF POINTER=(
       @DEINITIALIZEUSERDRV,
       @FREEUSERPROT);
FUNCTION DOCK_USER(NR:DWORD):POINTER;
BEGIN
 CASE NR OF
  0:DOCK_USER:=@USER_PROT0;
  1:
  BEGIN
   INCATOM(@USER_USERS);
   DOCK_USER:=@USER_PROT1;
  END;
  ELSE DOCK_USER:=NIL;
 END;
END;
CONST USERDRV:TDRIVER=(NEXT:NIL;LAST:NIL;TYP:$16;ID:0;GETPROT:@DOCK_USER;
                       DESC:'User manager (1)');
BEGIN
 STARTDRIVERINITIALIZATION;
 ADDDRIVER(@USERDRV);
 STOPDRIVERINITIALIZATION;
END.
