UNIT GRAPH;
{$ASMMODE INTEL}
INTERFACE
USES ALLBAS,GO32,DOS,MSMOUSE;
TYPE PPICTURE=^TPICTURE;
     TPICTURE=RECORD
      H,B:DWORD;
      P:ARRAY[0..9999999] OF DWORD;
     END;
TYPE TCHAR=RECORD
      H,B:DWORD;
      P:ARRAY[0..9999999] OF BYTE;
     END;
     PCHAR=^TCHAR;
TYPE TSCRWIN=RECORD
      ADDX,ADDY,SUBX,SUBY,MAXX,MAXY:DWORD;
      VIS:LONGBOOL;
     END;
TYPE PCHARARR=ARRAY[0..9999999] OF PCHAR;
TYPE PFONT=^TFONT;
     TFONT=RECORD
      HEIGHT:DWORD;
      CHARS:DWORD;
      CHARTAB:^PCHARARR;
     END;
VAR MODES:^WORDARRAY;
    MODECOUNT,AKTMODE,OLDMODE,MEMORY:DWORD;
    ISVESA:BOOLEAN;
    MODEINFO:^TMODEINFO;
    CONV:FUNCTION(C:DWORD):DWORD;
    RCONV:FUNCTION(C:DWORD):DWORD;
    DIRECT_PUT:PROCEDURE(X,Y:LONGINT;C:DWORD);
    DIRECT_GET:FUNCTION(X,Y:LONGINT):DWORD;
    ABS_PUT:PROCEDURE(X,Y:LONGINT;C:DWORD);
    ABS_GET:FUNCTION(X,Y:LONGINT):DWORD;
    COPY:PROCEDURE(DUMMY:DWORD);
    BAR:PROCEDURE(X,Y:LONGINT;H,B,C:DWORD);
    FILL:PROCEDURE(C:DWORD);
    PUT:PROCEDURE(X,Y:LONGINT;C:DWORD);
    GET:FUNCTION(X,Y:LONGINT):DWORD;
    PUTPIC:PROCEDURE(X,Y:LONGINT;PIC:PPICTURE);
VAR MAININFO:^TMAININFO;
    MAININFOR:DWORD;
    WRSEG,RDSEG,RDWIN,WRWIN:WORD;
    WRSEGL:DWORD;
    OLDBANK:DWORD;
    REDPOS,GREENPOS,BLUEPOS,REDDIV,GREENDIV,BLUEDIV:DWORD;
    SETBANK:POINTER;
    WIDTH,HEIGHT,PIXELS:DWORD;
    BYTESPERPIXEL:DWORD;
    COLORD:BYTE;
PROCEDURE RECTANGLE(X,Y:LONGINT;H,B,CL:DWORD);
PROCEDURE AUTOSPECIFYMODE(B,H,P:WORD);
PROCEDURE SPECIFYMODE(MD:WORD);
FUNCTION AUTOSELECT(ST,WI,HE:WORD;CD:BYTE):DWORD;
PROCEDURE SELECTMODE(NR:WORD);
PROCEDURE INITMODE;
PROCEDURE CREATEABSWIN(X,Y:LONGINT;H,B:DWORD;VIS:BOOLEAN;VAR W:TSCRWIN);
PROCEDURE CREATESUBWIN(BAS:TSCRWIN;X,Y:LONGINT;H,B:DWORD;VIS:BOOLEAN;VAR W:TSCRWIN);
PROCEDURE SETWIN(W:TSCRWIN);
PROCEDURE DIRECT_PUTPIC(X,Y:LONGINT;P:PPICTURE);
PROCEDURE DIRECT_GETPIC(X,Y:LONGINT;P:PPICTURE);
PROCEDURE DIRECT_PUTPICSPZ(X,Y:LONGINT;P:PPICTURE);
PROCEDURE ABS_GETPIC(X,Y:LONGINT;P:PPICTURE);
PROCEDURE ABS_PUTPICSPZ(X,Y:LONGINT;P:PPICTURE);
PROCEDURE CONVDPIC(SOURCE,DEST:PPICTURE);
FUNCTION LOADFONT(FN:STRING):PFONT;
PROCEDURE PUTCHAR(X,Y:LONGINT;NUM,COL:DWORD;FONT:PFONT);
PROCEDURE PUTSTRING(X,Y:LONGINT;S:STRING;COL:DWORD;FONT:PFONT);
FUNCTION GETSTRINGWIDTH(S:STRING;FONT:PFONT):DWORD;
PROCEDURE CREATEPICTUREMD(VAR PIC:PPICTURE;H,B:DWORD);
PROCEDURE PICTUREMD_PUT(PIC:PPICTURE;X,Y:LONGINT;C:DWORD);
PROCEDURE FREEPICTUREMD(VAR PIC:PPICTURE);
PROCEDURE BAR3D(X,Y:LONGINT;H,B:DWORD);
PROCEDURE BARI3D(X,Y:LONGINT;H,B:DWORD);
PROCEDURE DRAWSPOINTERLEFT(X,Y:LONGINT;D,C:DWORD);
PROCEDURE DRAWSPOINTERRIGHT(X,Y:LONGINT;D,C:DWORD);
PROCEDURE DRAWSPOINTERDOWN(X,Y:LONGINT;D,C:DWORD);
PROCEDURE DRAWSPOINTERUP(X,Y:LONGINT;D,C:DWORD);
PROCEDURE PUTCHARINV(X,Y:LONGINT;NUM:DWORD;FONT:PFONT);
PROCEDURE PUTSTRINGINV(X,Y:LONGINT;S:STRING;FONT:PFONT);
PROCEDURE BARTRA(X,Y:LONGINT;H,B:DWORD;C:DWORD;F:EXTENDED);
PROCEDURE BARFTRA(X,Y:LONGINT;H,B:DWORD;C,F:DWORD);
PROCEDURE FRAMEI3D(X,Y:LONGINT;H,B:DWORD);
FUNCTION GETSTRINGCHARXPOS(S:STRING;X:LONGINT;FONT:PFONT):DWORD;
PROCEDURE LINE(X1,Y1,X2,Y2:LONGINT;C:DWORD);
FUNCTION CONVPIC(P:PPICTURE):PPICTURE;
FUNCTION GETMAXWIDTHSTR(VAR P:DWORD;S:STRING;B:DWORD;FONT:PFONT):STRING;
FUNCTION GETMAXWIDTHSTRLINES(S:STRING;B:DWORD;FONT:PFONT):DWORD;
PROCEDURE DRAWCROSS(X,Y:LONGINT;H,CL:DWORD);
PROCEDURE DRAWQRAUTE(X,Y:LONGINT;H,CL:DWORD);
PROCEDURE DRAWFQRAUTE(X,Y:LONGINT;H,CL,CL2:DWORD);
PROCEDURE DRAWFQI3DRAUTE(X,Y:LONGINT;H,CL2:DWORD);
PROCEDURE FRAMEC3D(X,Y:LONGINT;H,B:DWORD);
IMPLEMENTATION
VAR BUFFER:POINTER;
    ADDX,ADDY,SUBX,SUBY,MAXX,MAXY:DWORD;
    VIS:LONGBOOL;
PROCEDURE DRAWFQI3DRAUTE(X,Y:LONGINT;H,CL2:DWORD);
VAR X2,Y2:LONGINT;
    I:DWORD;
    NX1,NX2:LONGINT;
    B:LONGINT;
BEGIN
 IF H<2 THEN EXIT;
 X2:=X+H-1;
 H:=H SHR 1;
 Y2:=Y+H;
 FOR I:=0 TO H DO
 BEGIN
  NX1:=X+I;
  NX2:=X2-I;
  PUT(NX2,Y2-I,CL_LSILVER);
  PUT(NX1,Y2+I,CL_LSILVER);
  PUT(NX1,Y2-I,CL_GRAY);
  PUT(NX2,Y2+I,CL_WHITE);
  IF I<H THEN
  BEGIN
   PUT(NX2-1,Y2-I,CL_SILVER);
   PUT(NX1+1,Y2+I,CL_SILVER);
   PUT(NX1+1,Y2-I,CL_BLACK);
   PUT(NX2-1,Y2+I,CL_LSILVER);
  END;
  B:=NX2-NX1-3;
  IF B>0 THEN
  BEGIN
   BAR(NX1+2,Y2-I,1,B,CL2);
   BAR(NX1+2,Y2+I,1,B,CL2);
  END;
 END;
END;
PROCEDURE DRAWFQRAUTE(X,Y:LONGINT;H,CL,CL2:DWORD);
VAR X2,Y2:LONGINT;
    I:DWORD;
    NX1,NX2:LONGINT;
    B:LONGINT;
BEGIN
 IF H<2 THEN EXIT;
 X2:=X+H-1;
 H:=H SHR 1;
 Y2:=Y+H;
 FOR I:=0 TO H DO
 BEGIN
  NX1:=X+I;
  NX2:=X2-I;
  PUT(NX1,Y2-I,CL);
  PUT(NX2,Y2-I,CL);
  PUT(NX1,Y2+I,CL);
  PUT(NX2,Y2+I,CL);
  B:=NX2-NX1-1;
  IF B>0 THEN
  BEGIN
   BAR(NX1+1,Y2-I,1,B,CL2);
   BAR(NX1+1,Y2+I,1,B,CL2);
  END;
 END;
END;
PROCEDURE DRAWQRAUTE(X,Y:LONGINT;H,CL:DWORD);
VAR X2,Y2:LONGINT;
    I:DWORD;
BEGIN
 IF H<2 THEN EXIT;
 X2:=X+H-1;
 H:=H SHR 1;
 Y2:=Y+H;
 FOR I:=0 TO H DO
 BEGIN
  PUT(X+I,Y2-I,CL);
  PUT(X+I,Y2+I,CL);
  PUT(X2-I,Y2-I,CL);
  PUT(X2-I,Y2+I,CL);
 END;
END;
PROCEDURE DRAWCROSS(X,Y:LONGINT;H,CL:DWORD);
VAR I:DWORD;
    X2:LONGINT;
BEGIN
 X2:=X+H-1;
 FOR I:=0 TO H-1 DO
 BEGIN
  PUT(X+I,Y+I,CL);
  PUT(X2-I,Y+I,CL);
 END;
END;
FUNCTION GETMAXWIDTHSTRLINES(S:STRING;B:DWORD;FONT:PFONT):DWORD;
VAR LIN:STRING;
    P:DWORD;
BEGIN
 GETMAXWIDTHSTRLINES:=0;
 P:=1;
 REPEAT
  LIN:=GETMAXWIDTHSTR(P,S,B,FONT);
  IF LIN<>'' THEN INC(GETMAXWIDTHSTRLINES);
 UNTIL LIN='';
END;
FUNCTION GETMAXWIDTHSTR(VAR P:DWORD;S:STRING;B:DWORD;FONT:PFONT):STRING;
VAR LIN,ADD:STRING;
    N:DWORD;
BEGIN
 LIN:='';
 WHILE P<=LENGTH(S) DO
 BEGIN
  ADD:=READWORD(P,S);
  IF GETSTRINGWIDTH(LIN+ADD,FONT)>B THEN
  BEGIN
   IF LIN='' THEN
   BEGIN
    N:=0;
    WHILE (N<LENGTH(ADD)) AND (GETSTRINGWIDTH(LIN+ADD[N+1],FONT)<=B) DO
    BEGIN
     INC(N);
     LIN:=LIN+ADD[N];
    END;
    DEC(P,LENGTH(ADD)-N);
   END ELSE DEC(P,LENGTH(ADD));
   GETMAXWIDTHSTR:=LIN;
   EXIT;
  END ELSE LIN:=LIN+ADD;
  IF GETSTRINGWIDTH(LIN+' ',FONT)>B THEN
  BEGIN
   GETMAXWIDTHSTR:=LIN;
   EXIT;
  END;
  LIN:=LIN+' ';
 END;
 GETMAXWIDTHSTR:=LIN;
END;
FUNCTION CONVPIC(P:PPICTURE):PPICTURE;
VAR I,N:DWORD;
BEGIN
 CREATEPICTUREMD(CONVPIC,P^.H,P^.B);
 FOR I:=0 TO P^.H-1 DO
 BEGIN
  FOR N:=0 TO P^.B-1 DO
  BEGIN
   PICTUREMD_PUT(CONVPIC,N,I,P^.P[I*P^.B+N]);
  END;
 END;
END;
PROCEDURE RECTANGLE(X,Y:LONGINT;H,B,CL:DWORD);
BEGIN
 BAR(X,Y,1,B,CL);
 BAR(X,Y+1,H-2,1,CL);
 BAR(X+B-1,Y+1,H-2,1,CL);
 BAR(X,Y+H-1,1,B,CL);
END;
{ Es mu unbedingt Clipping hinzugefgt werden ! }
PROCEDURE LINE(X1,Y1,X2,Y2:LONGINT;C:DWORD);
VAR T:LONGINT;
    H,B:DWORD;
BEGIN
 IF X1>X2 THEN
 BEGIN
  T:=X1;
  X1:=X2;
  X2:=T;
  T:=Y1;
  Y1:=Y2;
  Y2:=T;
 END;
 B:=X2-X1+1;
 { Ist die Linie berhaupt sichtbar ? }
 IF (X2<0) OR (X1>LONGINT(MAXX)) THEN EXIT;
 IF Y1<Y2 THEN
 BEGIN
  H:=Y2-Y1+1;
  IF (Y2<=0) OR (Y1>LONGINT(MAXY)) THEN EXIT;
  IF H<B THEN
  BEGIN
   FOR T:=0 TO B-1 DO
   BEGIN
    PUT(X1+T,Y1+T*H DIV B,C);
   END;
  END
  ELSE
  BEGIN
   FOR T:=0 TO H-1 DO
   BEGIN
    PUT(X1+T*B DIV H,Y1+T,C);
   END;
  END;
 END
 ELSE
 BEGIN
  H:=Y1-Y2+1;
  IF (Y1<=0) OR (Y2>LONGINT(MAXY)) THEN EXIT;
  IF H<B THEN
  BEGIN
   FOR T:=0 TO B-1 DO
   BEGIN
    PUT(X1+T,Y1-T*H DIV B,C);
   END;
  END
  ELSE
  BEGIN
   FOR T:=0 TO H-1 DO
   BEGIN
    PUT(X1+T*B DIV H,Y1-T,C);
   END;
  END;
 END;
END;
{$I INC8.PAS}
{$I INC16.PAS}
{$I INC32.PAS}
FUNCTION GETSTRINGCHARXPOS(S:STRING;X:LONGINT;FONT:PFONT):DWORD;
VAR I:DWORD;
BEGIN
 IF X<=0 THEN
 BEGIN
  GETSTRINGCHARXPOS:=0;
  EXIT;
 END;
 FOR I:=1 TO LENGTH(S) DO
 BEGIN
  IF BYTE(S[I])<FONT^.CHARS THEN
  BEGIN
   DEC(X,FONT^.CHARTAB^[BYTE(S[I])]^.B);
   IF X<=0 THEN
   BEGIN
    GETSTRINGCHARXPOS:=I-1;
    EXIT;
   END;
  END;
 END;
 GETSTRINGCHARXPOS:=LENGTH(S)+1;
END;
PROCEDURE BARFTRA(X,Y:LONGINT;H,B:DWORD;C,F:DWORD);
VAR I,N:DWORD;
    F2:DWORD;
    CX1,CX2,CX3:DWORD;
BEGIN
 IF (H=0) OR (B=0) THEN EXIT;
 F2:=65536-F;
 C:=RCONV(C);
 CX1:=(C AND $FF)*F;
 CX2:=(C SHR 8 AND $FF)*F;
 CX3:=(C SHR 16 AND $FF)*F;
 FOR I:=0 TO H-1 DO
 BEGIN
  FOR N:=0 TO B-1 DO
  BEGIN
   C:=RCONV(GET(X+N,Y+I));
   C:=(((C        AND $FF)*F2+CX1) SHR 16)+
      (((C SHR 8  AND $FF)*F2+CX2) SHR 16) SHL 8+
      (((C SHR 16 AND $FF)*F2+CX3) SHR 16) SHL 16;
   PUT(X+N,Y+I,CONV(C));
  END;
 END;
END;
PROCEDURE BARTRA(X,Y:LONGINT;H,B:DWORD;C:DWORD;F:EXTENDED);
VAR I,N:DWORD;
    F2:EXTENDED;
    CX1,CX2,CX3:EXTENDED;
BEGIN
 IF (H=0) OR (B=0) THEN EXIT;
 F2:=1-F;
 C:=RCONV(C);
 CX1:=(C AND $FF)*F;
 CX2:=(C SHR 8 AND $FF)*F;
 CX3:=(C SHR 16 AND $FF)*F;
 FOR I:=0 TO H-1 DO
 BEGIN
  FOR N:=0 TO B-1 DO
  BEGIN
   C:=RCONV(GET(X+N,Y+I));
   C:=ROUND((C AND $FF)*F2+CX1)+
      ROUND((C SHR 8 AND $FF)*F2+CX2) SHL 8+
      ROUND((C SHR 16 AND $FF)*F2+CX3) SHL 16;
   PUT(X+N,Y+I,CONV(C));
  END;
 END;
END;
PROCEDURE PUTINV(X,Y:LONGINT);
BEGIN
 PUT(X,Y,NOT GET(X,Y));
END;
PROCEDURE DRAWSPOINTERUP(X,Y:LONGINT;D,C:DWORD);
VAR I:DWORD;
BEGIN
 FOR I:=0 TO D-1 DO
 BEGIN
  BAR(X+(D-I-1),Y+I,1,(I+1)*2,C);
 END;
END;
PROCEDURE DRAWSPOINTERDOWN(X,Y:LONGINT;D,C:DWORD);
VAR I:DWORD;
BEGIN
 FOR I:=0 TO D-1 DO
 BEGIN
  BAR(X+I,Y+I,1,(D-I)*2,C);
 END;
END;
PROCEDURE DRAWSPOINTERRIGHT(X,Y:LONGINT;D,C:DWORD);
VAR I:DWORD;
BEGIN
 FOR I:=0 TO D-1 DO
 BEGIN
  BAR(X+I,Y+I,(D-I)*2,1,C);
 END;
END;
PROCEDURE DRAWSPOINTERLEFT(X,Y:LONGINT;D,C:DWORD);
VAR I:DWORD;
BEGIN
 FOR I:=0 TO D-1 DO
 BEGIN
  BAR(X+I,Y+(D-I-1),(I+1)*2,1,C);
 END;
END;
PROCEDURE FRAMEC3D(X,Y:LONGINT;H,B:DWORD);
BEGIN
 BAR(X     ,Y     ,1   ,B   ,CL_GRAY);
 BAR(X     ,Y+1   ,H-2 ,1   ,CL_GRAY);
 BAR(X     ,Y+H-1 ,1   ,B   ,CL_LSILVER);
 BAR(X+B-1 ,Y+1   ,H-2 ,1   ,CL_LSILVER);
 BAR(X+1   ,Y+1   ,1   ,B-2 ,CL_LSILVER);
 BAR(X+1   ,Y+2   ,H-4 ,1   ,CL_LSILVER);
 BAR(X+1   ,Y+H-2 ,1   ,B-2 ,CL_GRAY);
 BAR(X+B-2 ,Y+2   ,H-4 ,1   ,CL_GRAY);
END;
PROCEDURE FRAMEI3D(X,Y:LONGINT;H,B:DWORD);
BEGIN
 BAR(X     ,Y     ,1   ,B   ,CL_BLACK);
 BAR(X     ,Y+1   ,H-2 ,1   ,CL_BLACK);
 BAR(X     ,Y+H-1 ,1   ,B   ,CL_WHITE);
 BAR(X+B-1 ,Y+1   ,H-2 ,1   ,CL_WHITE);
 BAR(X+1   ,Y+1   ,1   ,B-2 ,CL_GRAY);
 BAR(X+1   ,Y+2   ,H-4 ,1   ,CL_GRAY);
 BAR(X+1   ,Y+H-2 ,1   ,B-2 ,CL_LSILVER);
 BAR(X+B-2 ,Y+2   ,H-4 ,1   ,CL_LSILVER);
END;
PROCEDURE BARI3D(X,Y:LONGINT;H,B:DWORD);
BEGIN
 BAR(X     ,Y,1,B,CL_BLACK);
 BAR(X     ,Y+1,H-2,1,CL_BLACK);
 BAR(X     ,Y+H-1,1,B,CL_WHITE);
 BAR(X+B-1 ,Y+1,H-2,1,CL_WHITE);
 BAR(X+1   ,Y+1,1,B-2,CL_GRAY);
 BAR(X+1   ,Y+2,H-4,1,CL_GRAY);
 BAR(X+1   ,Y+H-2,1,B-2,CL_LSILVER);
 BAR(X+B-2 ,Y+2,H-4,1,CL_LSILVER);
 BAR(X+2,Y+2,H-4,B-4,CL_SILVER);
END;
PROCEDURE BAR3D(X,Y:LONGINT;H,B:DWORD);
BEGIN
 BAR(X     ,Y,1,B,CL_WHITE);
 BAR(X     ,Y+1,H-2,1,CL_WHITE);
 BAR(X     ,Y+H-1,1,B,CL_BLACK);
 BAR(X+B-1 ,Y+1,H-2,1,CL_BLACK);
 BAR(X+1   ,Y+1,1,B-2,CL_LSILVER);
 BAR(X+1   ,Y+2,H-4,1,CL_LSILVER);
 BAR(X+1   ,Y+H-2,1,B-2,CL_GRAY);
 BAR(X+B-2 ,Y+2,H-4,1,CL_GRAY);
 BAR(X+2,Y+2,H-4,B-4,CL_SILVER);
END;
PROCEDURE FREEPICTUREMD(VAR PIC:PPICTURE);
BEGIN
 FREEMEM(PIC,PIC^.H*PIC^.B*BYTESPERPIXEL+8);
 PIC:=NIL;
END;
PROCEDURE PUTPIC16(X,Y:LONGINT;PIC:PPICTURE);
VAR I,N:DWORD;
    PP:^WORD;
BEGIN
 PP:=POINTER(PIC)+8;
 FOR I:=0 TO PIC^.H-1 DO
 BEGIN
  FOR N:=0 TO PIC^.B-1 DO
  BEGIN
   PUT(X+N,Y+I,PP^);
   INC(PP);
  END;
 END;
END;
PROCEDURE PUTPIC8(X,Y:LONGINT;PIC:PPICTURE);
VAR I,N:DWORD;
    PP:^BYTE;
BEGIN
 PP:=POINTER(PIC)+8;
 FOR I:=0 TO PIC^.H-1 DO
 BEGIN
  FOR N:=0 TO PIC^.B-1 DO
  BEGIN
   PUT(X+N,Y+I,PP^);
   INC(PP);
  END;
 END;
END;
PROCEDURE PICTUREMD_PUT(PIC:PPICTURE;X,Y:LONGINT;C:DWORD);
BEGIN
 IF (DWORD(X)<PIC^.B) AND (DWORD(Y)<PIC^.H) THEN
 BEGIN
  CASE BYTESPERPIXEL OF
   1:PBYTEARR(POINTER(PIC)+8)^[Y*PIC^.B+X]:=CONV(C);
   2:PWORDARR(POINTER(PIC)+8)^[Y*PIC^.B+X]:=CONV(C);
   4:PIC^.P[Y*PIC^.B+X]:=CONV(C);
  END;
 END;
END;
PROCEDURE CREATEPICTUREMD(VAR PIC:PPICTURE;H,B:DWORD);
BEGIN
 GETMEM(PIC,H*B*BYTESPERPIXEL+8);
 PIC^.H:=H;
 PIC^.B:=B;
END;
FUNCTION GETSTRINGWIDTH(S:STRING;FONT:PFONT):DWORD;
VAR I:DWORD;
    X:DWORD;
BEGIN
 X:=0;
 FOR I:=1 TO LENGTH(S) DO
 BEGIN
  IF BYTE(S[I])<FONT^.CHARS THEN INC(X,FONT^.CHARTAB^[BYTE(S[I])]^.B);
 END;
 GETSTRINGWIDTH:=X;
END;
PROCEDURE PUTSTRINGINV(X,Y:LONGINT;S:STRING;FONT:PFONT);
VAR I:DWORD;
BEGIN
 FOR I:=1 TO LENGTH(S) DO
 BEGIN
  IF BYTE(S[I])<FONT^.CHARS THEN
  BEGIN
   PUTCHARINV(X,Y,BYTE(S[I]),FONT);
   INC(X,FONT^.CHARTAB^[BYTE(S[I])]^.B);
  END;
 END;
END;
PROCEDURE PUTSTRING(X,Y:LONGINT;S:STRING;COL:DWORD;FONT:PFONT);
VAR I:DWORD;
BEGIN
 FOR I:=1 TO LENGTH(S) DO
 BEGIN
  IF BYTE(S[I])<FONT^.CHARS THEN
  BEGIN
   PUTCHAR(X,Y,BYTE(S[I]),COL,FONT);
   INC(X,FONT^.CHARTAB^[BYTE(S[I])]^.B);
  END;
 END;
END;
PROCEDURE PUTCHARINV(X,Y:LONGINT;NUM:DWORD;FONT:PFONT);
VAR I,N:DWORD;
BEGIN
 IF NUM>=FONT^.CHARS THEN EXIT;
 WITH FONT^.CHARTAB^[NUM]^ DO
 BEGIN
  IF (H=0) OR (B=0) THEN EXIT;
  FOR I:=0 TO H-1 DO
  BEGIN
   FOR N:=0 TO B-1 DO
   BEGIN
    IF P[I*B+N]=1 THEN PUTINV(X+N,Y+I);
   END;
  END;
 END;
END;
PROCEDURE PUTCHAR(X,Y:LONGINT;NUM,COL:DWORD;FONT:PFONT);
VAR I,N:DWORD;
BEGIN
 IF NUM>=FONT^.CHARS THEN EXIT;
 WITH FONT^.CHARTAB^[NUM]^ DO
 BEGIN
  IF (H=0) OR (B=0) THEN EXIT;
  FOR I:=0 TO H-1 DO
  BEGIN
   FOR N:=0 TO B-1 DO
   BEGIN
    IF P[I*B+N]=1 THEN PUT(X+N,Y+I,COL);
   END;
  END;
 END;
END;
FUNCTION LOADFONT(FN:STRING):PFONT;
VAR FONT:PFONT;
    F:FILE;
    TEMPWIDTH,I:DWORD;
BEGIN
 ASSIGN(F,FN);
 RESET(F,1);
 IF IORESULT<>0 THEN
 BEGIN
  LOADFONT:=NIL;
  EXIT;
 END;
 NEW(FONT);
 BLOCKREAD(F,FONT^.CHARS,4);
 BLOCKREAD(F,FONT^.HEIGHT,4);
 GETMEM(FONT^.CHARTAB,FONT^.CHARS*4);
 FOR I:=0 TO FONT^.CHARS-1 DO
 BEGIN
  BLOCKREAD(F,TEMPWIDTH,4);
  GETMEM(FONT^.CHARTAB^[I],FONT^.HEIGHT*TEMPWIDTH+8);
  FONT^.CHARTAB^[I]^.H:=FONT^.HEIGHT;
  FONT^.CHARTAB^[I]^.B:=TEMPWIDTH;
  BLOCKREAD(F,FONT^.CHARTAB^[I]^.P,FONT^.HEIGHT*TEMPWIDTH);
 END;
 CLOSE(F);
 LOADFONT:=FONT;
END;
PROCEDURE CONVDPIC(SOURCE,DEST:PPICTURE);
VAR I,N:DWORD;
    S:DWORD;
BEGIN
 S:=0;
 DEST^.H:=SOURCE^.H;
 DEST^.B:=SOURCE^.B;
 FOR I:=0 TO SOURCE^.H-1 DO
 BEGIN
  FOR N:=0 TO SOURCE^.B-1 DO
  BEGIN
   DEST^.P[S]:=CONV(SOURCE^.P[S] AND $7FFFFFFF)+SOURCE^.P[S] AND $80000000;
   INC(S);
  END;
 END;
END;
PROCEDURE ABS_PUTPICSPZ(X,Y:LONGINT;P:PPICTURE);
VAR I,N:WORD;
    S:DWORD;
BEGIN
 IF (P^.H=0) OR (P^.B=0) THEN EXIT;
 S:=0;
 FOR I:=0 TO P^.H-1 DO
 BEGIN
  FOR N:=0 TO P^.B-1 DO
  BEGIN
   IF P^.P[S] AND $80000000=0 THEN ABS_PUT(X+N,Y+I,P^.P[S]);
   INC(S);
  END;
 END;
END;
PROCEDURE ABS_GETPIC(X,Y:LONGINT;P:PPICTURE);
VAR I,N:WORD;
    S:DWORD;
BEGIN
 IF (P^.H=0) OR (P^.B=0) THEN EXIT;
 S:=0;
 FOR I:=0 TO P^.H-1 DO
 BEGIN
  FOR N:=0 TO P^.B-1 DO
  BEGIN
   P^.P[S]:=ABS_GET(X+N,Y+I);
   INC(S);
  END;
 END;
END;
PROCEDURE DIRECT_PUTPICSPZ(X,Y:LONGINT;P:PPICTURE);
VAR I,N:WORD;
    S:DWORD;
BEGIN
 IF (P^.H=0) OR (P^.B=0) THEN EXIT;
 S:=0;
 FOR I:=0 TO P^.H-1 DO
 BEGIN
  FOR N:=0 TO P^.B-1 DO
  BEGIN
   IF P^.P[S] AND $80000000=0 THEN DIRECT_PUT(X+N,Y+I,P^.P[S]);
   INC(S);
  END;
 END;
END;
PROCEDURE DIRECT_GETPIC(X,Y:LONGINT;P:PPICTURE);
VAR I,N:WORD;
    S:DWORD;
BEGIN
 IF (P^.H=0) OR (P^.B=0) THEN EXIT;
 S:=0;
 FOR I:=0 TO P^.H-1 DO
 BEGIN
  FOR N:=0 TO P^.B-1 DO
  BEGIN
   P^.P[S]:=DIRECT_GET(X+N,Y+I);
   INC(S);
  END;
 END;
END;
PROCEDURE DIRECT_PUTPIC(X,Y:LONGINT;P:PPICTURE);
VAR I,N:DWORD;
    S:DWORD;
BEGIN
 IF (P^.H=0) OR (P^.B=0) THEN EXIT;
 S:=0;
 FOR I:=0 TO P^.H-1 DO
 BEGIN
  FOR N:=0 TO P^.B-1 DO
  BEGIN
   DIRECT_PUT(X+N,Y+I,P^.P[S]);
   INC(S);
  END;
 END;
END;
PROCEDURE SETWIN(W:TSCRWIN);
BEGIN
 ADDX:=W.ADDX;
 ADDY:=W.ADDY;
 SUBX:=W.SUBX;
 SUBY:=W.SUBY;
 MAXX:=W.MAXX;
 MAXY:=W.MAXY;
 VIS:=W.VIS;
END;
PROCEDURE CREATESUBWIN(BAS:TSCRWIN;X,Y:LONGINT;H,B:DWORD;VIS:BOOLEAN;VAR W:TSCRWIN);
BEGIN
 X:=X-BAS.SUBX;
 Y:=Y-BAS.SUBY;
 IF (NOT BAS.VIS) OR (NOT VIS) OR (H=0) OR (B=0) OR
    (LONGINT(X+B)<=0) OR (LONGINT(Y+H)<=0) OR (LONGINT(X)>LONGINT(BAS.MAXX)) OR
    (LONGINT(Y)>LONGINT(BAS.MAXY)) THEN
 BEGIN
  W.VIS:=FALSE;
  EXIT;
 END;
 IF X<0 THEN
 BEGIN
  W.ADDX:=BAS.ADDX;
  W.SUBX:=-X;
 END
 ELSE
 BEGIN
  W.ADDX:=BAS.ADDX+X;
  W.SUBX:=0;
 END;
 IF Y<0 THEN
 BEGIN
  W.ADDY:=BAS.ADDY;
  W.SUBY:=-Y;
 END
 ELSE
 BEGIN
  W.ADDY:=BAS.ADDY+Y;
  W.SUBY:=0;
 END;
 H:=H-W.SUBY;
 B:=B-W.SUBX;
 W.MAXY:=BAS.MAXY-(W.ADDY-BAS.ADDY);
 W.MAXX:=BAS.MAXX-(W.ADDX-BAS.ADDX);
 IF BAS.MAXY<>WIDTH-1 THEN
 BEGIN
  IF BAS.SUBY<>0 THEN
  BEGIN
  END;
 END;
 IF H<W.MAXY+1 THEN W.MAXY:=H-1;
 IF B<W.MAXX+1 THEN W.MAXX:=B-1;
 W.VIS:=TRUE;
END;
PROCEDURE CREATEABSWIN(X,Y:LONGINT;H,B:DWORD;VIS:BOOLEAN;VAR W:TSCRWIN);
BEGIN
 IF (B=0) OR (H=0) OR (NOT VIS) OR (X+B<=0) OR (Y+H<=0) OR (Y>=HEIGHT) OR (X>=WIDTH) THEN
 BEGIN
  W.VIS:=FALSE;
  EXIT;
 END;
 IF X<0 THEN
 BEGIN
  B:=B+X;
  X:=0;
 END;
 IF Y<0 THEN
 BEGIN
  H:=H+Y;
  Y:=0;
 END;
 W.VIS:=TRUE;
 W.MAXX:=B-1;
 W.MAXY:=H-1;
 W.ADDX:=X;
 W.ADDY:=Y;
 W.SUBX:=0;
 W.SUBY:=0;
END;
PROCEDURE SETBANK_NIL;ASSEMBLER;
ASM
  MOV AX,4F05h
  INT 10h
END;
FUNCTION AUTOSELECT(ST,WI,HE:WORD;CD:BYTE):DWORD;
VAR I:WORD;
BEGIN
 I:=ST;
 WHILE I<MODECOUNT DO
 BEGIN
  SELECTMODE(I);
  IF (MODEINFO^.XRES=WI) AND
     (MODEINFO^.YRES=HE) AND
     (MODEINFO^.BPP=CD)  AND
     (MODEINFO^.MODEATTR AND 1<>0) THEN
  BEGIN
   AUTOSELECT:=I;
   EXIT;
  END;
  INC(I);
 END;
 AUTOSPECIFYMODE(WI,HE,CD);
 AUTOSELECT:=AKTMODE;
END;
FUNCTION RCONV_DC(C:DWORD):DWORD;ASSEMBLER;
ASM
  XOR EAX,EAX
  MOV EDX,C
  MOV EBX,EDX
  MOV ECX,BLUEPOS
  SHR EBX,CL
  MOV ECX,BLUEDIV
  SHL EBX,CL
  MOV AL,BL
  SHL EAX,16
  MOV EBX,EDX
  MOV ECX,GREENPOS
  SHR EBX,CL
  MOV ECX,GREENDIV
  SHL EBX,CL
  MOV AH,BL
  MOV ECX,REDPOS
  SHR EDX,CL
  MOV ECX,REDDIV
  SHL EDX,CL
  MOV AL,DL
END;
FUNCTION CONV_DC(C:DWORD):DWORD;ASSEMBLER;
ASM
  XOR EAX,EAX
  MOV AL,BYTE PTR [C+2]
  MOV CL,BLUEDIV
  SHR AL,CL
  MOV CL,BLUEPOS
  SHL EAX,CL
  MOV EBX,EAX
  XOR EAX,EAX
  MOV AL,BYTE PTR [C+1]
  MOV CL,GREENDIV
  SHR AL,CL
  MOV CL,GREENPOS
  SHL EAX,CL
  ADD EBX,EAX
  XOR EAX,EAX
  MOV AL,BYTE PTR [C]
  MOV CL,REDDIV
  SHR AL,CL
  MOV CL,REDPOS
  SHL EAX,CL
  ADD EAX,EBX
END;
FUNCTION CONV_NIL(C:DWORD):DWORD;
BEGIN
 CONV_NIL:=C;
END;
PROCEDURE PUT_NIL(X,Y:LONGINT;C:DWORD);
BEGIN
END;
PROCEDURE SETPALI(I,RE,GR,BLA:BYTE);ASSEMBLER;
ASM
  MOV DX,3C8h
  MOV AL,I
  OUT DX,AL
  INC DX
  MOV AL,RE
  OUT DX,AL
  MOV AL,GR
  OUT DX,AL
  MOV AL,BLA
  OUT DX,AL
END;
PROCEDURE SETSTD256PAL;
VAR I:DWORD;
BEGIN
 FOR I:=0 TO 255 DO
 BEGIN
  SETPALI(I,(I AND 7)*9,(I SHR 3 AND 7)*9,(I SHR 6 AND 3)*21);
 END;
END;
PROCEDURE INITMODE;
BEGIN
 WRITELN(AKTMODE);
 REGS.AX:=$4F02;
 REGS.BX:=AKTMODE;
 INTR($10,REGS);
 REGS.AX:=$4F05;
 REGS.DX:=0;
 INTR($10,REGS);
 WRITELN('Init ?');
 RDSEG:=0;
 WRSEG:=0;
 IF (MODEINFO^.WINBATTR AND 1=1) THEN
 BEGIN
  IF (MODEINFO^.WINBATTR AND 2<>0) THEN
  BEGIN
   RDSEG:=MODEINFO^.WINBSEG;
   RDWIN:=1;
  END;
  IF (MODEINFO^.WINBATTR AND 4<>0) THEN
  BEGIN
   WRSEG:=MODEINFO^.WINBSEG;
   WRWIN:=1;
  END;
 END;
 IF (MODEINFO^.WINAATTR AND 1=1) THEN
 BEGIN
  IF (MODEINFO^.WINAATTR AND 2<>0) THEN
  BEGIN
   RDSEG:=MODEINFO^.WINASEG;
   RDWIN:=0;
  END;
  IF (MODEINFO^.WINAATTR AND 4<>0) THEN
  BEGIN
   WRSEG:=MODEINFO^.WINASEG;
   WRWIN:=0;
  END;
 END;
 WRSEG:=MODEINFO^.WINASEG;
 WRSEGL:=DWORD(WRSEG)*16;
 WIDTH:=MODEINFO^.XRES;
 HEIGHT:=MODEINFO^.YRES;
 ADDX:=0;
 ADDY:=0;
 SUBX:=0;
 SUBY:=0;
 MAXX:=WIDTH-1;
 MAXY:=HEIGHT-1;
 VIS:=TRUE;
 PIXELS:=HEIGHT*WIDTH;
 CONV:=@CONV_NIL;
 DIRECT_PUT:=@PUT_NIL;
 SETBANK:=@SETBANK_NIL;
 IF MODEINFO^.MEMM=6 THEN
 BEGIN
  REDPOS:=MODEINFO^.REDP;
  REDDIV:=8-MODEINFO^.REDS;
  GREENPOS:=MODEINFO^.GREENP;
  GREENDIV:=8-MODEINFO^.GREENS;
  BLUEPOS:=MODEINFO^.BLUEP;
  BLUEDIV:=8-MODEINFO^.BLUES;
  CONV:=@CONV_DC;
  RCONV:=@RCONV_DC;
 END;
 COLORD:=MODEINFO^.BPP;
 CASE COLORD OF
  8:
  BEGIN
   IF MODEINFO^.MEMM=4 THEN
   BEGIN
    REDPOS:=0;
    REDDIV:=5;
    GREENPOS:=3;
    GREENDIV:=5;
    BLUEPOS:=6;
    BLUEDIV:=6;
    SETSTD256PAL;
    CONV:=@CONV_DC;
    RCONV:=@RCONV_DC;
   END;
   GETMEM(BUFFER,HEIGHT*WIDTH);
   BYTESPERPIXEL:=1;
   CASE MODEINFO^.WINGRAN OF
    64:
    BEGIN
     CASE MODEINFO^.WINSIZE OF
      64:
      BEGIN
       DIRECT_PUT:=@PUT_64_64_8;
       DIRECT_GET:=@GET_64_64_8;
       COPY:=@COPY_64_64_8;
       FILL:=@FILL_B8;
       BAR:=@BAR_B8;
       PUT:=@PUT_B8;
       GET:=@GET_B8;
       ABS_PUT:=@PUT_ABS_B8;
       ABS_GET:=@GET_ABS_B8;
       PUTPIC:=@PUTPIC8;
      END;
     END;
    END;
   END;
  END;
  16:
  BEGIN
   GETMEM(BUFFER,HEIGHT*WIDTH*4);
   BYTESPERPIXEL:=2;
   CASE MODEINFO^.WINGRAN OF
    64:
    BEGIN
     CASE MODEINFO^.WINSIZE OF
      64:
      BEGIN
       DIRECT_PUT:=@PUT_64_64_16;
       DIRECT_GET:=@GET_64_64_16;
       COPY:=@COPY_64_64_16;
       FILL:=@FILL_B16;
       BAR:=@BAR_B16;
       PUT:=@PUT_B16;
       GET:=@GET_B16;
       ABS_PUT:=@PUT_ABS_B16;
       ABS_GET:=@GET_ABS_B16;
       PUTPIC:=@PUTPIC16;
      END;
     END;
    END;
   END;
  END;
  32:
  BEGIN
   GETMEM(BUFFER,HEIGHT*WIDTH*4);
   BYTESPERPIXEL:=4;
   CASE MODEINFO^.WINGRAN OF
    64:
    BEGIN
     CASE MODEINFO^.WINSIZE OF
      64:
      BEGIN
       DIRECT_PUT:=@PUT_64_64_32;
       DIRECT_GET:=@GET_64_64_32;
       COPY:=@COPY_64_64_32;
       FILL:=@FILL_B32;
       BAR:=@BAR_B32;
       PUT:=@PUT_B32;
       GET:=@GET_B32;
       ABS_PUT:=@PUT_ABS_B32;
       ABS_GET:=@GET_ABS_B32;
       PUTPIC:=@PUTPIC32;
      END;
     END;
    END;
   END;
  END;
 END;
 CL_BLACK:=CONV($000000);
 CL_BLUE:=CONV($7F0000);
 CL_GREEN:=CONV($007F00);
 CL_RED:=CONV($00007F);
 CL_GRAY:=CONV($7F7F7F);
 CL_SILVER:=CONV($BFBFBF);
 CL_YELLOW:=CONV($00FFFF);
 CL_WHITE:=CONV($FFFFFF);
 CL_LSILVER:=CONV($CFCFCF);
 CL_LBLUE:=CONV($FF0000);
END;
PROCEDURE AUTOSPECIFYMODE(B,H,P:WORD);
VAR I:WORD;
BEGIN
 FOR I:=0 TO $1FF DO
 BEGIN
  WRITE(I,#13);
  SPECIFYMODE(I);
  IF (MODEINFO^.YRES=H) AND (MODEINFO^.XRES=B) AND
     (MODEINFO^.BPP=P) THEN EXIT;
 END;
 AKTMODE:=$FFFFFFFF;
END;
END.
