PROCEDURE PUTPIC8(X,Y:LONGINT;PIC:PPICTURE);ASSEMBLER;
ASM
  MOV EAX,[VIS]
  OR EAX,EAX
  JZ @EXT
  MOV ESI,PIC
  MOV ECX,[ESI]                { Hhe berprfen }
  OR ECX,ECX
  JZ @EXT
  MOV EBX,[ESI+4]              { Breite berprfen }
  OR EBX,EBX
  JZ @EXT
  ADD ESI,8
  MOV EDX,Y                    {  Y-SUBY auf Signed berprfen ! }
  SUB EDX,SUBY
  JNS @NONEGY
  NEG EDX
  SUB ECX,EDX                  { Hhe korrigieren }
  JS @EXT
  JZ @EXT
  MOV EAX,EBX                  { Breite stimmt noch... (keine x-Prfung) }
  MUL EDX                      { Anfangsposition korrigieren }
  SHL EAX,2
  ADD ESI,EAX
  XOR EDX,EDX                  { Y=0 ! }
  JMP @TOKNEGY
 @NONEGY:
  CMP EDX,MAXY                 { Y innerhalb des Fensters ? }
  JA @EXT
 @TOKNEGY:
  MOV EDI,X                    { X-SUBX auf Signed berprfen ! }
  SUB EDI,SUBX
  JNS @NONEGX
  NEG EDI
  SUB EBX,EDI                  { Breite korrigieren ! }
  JS @EXT
  JZ @EXT
  SHL EDI,2                    { Anfangsposition korrigieren ! }
  ADD ESI,EDI
  XOR EDI,EDI                  { X=0 ! }
  JMP @TOKNEGX
 @NONEGX:
  CMP EDI,[MAXX]               { X innerhalb des Fensters ? }
  JA @EXT
 @TOKNEGX:
  { Breite mu noch berprft werden ! }
  MOV EAX,EDI
  ADD EAX,EBX
  CMP EAX,MAXX
  JNA @OVERFLOWX
  MOV EBX,MAXX
  SUB EBX,EDI
  INC EBX
 @OVERFLOWX:
  { Hhe mu noch berprft werden ! }
  MOV EAX,EDX
  ADD EAX,ECX
  CMP EAX,MAXY
  JNA @OVERFLOWY
  MOV ECX,MAXY
  SUB ECX,EDX
  INC ECX
 @OVERFLOWY:
  ADD EDI,ADDX                 { Fensterverschiebung X }
  ADD EDX,ADDY                 { Fensterverschiebung Y }
  MOV EAX,WIDTH
  MUL EDX
  ADD EDI,EAX                  { Damit ist in EDI schon mal die Pre-Ziel-Ver }
  ADD EDI,[BUFFER]             { Und Zielposition fertig ! }
  MOV EDX,ECX                  { EDX wird als Zhler fr die Hhe verwendet }
  MOV EAX,PIC                  { HADD berechnen => EAX }
  MOV EAX,[EAX+4]
  SUB EAX,EBX
  PUSH EBP
  MOV EBP,WIDTH
  SUB EBP,EBX
  SHL EBP,2
 @BIGLOOP:
  MOV ECX,EBX
  SHR ECX,2
  REP MOVSD
  MOV ECX,EBX
  AND ECX,3
  REP MOVSB
  ADD ESI,EAX
  ADD EDI,EBP
  DEC EDX
  JNE @BIGLOOP
  POP EBP
 @EXT:
END;
PROCEDURE CLEAR8(C:DWORD);ASSEMBLER;
ASM
  MOV EAX,VIS
  OR EAX,EAX
  JZ @EXT
  MOV EAX,WIDTH
  MOV EBX,EAX
  MOV ECX,[ADDY]
  MUL ECX
  ADD EAX,[ADDX]
  MOV EDX,[MAXX]
  INC EDX
  SUB EBX,EDX
  MOV EDI,EAX
  MOV ESI,[MAXY]
  INC ESI
  ADD EDI,[BUFFER]
  MOV EAX,C
  MOV AH,AL
  MOV CX,AX
  SHL EAX,16
  MOV AX,CX
 @LP:
  MOV ECX,EDX
  SHR ECX,2
  REP STOSD
  MOV ECX,EDX
  AND ECX,3
  REP STOSB
  ADD EDI,EBX
  DEC ESI
  JNZ @LP
 @EXT:
END;
PROCEDURE PUTPIXEL8(X,Y:LONGINT;C:DWORD);ASSEMBLER;
ASM
  MOV EAX,VIS
  OR EAX,EAX
  JZ @EXT
  MOV EDX,Y
  SUB EDX,SUBY
  CMP EDX,MAXY
  JA @EXT
  MOV EAX,WIDTH
  MOV ECX,X
  SUB ECX,SUBX
  CMP ECX,MAXX
  JA @EXT
  ADD EDX,ADDY
  ADD ECX,ADDX
  MUL EDX
  ADD EAX,ECX
  ADD EAX,[BUFFER]
  MOV EBX,C
  MOV [EAX],BL
 @EXT:
END;
PROCEDURE BAR8(X,Y:LONGINT;H,B,C:DWORD);ASSEMBLER;
ASM
  MOV EAX,VIS
  OR EAX,EAX
  JZ @EXT
  MOV ESI,H
  OR ESI,ESI
  JZ NEAR @EXT
  MOV EBX,B
  OR EBX,EBX
  JZ NEAR @EXT
  MOV ECX,X
  SUB ECX,[SUBX]
  JNS @NXSIGN
  ADD EBX,ECX
  JS @EXT
  JZ @EXT
  XOR ECX,ECX
  JMP @XSIGN
 @NXSIGN:
  CMP ECX,[MAXX]
  JA @EXT
 @XSIGN:
  MOV EDX,Y
  SUB EDX,[SUBY]
  JNS @NYSIGN
  ADD ESI,EDX
  JS @EXT
  JZ @EXT
  XOR EDX,EDX
  JMP @YSIGN
 @NYSIGN:
  CMP EDX,[MAXY]
  JA @EXT
 @YSIGN:
  MOV EAX,ECX
  ADD EAX,EBX
  JC @NXCOR
  CMP EAX,[MAXX]
  JNA @NXOVER
 @NXCOR:
  MOV EBX,[MAXX]
  SUB EBX,ECX
  INC EBX
 @NXOVER:
  MOV EAX,EDX
  ADD EAX,ESI
  JC @NYCOR
  CMP EAX,[MAXY]
  JNA @NYOVER
 @NYCOR:
  MOV ESI,[MAXY]
  SUB ESI,EDX
  INC ESI
 @NYOVER:
  MOV EAX,[WIDTH]
  ADD EDX,[ADDY]
  MUL EDX
  ADD EAX,ECX
  ADD EAX,[ADDX]
  MOV EDI,EAX
  ADD EDI,[BUFFER]
  MOV EDX,[WIDTH]
  SUB EDX,EBX
  MOV EAX,C
  MOV AH,AL
  MOV CX,AX
  SHL EAX,16
  MOV AX,CX
 @MAINLOOP:
  MOV ECX,EBX
  SHR ECX,2
  REP STOSD
  MOV ECX,EBX
  AND ECX,3
  REP STOSB
  ADD EDI,EDX
  DEC ESI
  JNE @MAINLOOP
 @EXT:
END;
PROCEDURE SHOW8_LFB;ASSEMBLER;
ASM
{$IFNDEF DEBUG}
  MOV EAX,[AREAVIS]
  OR EAX,EAX
  JZ @EXT
  PUSH EBP
  MOV EAX,[WIDTH]
  MOV EBP,EAX
  MOV ECX,[AREAY]
  MUL ECX
  ADD EAX,[AREAX]
  MOV ESI,EAX
  MOV EDI,EAX
  ADD ESI,[BUFFER]
  ADD EDI,[FRAMEADDR]
  MOV EBX,[AREAB]
  SUB EBP,EBX
  MOV EDX,[AREAH]
 @LP:
  MOV ECX,EBX
  SHR ECX,2
  REP MOVSD
  MOV ECX,EBX
  AND ECX,3
  REP MOVSB
  ADD EDI,EBP
  ADD ESI,EBP
  DEC EDX
  JNE @LP
  POP EBP
 @EXT:
{$ENDIF}
END;
PROCEDURE BAR3D8(X,Y:LONGINT;H,B:DWORD);
BEGIN
 BAR8(X,Y,1,B,CL_LSILVER);
 BAR8(X,Y+1,H-2,1,CL_LSILVER);
 BAR8(X,Y+H-1,1,B,CL_BLACK);
 BAR8(X+B-1,Y+1,H-2,1,CL_BLACK);
 BAR8(X+1,Y+1,1,B-2,CL_WHITE);
 BAR8(X+1,Y+2,H-4,1,CL_WHITE);
 BAR8(X+1,Y+H-2,1,B-2,CL_GRAY);
 BAR8(X+B-2,Y+2,H-4,1,CL_GRAY);
 BAR8(X+2,Y+2,H-4,B-4,CL_SILVER);
END;
PROCEDURE FRAME3D8(X,Y:LONGINT;H,B:DWORD);
BEGIN
 BAR8(X,Y,1,B,CL_LSILVER);
 BAR8(X,Y+1,H-2,1,CL_LSILVER);
 BAR8(X,Y+H-1,1,B,CL_BLACK);
 BAR8(X+B-1,Y+1,H-2,1,CL_BLACK);
 BAR8(X+1,Y+1,1,B-2,CL_WHITE);
 BAR8(X+1,Y+2,H-4,1,CL_WHITE);
 BAR8(X+1,Y+H-2,1,B-2,CL_GRAY);
 BAR8(X+B-2,Y+2,H-4,1,CL_GRAY); 
END;
PROCEDURE BARI3D8(X,Y:LONGINT;H,B:DWORD);
BEGIN
 BAR8(X,Y,1,B,CL_GRAY);
 BAR8(X,Y+1,H-2,1,CL_GRAY);
 BAR8(X,Y+H-1,1,B,CL_WHITE);
 BAR8(X+B-1,Y+1,H-2,1,CL_WHITE);
 BAR8(X+1,Y+1,1,B-2,CL_BLACK);
 BAR8(X+1,Y+2,H-4,1,CL_BLACK);
 BAR8(X+1,Y+H-2,1,B-2,CL_LSILVER);
 BAR8(X+B-2,Y+2,H-4,1,CL_LSILVER);
 BAR8(X+2,Y+2,H-4,B-4,CL_SILVER);
END;
PROCEDURE FRAMEI3D8(X,Y:LONGINT;H,B:DWORD);
BEGIN
 BAR8(X,Y,1,B,CL_GRAY);
 BAR8(X,Y+1,H-2,1,CL_GRAY);
 BAR8(X,Y+H-1,1,B,CL_WHITE);
 BAR8(X+B-1,Y+1,H-2,1,CL_WHITE);
 BAR8(X+1,Y+1,1,B-2,CL_BLACK);
 BAR8(X+1,Y+2,H-4,1,CL_BLACK);
 BAR8(X+1,Y+H-2,1,B-2,CL_LSILVER);
 BAR8(X+B-2,Y+2,H-4,1,CL_LSILVER);
END;
PROCEDURE ABS_PUT8(X,Y:LONGINT;C:DWORD);ASSEMBLER;
ASM
  MOV EDX,Y
  CMP EDX,[HEIGHT]
  JNB @EXT
  MOV EAX,[WIDTH]
  MOV ECX,X
  CMP ECX,EAX
  JNB @EXT
  MUL EDX
  ADD EAX,ECX
  MOV EBX,C
  ADD EAX,[BUFFER]
  MOV [EAX],BL
 @EXT:
END;
FUNCTION ABS_GET8(X,Y:LONGINT):DWORD;ASSEMBLER;
ASM
  MOV EDX,Y
  CMP EDX,[HEIGHT]
  JNB @EXT
  MOV EAX,[WIDTH]
  MOV ECX,X
  CMP ECX,EAX
  JNB @EXT
  MUL EDX
  ADD EAX,ECX
  ADD EAX,[BUFFER]
  MOV EAX,[EAX]
  AND EAX,0FFh
 @EXT:
END;
PROCEDURE DIRECT_PUT8LFB(X,Y:LONGINT;C:DWORD);ASSEMBLER;
ASM
{$IFNDEF DEBUG}
  MOV EDX,Y
  CMP EDX,[HEIGHT]
  JNB @EXT
  MOV EAX,[WIDTH]
  MOV ECX,X
  CMP ECX,EAX
  JNB @EXT
  MUL EDX
  ADD EAX,ECX
  MOV EBX,C
  ADD EAX,[FRAMEADDR]
  MOV [EAX],BL
 @EXT:
{$ENDIF}
END;
PROCEDURE ABS_PUTPIC8(X,Y:LONGINT;P:PPICTURE);
VAR I,N:WORD;
    S:DWORD;
BEGIN
 IF (P^.H=0) OR (P^.B=0) THEN EXIT;
 S:=0;
 FOR I:=0 TO P^.H-1 DO
 BEGIN
  FOR N:=0 TO P^.B-1 DO
  BEGIN
   ABS_PUT8(X+N,Y+I,P^.P[S]);
   INC(S);
  END;
 END;
END;
PROCEDURE ABS_PUTPICSPZ8(X,Y:LONGINT;P:PPICTURE);
VAR I,N:WORD;
    S:DWORD;
BEGIN
 IF (P^.H=0) OR (P^.B=0) THEN EXIT;
 S:=0;
 FOR I:=0 TO P^.H-1 DO
 BEGIN
  FOR N:=0 TO P^.B-1 DO
  BEGIN
   IF P^.P[S] AND $80000000=0 THEN ABS_PUT8(X+N,Y+I,P^.P[S]);
   INC(S);
  END;
 END;
END;
PROCEDURE ABS_GETPIC8(X,Y:LONGINT;P:PPICTURE);
VAR I,N:WORD;
    S:PDWORD;
BEGIN
 IF (P^.H=0) OR (P^.B=0) THEN EXIT;
 S:=@P^.P;
 FOR I:=0 TO P^.H-1 DO
 BEGIN
  FOR N:=0 TO P^.B-1 DO
  BEGIN
   S^:=ABS_GET8(X+N,Y+I);
   INC(S);
  END;
 END;
END;
PROCEDURE DIRECT_PUTPICSPZ8LFB(X,Y:LONGINT;P:PPICTURE);
VAR I,N:WORD;
    S:DWORD;
BEGIN
 {$IFNDEF DEBUG}
 IF (P^.H=0) OR (P^.B=0) THEN EXIT;
 S:=0;
 FOR I:=0 TO P^.H-1 DO
 BEGIN
  FOR N:=0 TO P^.B-1 DO
  BEGIN
   IF P^.P[S] AND $80000000=0 THEN DIRECT_PUT8LFB(X+N,Y+I,P^.P[S]);
   INC(S);
  END;
 END;
 {$ENDIF DEBUG}
END;
PROCEDURE DIRECT_PUTPIC8LFB(X,Y:LONGINT;P:PPICTURE);
VAR I,N:DWORD;
    S:DWORD;
BEGIN
 {$IFNDEF DEBUG}
 IF (P^.H=0) OR (P^.B=0) THEN EXIT;
 S:=0;
 FOR I:=0 TO P^.H-1 DO
 BEGIN
  FOR N:=0 TO P^.B-1 DO
  BEGIN
   DIRECT_PUT8LFB(X+N,Y+I,P^.P[S]);
   INC(S);
  END;
 END;
 {$ENDIF DEBUG}
END;
PROCEDURE PUTSTRING8_TYP1(X,Y:LONGINT;S:STRING;C,SZ:DWORD);
VAR CI:DWORD;
    I,N:DWORD;
    P:PDWORDARRAY;
    CH,T:DWORD;
    B:DWORD;
BEGIN
 FOR CI:=1 TO BYTE(S[0]) DO
 BEGIN
  CH:=BYTE(S[CI]);
  IF CH<FONT1_CHARS THEN
  BEGIN
   P:=FONT1_ARRAY^[CH];
   B:=P^[1];
   T:=8;
   IF (FONT1_HEIGHT<>0) AND (B<>0) THEN
   BEGIN
    FOR I:=0 TO FONT1_HEIGHT-1 DO
    BEGIN
     FOR N:=0 TO B-1 DO
     BEGIN
      IF PBYTEARRAY(P)^[T]=1 THEN PUTPIXEL8(X+N,Y+I,C);
      INC(T);
     END;
    END;
    INC(X,B);
   END;
  END;
 END;
END;
FUNCTION SELECTFONT8(NAME:STRING):BOOLEAN;
BEGIN
 IF NAME=FONT_NAME THEN EXIT;
 GETLOCK(@FONT_LOCK);
 IF CURFONT<>NIL THEN RELEASEFONT(CURFONT);
 CURFONT:=USEFONT(NAME);
 IF CURFONT<>NIL THEN
 BEGIN
  CASE CURFONT^.TYP OF
   1:
   BEGIN
    WITH PFONT1(CURFONT^.DATA)^ DO
    BEGIN
     FONT1_HEIGHT:=HEIGHT;
     FONT1_CHARS:=CHARS;
     FONT1_ARRAY:=CHARTAB;
    END;
    INTERN_PUTSTRING:=@PUTSTRING8_TYP1;
    INTERN_GETSTRINGWIDTH:=@GETSTRINGWIDTH_TYP1;
    INTERN_GETSTRINGHEIGHT:=@GETSTRINGHEIGHT_TYP1;
   END;
   ELSE INTERN_PUTSTRING:=NIL; { Hier knnte nach externem Prog ges. werden }
  END;
 END
 ELSE
 BEGIN
  INTERN_PUTSTRING:=NIL;
  INTERN_GETSTRINGWIDTH:=NIL;
  INTERN_GETSTRINGHEIGHT:=NIL;
  SELECTFONT8:=FALSE;
 END;
 FREELOCK(@FONT_LOCK);
END;
PROCEDURE DRAWSPOINTERUP8(X,Y:LONGINT;D,C:DWORD);
VAR I:DWORD;
BEGIN
 FOR I:=0 TO D-1 DO
 BEGIN
  BAR8(X+(D-I-1),Y+I,1,(I+1)*2,C);
 END;
END;
PROCEDURE DRAWSPOINTERDOWN8(X,Y:LONGINT;D,C:DWORD);
VAR I:DWORD;
BEGIN
 FOR I:=0 TO D-1 DO
 BEGIN
  BAR8(X+I,Y+I,1,(D-I)*2,C);
 END;
END;
PROCEDURE DRAWSPOINTERRIGHT8(X,Y:LONGINT;D,C:DWORD);
VAR I:DWORD;
BEGIN
 FOR I:=0 TO D-1 DO
 BEGIN
  BAR8(X+I,Y+I,(D-I)*2,1,C);
 END;
END;
PROCEDURE DRAWSPOINTERLEFT8(X,Y:LONGINT;D,C:DWORD);
VAR I:DWORD;
BEGIN
 FOR I:=0 TO D-1 DO
 BEGIN
  BAR8(X+I,Y+(D-I-1),(I+1)*2,1,C);
 END;
END;
PROCEDURE DRAWCROSS8(X,Y:LONGINT;H,CL:DWORD);
VAR I:DWORD;
    X2:LONGINT;
BEGIN
 X2:=X+H-1;
 FOR I:=0 TO H-1 DO
 BEGIN
  PUTPIXEL8(X+I,Y+I,CL);
  PUTPIXEL8(X2-I,Y+I,CL);
 END;
END;
CONST PROCS8BITMODE:ARRAY[0..17] OF POINTER=(
       @SHOW,
       @PUTPIXEL8,
       @CLEAR8,
       @BAR8,
       @PUTPIC8,
       @BAR3D8,
       @BARI3D8,
       @FRAME3D8,
       @FRAMEI3D8,
       @SELECTFONT8,
       @PUTSTRING,
       @GETSTRINGWIDTH,
       @GETSTRINGHEIGHT,
       @DRAWSPOINTERUP8,
       @DRAWSPOINTERLEFT8,
       @DRAWSPOINTERRIGHT8,
       @DRAWSPOINTERDOWN8,
       @DRAWCROSS8);
PROCEDURE SETPALI(I,RE,GR,BLA:BYTE);ASSEMBLER;
ASM
  MOV DX,3C8h
  MOV AL,I
  OUT DX,AL
  INC DX
  MOV AL,RE
  OUT DX,AL
  MOV AL,GR
  OUT DX,AL
  MOV AL,BLA
  OUT DX,AL
END;
PROCEDURE SETSTD256PAL;
VAR I:DWORD;
BEGIN
 FOR I:=0 TO 255 DO
 BEGIN
  SETPALI(I,(I AND 7)*9,(I SHR 3 AND 7)*9,(I SHR 6 AND 3)*21);
 END;
END;
FUNCTION INIT320X200X8:POINTER;
VAR REGS:TREGISTERS;
BEGIN
 WRITELNSTR('USE BIOS MODE 19');
 REDPOS:=0;
 REDDIV:=5;
 GREENPOS:=3;
 GREENDIV:=5;
 BLUEPOS:=6;
 BLUEDIV:=6;
 HEIGHT:=200;
 WIDTH:=320;
 ADDX:=0;
 ADDY:=0;
 SUBX:=0;
 SUBY:=0;
 MAXX:=319;
 MAXY:=199;
 AREAVIS:=FALSE;
 VIS:=TRUE;
 PIXELS:=320*200;
 BUFFER:=ALLOCMEM(PIXELS);
 FRAMEADDR:=$A0000;
 DIRECT_PUTPIC:=@DIRECT_PUTPIC8LFB;
 DIRECT_PUTPICSPZ:=@DIRECT_PUTPICSPZ8LFB;
 ABS_GETPIC:=@ABS_GETPIC8;
 ABS_PUTPICSPZ:=@ABS_PUTPICSPZ8;
 ABS_PUTPIC:=@ABS_PUTPIC8;
 REGS.EAX:=$13;
 {$IFNDEF DEBUG}REALINT($10,REGS);{$ENDIF}
 SETSTD256PAL;
 CLEAR8(CL_BLACK);
 INTERN_SHOW:=@SHOW8_LFB;
 INIT320X200X8:=@PROCS8BITMODE;
 CL_BLACK:=CONV($000000);
 CL_BLUE:=CONV($7F0000);
 CL_GREEN:=CONV($007F00);
 CL_RED:=CONV($00007F);
 CL_GRAY:=CONV($7F7F7F);
 CL_SILVER:=CONV($BFBFBF);
 CL_YELLOW:=CONV($00FFFF);
 CL_WHITE:=CONV($FFFFFF);
 CL_LSILVER:=CONV($CFCFCF);
 CL_LBLUE:=CONV($FF0000);
END;
FUNCTION INIT8BITMODE:POINTER;
VAR REGS:TREGISTERS;
BEGIN
 IF (MODEINFO.PHYSBASEPTR<>0) AND (MODEINFO.MEMM=4) THEN
 BEGIN
  REDPOS:=0;
  REDDIV:=5;
  GREENPOS:=3;
  GREENDIV:=5;
  BLUEPOS:=6;
  BLUEDIV:=6;
  BUFFER:=ALLOCMEM(PIXELS);
  WRSEGL:=MODEINFO.PHYSBASEPTR;
  FRAMEADDR:=MAPSPACE(WRSEGL,PIXELS);
  DIRECT_PUTPIC:=@DIRECT_PUTPIC8LFB;
  DIRECT_PUTPICSPZ:=@DIRECT_PUTPICSPZ8LFB;
  ABS_GETPIC:=@ABS_GETPIC8;
  ABS_PUTPICSPZ:=@ABS_PUTPICSPZ8;
  ABS_PUTPIC:=@ABS_PUTPIC8;
  REGS.EAX:=$4F02;
  REGS.EBX:=AKTMODE OR 16384;
  {$IFNDEF DEBUG}REALINT($10,REGS);{$ENDIF}
  SETSTD256PAL;
  CLEAR8(CL_BLACK);
  INTERN_SHOW:=@SHOW8_LFB;
  INIT8BITMODE:=@PROCS8BITMODE;
 END ELSE INIT8BITMODE:=NIL;
END;
