  BITS 16
  ORG 0h
%INCLUDE "KERNEL16\SYSTEM.MAC"
START:
  JMP SHORT MAIN
  NOP
  NOP
 KERNEL16_SIZE DD KERNEL16_END-START
 MEMORYSIZE DD 0
 MODULCOUNT DD 0
 MODULPOS DD 0
 MAIN:
  CALL PREPAREKERNEL16
  CALL SWITCHTOPMODE
  CALL MEM_GETMEMSIZE
  MOV [MEMORYSIZE],EAX
  CALL READDWORD
  MOV [MODULCOUNT],EAX
  CALL DRAWBACKGROUND
 MAINLOOP:
  CALL LOADMODUL
  INC DWORD [MODULPOS]
  OR EAX,EAX
  JZ JMPK32
  CALL DRAWPERCENT
  JMP MAINLOOP
 JMPK32:
  MOV EDI,100000h
  MOV EBX,[FS:EDI+8]           ; Gre des Systemspeichers
  MOV EDX,[CS:REALSEG]         ; 
  AND EDX,0FFFFh               ;  Realmode-Segment
  SHL EDX,4                    ; 
  ADD EDX,KERNEL16_REALMODEDESC; 
  MOV EBX,[LOADMODUL_ADDR]
  MOV AX,20h
  MOV DS,AX
  MOV ES,AX
  MOV FS,AX
  MOV GS,AX
  MOV EAX,[CS:MEMORYSIZE]      ; Speichergre
  CALL 18h:DWORD 100000h       ; Kernel32 aufrufen.
  CALL SWITCHTORMODE
  CALL DONEKERNEL16
  MOV AX,3                     ; Textmodus 3
  INT 10h
  RETF                         ; Programm verlassen...
DRAWPERCENT:
  MOV EAX,76
  MUL DWORD [MODULPOS]
  XOR EDX,EDX
  DIV DWORD [MODULCOUNT]
  OR EAX,EAX
  JZ DRAWPERCENT_EXT
  MOV ECX,EAX
  MOV EDI,0B8000h+2*1842
  MOV AL,''
  MOV AH,1
 DRAWPERCENT_LP:
  MOV [FS:EDI],AX
  ADD EDI,2
  DEC ECX
  JNE DRAWPERCENT_LP
 DRAWPERCENT_EXT:
  RET
DRAWBACKGROUND:
  MOV ECX,1680
  MOV EDI,0B8000h
  MOV AL,''
  MOV AH,1
 DRAWBACKGROUND_LP:
  MOV [FS:EDI],AX
  ADD EDI,2
  DEC ECX
  JNE DRAWBACKGROUND_LP
  MOV ECX,320
  MOV ESI,DISP
 DRAWBACKGROUND_LP2:
  MOV EAX,[ESI]
  MOV [FS:EDI],EAX
  ADD EDI,2
  ADD ESI,2
  DEC ECX
  JNE DRAWBACKGROUND_LP2
  RET
DISP:
 DB '',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14
 DB '',14,' ',14,'R',02,'S',02,'3',02,' ',02,'w',02,'i',02,'r',02,'d',02,' ',02,'g',02,'e',02,'l',02,'a',02,'d',02,'e',02,'n',02,'.',02,'.',02,'.',02,' ',02,' ',02,' ',02,' ',02,' ',02,' ',02,' ',02,' ',02,' ',02,' ',02,' ',02,' ',02,' ',02,' ',02,' ',02,' ',02,' ',02,' ',02,' ',02,' ',02,' ',02,' ',02,' ',02,' ',02,' ',02,' ',02,' ',02,' ',02,' ',02,' ',02,' ',02,' ',02,' ',02,' ',02,' ',02,' ',02,' ',02,' ',02,' ',02,' ',02,' ',02,' ',02,' ',02,' ',02,' ',02,' ',02,' ',02,' ',02,' ',02,' ',02,' ',02,' ',02,' ',02,' ',02,' ',02,' ',02,' ',02,' ',14,'',14
 DB '',14,' ',14,'',07,'',07,'',07,'',07,'',07,'',07,'',07,'',07,'',07,'',07,'',07,'',07,'',07,'',07,'',07,'',07,'',07,'',07,'',07,'',07,'',07,'',07,'',07,'',07,'',07,'',07,'',07,'',07,'',07,'',07,'',07,'',07,'',07,'',07,'',07,'',07,'',07,'',07,'',07,'',07,'',07,'',07,'',07,'',07,'',07,'',07,'',07,'',07,'',07,'',07,'',07,'',07,'',07,'',07,'',07,'',07,'',07,'',07,'',07,'',07,'',07,'',07,'',07,'',07,'',07,'',07,'',07,'',07,'',07,'',07,'',07,'',07,'',07,'',07,'',07,'',07,' ',14,'',14
 DB '',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14,'',14
LOADMODUL_ADDR DD 100000h
LOADMODUL_PARSIZE DD 0         ; Anzahl Bytes an Parametern fr das Modul
LOADMODUL_FILESIZE DD 0        ; Gre des gesammten Eintrags
LOADMODUL_BSSSIZE DD 0         ; BSS
LOADMODUL_DATASIZE DD 0        ; .TEXT+.DATA
LOADMODUL_DATASIZEC DD 0
LOADMODUL_RELCOUNT DD 0        ; Reloc-Anzahl
LOADMODUL_CURRENTADDR DD 0
LOADMODUL_LASTADDR DD 0
LOADMODUL_PARPOS DD 0
LOADMODUL_COUNT DD 0
LOADMODUL:
  MOV EAX,[LOADMODUL_ADDR]       ; 
  MOV ECX,EAX                    ;  PAGEALIGN
  AND EAX,0FFFFF000h             ; 
  AND ECX,0FFFh                  ; 
  JZ LOADMODUL_PAGEALIGN         ; 
  ADD EAX,4096                   ; 
 LOADMODUL_PAGEALIGN:            ; 
  MOV [LOADMODUL_ADDR],EAX       ; 
  MOV EBX,[LOADMODUL_CURRENTADDR];  Zeiger einrichten.
  MOV [LOADMODUL_CURRENTADDR],EAX; 
  MOV [LOADMODUL_LASTADDR],EBX   ; 
  CALL READDWORD                 ;
  MOV [LOADMODUL_PARSIZE],EAX    ;
  OR EAX,EAX                     ;
  JZ LOADMODUL_SKIPPAR           ;
  MOV ECX,EAX                    ; 
  MOV EAX,[LOADMODUL_ADDR]       ; 
  MOV [LOADMODUL_PARPOS],EAX     ; 
  SUB ECX,4
  MOV [LOADMODUL_PARSIZE],ECX    ;
 LOADMODUL_COPY:                 ; 
  PUSH ECX                       ; 
  CALL READBYTE                  ; 
  POP ECX                        ; 
  MOV EDI,[LOADMODUL_ADDR]       ; 
  MOV [FS:EDI],AL                ; 
  INC EDI                        ; 
  MOV [LOADMODUL_ADDR],EDI       ; 
  DEC ECX                        ; 
  JNZ LOADMODUL_COPY             ; 
  MOV EAX,[LOADMODUL_ADDR]       ; 
  MOV ECX,EAX                    ;  PAGEALIGN
  AND EAX,0FFFFF000h             ; 
  AND ECX,0FFFh                  ; 
  JZ LOADMODUL_PAGEALIGN2        ; 
  ADD EAX,4096                   ; 
 LOADMODUL_PAGEALIGN2:           ; 
  MOV [LOADMODUL_ADDR],EAX       ; 
  MOV [LOADMODUL_CURRENTADDR],EAX
  JMP LOADMODUL_WITHPAR
 LOADMODUL_SKIPPAR:
  XOR EAX,EAX
  MOV [LOADMODUL_PARPOS],EAX
 LOADMODUL_WITHPAR:
  CALL READDWORD                 ; 
  OR EAX,EAX                     ; 
  JZ NEAR LOADMODUL_ABSEND       ;  Header lesen
  MOV [LOADMODUL_FILESIZE],EAX   ; 
  CALL READDWORD                 ; 
  MOV [LOADMODUL_BSSSIZE],EAX    ; 
  CALL READDWORD                 ; 
  MOV [LOADMODUL_RELCOUNT],EAX   ; 
  SHL EAX,2                      ; 
  MOV EBX,[LOADMODUL_FILESIZE]   ; 
  SUB EBX,EAX                    ; 
  SUB EBX,12                     ; 
  MOV [LOADMODUL_DATASIZE],EBX   ; 
  MOV [LOADMODUL_DATASIZEC],EBX  ;
  OR EBX,EBX
  JZ LOADMODUL_ENDCOPY
 LOADMODUL_COPYLOOP:
  CALL READBYTE
  MOV EDI,[LOADMODUL_ADDR]
  MOV [FS:EDI],AL
  INC EDI
  MOV [LOADMODUL_ADDR],EDI
  DEC DWORD [LOADMODUL_DATASIZEC]
  JNZ LOADMODUL_COPYLOOP
 LOADMODUL_ENDCOPY:
  MOV EAX,[LOADMODUL_ADDR]
  ADD EAX,[LOADMODUL_BSSSIZE]
  MOV [LOADMODUL_ADDR],EAX
  MOV EAX,[LOADMODUL_RELCOUNT]
  OR EAX,EAX
  JZ LOADMODUL_END
 LOADMODUL_RELOCLOOP:
  CALL READDWORD
  MOV EDI,[LOADMODUL_CURRENTADDR]
  ADD [FS:EDI+EAX],EDI
  DEC DWORD [LOADMODUL_RELCOUNT]
  JNZ LOADMODUL_RELOCLOOP
 LOADMODUL_END:
  MOV EDI,[LOADMODUL_CURRENTADDR]
  XOR EBX,EBX
  MOV [FS:EDI+4],EBX
  MOV EAX,[LOADMODUL_LASTADDR]
  OR EAX,EAX
  JZ LOADMODUL_PATCHLAST
  MOV [FS:EAX+4],EDI
 LOADMODUL_PATCHLAST:
  MOV EAX,[LOADMODUL_DATASIZE]
  MOV [FS:EDI+8],EAX
  MOV EAX,[LOADMODUL_BSSSIZE]
  MOV [FS:EDI+12],EAX
  MOV EAX,[LOADMODUL_PARPOS]
  MOV [FS:EDI+16],EAX
  MOV EAX,[LOADMODUL_PARSIZE]
  MOV [FS:EDI+20],EAX
  MOV EAX,1
 LOADMODUL_ABSEND:
  RET
%INCLUDE "KERNEL16\K16SUB.INC"
%INCLUDE "KERNEL16\REALMODE.INC"
KERNEL16_END:
