;ͻ
; Hier sollen die Realmode-Untersttzungsfunktionen eingebaut werden !      
;ͼ
KERNEL16_REALMODEDESC:
  DD 4096                      ; Gre des Realmode-Puffers
  DD KERNEL16_BUFFER           ; Zeiger auf den Realmode-Puffer
  DD KERNEL16_REALMODECMD      ; Zeiger auf den Kommandoblock
  DD KERNEL16_REALMODEEXC      ; Zeiger auf Prozedur zum Ausfhren
  DD KERNEL16_REALMODESTA      ; Zeiger auf den Realmode-Stapel
  DD 0                         ; Realmode-Segment fr KERNEL16 !
KERNEL16_REALMODEEXC:
  MOV AX,CS
  MOV DS,AX
  MOV SS,AX
  MOV ESP,[CS:KERNEL16_REALMODESTA]
  ADD ESP,4096
 KERNEL16_REALMODEEXC_WAIT:
  MOV EAX,[KERNEL16_REALMODECMD]
  OR EAX,EAX
  JNZ KERNEL16_REALMODEEXC_CMD
  INT 0FFh ; Schedule
  JMP KERNEL16_REALMODEEXC_WAIT
 KERNEL16_REALMODEEXC_CMD:
  CMP EAX,1
  JZ KERNEL16_CALLINTERRUPT
 KERNEL16_REALMODEEXC_CONTINUE:
  XOR EAX,EAX
  MOV [KERNEL16_REALMODECMD],EAX  
  JMP KERNEL16_REALMODEEXC_WAIT
KERNEL16_CALLINTERRUPT:
  XOR EAX,EAX
  MOV FS,AX
  MOV EAX,[KERNEL16_REALMODECMD+8]
  SHL EAX,2
  MOV EBX,[FS:EAX]
  MOV [KERNEL16_REALMODECMD+4],EBX
  MOV EAX,[KERNEL16_REALMODECMD+20]
  MOV ECX,[KERNEL16_REALMODECMD+24]
  MOV EDX,[KERNEL16_REALMODECMD+28]
  MOV EBX,[KERNEL16_REALMODECMD+32]
  MOV EDI,[KERNEL16_REALMODECMD+36]
  MOV ESI,[KERNEL16_REALMODECMD+40]
  MOV EBP,[KERNEL16_REALMODECMD+44]
  MOV ES,[KERNEL16_REALMODECMD+48]
  MOV FS,[KERNEL16_REALMODECMD+56]
  MOV GS,[KERNEL16_REALMODECMD+60]
  MOV DS,[KERNEL16_REALMODECMD+52]
  PUSHF
  CLI
  CALL FAR [CS:KERNEL16_REALMODECMD+4]
  MOV [CS:KERNEL16_REALMODECMD+52],DS
  PUSH CS
  POP DS
  MOV [KERNEL16_REALMODECMD+60],GS
  MOV [KERNEL16_REALMODECMD+56],FS
  MOV [KERNEL16_REALMODECMD+48],ES
  MOV [KERNEL16_REALMODECMD+44],EBP
  MOV [KERNEL16_REALMODECMD+40],ESI
  MOV [KERNEL16_REALMODECMD+36],EDI
  MOV [KERNEL16_REALMODECMD+32],EBX
  MOV [KERNEL16_REALMODECMD+28],EDX
  MOV [KERNEL16_REALMODECMD+24],ECX
  MOV [KERNEL16_REALMODECMD+20],EAX
  JMP KERNEL16_REALMODEEXC_CONTINUE
KERNEL16_REALMODECMD:
  DD 0                         ; Kommando
  DD 0,0,0,0                   ; Normale Parameter
  DD 0                         ; EAX
  DD 0                         ; ECX
  DD 0                         ; EDX
  DD 0                         ; EBX
  DD 0                         ; EDI
  DD 0                         ; ESI
  DD 0                         ; EBP
  DD 0                         ; ES
  DD 0                         ; DS
  DD 0                         ; FS
  DD 0                         ; GS
  DD 0                         ; Flags
KERNEL16_BUFFER TIMES 1024 DD 0
KERNEL16_REALMODESTA TIMES 1024 DD 0
