PROGRAM LD2;
{ Bitte noch mal .COMM Sektionen prfen ! }
USES DOS;
{$I-}
CONST FILETYPE_COFF=1;
TYPE PCOFF_FILEHEADER=^TCOFF_FILEHEADER;
     TCOFF_FILEHEADER=PACKED RECORD
      MAGIC:WORD;
      SECTIONC:WORD;
      TIMEDATE:DWORD;
      SYMBOLS:DWORD;
      SYMBOLC:DWORD;
      OPTHEADER:WORD;
      FLAGS:WORD;
     END;
TYPE PCOFF_SECTIONHEADER=^TCOFF_SECTIONHEADER;
     TCOFF_SECTIONHEADER=PACKED RECORD
      NAME:ARRAY[0..7] OF CHAR;
      PADDR:DWORD;
      VADDR:DWORD;
      SIZE:DWORD;
      DATAS:DWORD;
      RELOCS:DWORD;
      LINENUMBERS:DWORD;
      RELOCC:WORD;
      LINUNUMBERC:WORD;
      FLAGS:DWORD;
     END;
TYPE PCOFF_SYMBOL=^TCOFF_SYMBOL;
     TCOFF_SYMBOL=PACKED RECORD
      ZEROS,OFFSET:DWORD;
      VALUE:DWORD;
      SECTION:WORD;
      TYP:WORD;
      CLASS:BYTE;
      AUX:BYTE;
     END;
TYPE PCOFF_RELOC=^TCOFF_RELOC;
     TCOFF_RELOC=RECORD
      VADDR:DWORD;
      SYMBOL:DWORD;
      TYP:WORD;
     END;
TYPE PPATH=^TPATH;
     TPATH=RECORD
      NEXT,LAST:PPATH;
      PATH:STRING;
     END;
TYPE PADDRSYM=^TADDRSYM;
     TADDRSYM=RECORD
      NEXT,LAST:PADDRSYM;
      NAME:STRING;
      ID:DWORD;
      KNOWN:BOOLEAN;
      ADDR:DWORD;
      FILEID:DWORD;
      INDEX:DWORD;
     END;
TYPE PFILE=^TFILE;
     TFILE=RECORD
      NEXT,LAST:PFILE;
      TYP:DWORD;
      NAME:STRING;
      BSSSIZE:DWORD;
      DATASIZE:DWORD;
      TEXTSIZE:DWORD;
      COMMSIZE:DWORD;
      FILEID:DWORD;
     END;
TYPE PRELOC=^TRELOC;
     TRELOC=RECORD
      NEXT,LAST:PRELOC;
      SYMBOLID:DWORD;
      TYP:DWORD;
      ADDR:DWORD;
     END;
TYPE PPROGRAM=^TPROGRAM;
     TPROGRAM=OBJECT
      PATHS:PPATH;
      ADDRSYMS:PADDRSYM;
      FILES,LASTF:PFILE;
      RELOCS:PRELOC;
      PROCEDURE ADDRELOC(ADDR,ID,TYP:DWORD);
      PROCEDURE INVLDSYMBOLINDEX;
      PROCEDURE ADDSYMBOL(NAME:STRING;KNOWN:BOOLEAN;ADDR,FILID,INDEX:DWORD);
      PROCEDURE ADDFILE(TYP:DWORD;NAME:STRING;TEXT,DATA,COMM,BSS:DWORD);
      PROCEDURE ADDFILEPATH(PATH:STRING);
      FUNCTION FINDFILE(FILEN:STRING;VAR F:FILE):BOOLEAN;
      PROCEDURE LINKCOFF(FILEN:STRING);
      CONSTRUCTOR INIT;
      DESTRUCTOR DONE;
      FUNCTION LOADCFILE(FILEN:STRING):BOOLEAN;
      PROCEDURE RELEASECFILE;
      PROCEDURE LINKALL;
      PROCEDURE PROCESS_COFF(FILID:DWORD);
      FUNCTION FINDSYMBOLBYINDEX(INDEX:DWORD):DWORD;
      PROCEDURE MAKERELOCS;
      FUNCTION GETSYMBOLADDR(ID:DWORD):DWORD;
      PROCEDURE WRITERS3OUTPUT(FN:STRING);
      PRIVATE
      CFILE:POINTER;
      CFILESIZE:DWORD;
      BSSSIZE:DWORD;
      DATASIZE:DWORD;
      TEXTSIZE:DWORD;
      COMMSIZE:DWORD;
      BSSPOS:DWORD;
      DATAPOS:DWORD;
      TEXTPOS:DWORD;
      COMMPOS:DWORD;
      MEM:POINTER;
      SYMBOLID:DWORD;
      FILEID:DWORD;
     END;
PROCEDURE TPROGRAM.WRITERS3OUTPUT(FN:STRING);
VAR F:FILE;
    P:POINTER;
    P2:PRELOC;
    RELC:DWORD;
    REST:DWORD;
BEGIN
 ASSIGN(F,FN);
 REWRITE(F,1);
 BLOCKWRITE(F,BSSSIZE,4);
 P2:=RELOCS;
 RELC:=0;
 WHILE P2<>NIL DO
 BEGIN
  IF P2^.TYP=0 THEN INC(RELC);
  P2:=P2^.NEXT;
 END;
 BLOCKWRITE(F,RELC,4);
 REST:=TEXTSIZE+DATASIZE+COMMSIZE;
 P:=MEM;
 WHILE REST>0 DO
 BEGIN
  IF REST>32768 THEN
  BEGIN
   BLOCKWRITE(F,P^,32768);
   DEC(REST,32768);
   INC(P,32768);
  END
  ELSE
  BEGIN
   BLOCKWRITE(F,P^,REST);
   REST:=0;
  END;
 END;
 P2:=RELOCS;
 WHILE P2<>NIL DO
 BEGIN
  IF P2^.TYP=0 THEN BLOCKWRITE(F,P2^.ADDR,4);
  P2:=P2^.NEXT;
 END;
 CLOSE(F);
 P:=MEM;
END;
FUNCTION TPROGRAM.GETSYMBOLADDR(ID:DWORD):DWORD;
VAR P:PADDRSYM;
BEGIN
 P:=ADDRSYMS;
 WHILE P<>NIL DO
 BEGIN
  IF P^.ID=ID THEN
  BEGIN
   IF NOT P^.KNOWN THEN
   BEGIN
    WRITELN(P^.NAME);
    CLOSE(OUTPUT);
    ASSIGN(OUTPUT,'');
    REWRITE(OUTPUT);
    WRITELN('Symbol isn''t resolved !');
    HALT;
   END;
   GETSYMBOLADDR:=P^.ADDR;
   EXIT;
  END;
  P:=P^.NEXT;
 END;
END;
PROCEDURE TPROGRAM.MAKERELOCS;
VAR P:PRELOC;
    ADDR:DWORD;
    A:^DWORD;
BEGIN
 P:=RELOCS;
 WHILE P<>NIL DO
 BEGIN
  ADDR:=GETSYMBOLADDR(P^.SYMBOLID);
  A:=POINTER(MEM+P^.ADDR);
  IF P^.ADDR>=BSSSIZE+DATASIZE+TEXTSIZE+COMMSIZE THEN
  BEGIN
   CLOSE(OUTPUT);
   ASSIGN(OUTPUT,'');
   REWRITE(OUTPUT);
   WRITELN('????');
   WRITELN(P^.SYMBOLID);
   WRITELN(P^.ADDR);
   HALT;
  END;
  CASE P^.TYP OF
   0:
   BEGIN
    INC(A^,ADDR);
   END;
   1:
   BEGIN
    A^:=ADDR-P^.ADDR-4;
   END;
  END;
  P:=P^.NEXT;
 END;
END;
PROCEDURE TPROGRAM.ADDRELOC(ADDR,ID,TYP:DWORD);
VAR P:PRELOC;
BEGIN
 NEW(P);
 P^.NEXT:=RELOCS;
 P^.LAST:=NIL;
 P^.SYMBOLID:=ID;
 P^.TYP:=TYP;
 P^.ADDR:=ADDR;
 IF RELOCS<>NIL THEN RELOCS^.LAST:=P;
 RELOCS:=P;
END;
FUNCTION TPROGRAM.FINDSYMBOLBYINDEX(INDEX:DWORD):DWORD;
VAR P:PADDRSYM;
BEGIN
 P:=ADDRSYMS;
 WHILE P<>NIL DO
 BEGIN
  IF P^.INDEX=INDEX THEN
  BEGIN
   FINDSYMBOLBYINDEX:=P^.ID;
   EXIT;
  END;
  P:=P^.NEXT;
 END;
 FINDSYMBOLBYINDEX:=$FFFFFFFF;
END;
PROCEDURE TPROGRAM.INVLDSYMBOLINDEX;
VAR P:PADDRSYM;
BEGIN
 P:=ADDRSYMS;
 WHILE P<>NIL DO
 BEGIN
  P^.INDEX:=$FFFFFFFF;
  P:=P^.NEXT;
 END;
END;
PROCEDURE TPROGRAM.ADDSYMBOL(NAME:STRING;KNOWN:BOOLEAN;ADDR,FILID,INDEX:DWORD);
VAR P:PADDRSYM;
BEGIN
 P:=ADDRSYMS;
 WHILE P<>NIL DO
 BEGIN
  IF (P^.NAME=NAME) AND (P^.FILEID=FILID) THEN
  BEGIN
   IF KNOWN THEN
   BEGIN
    P^.ADDR:=ADDR;
    P^.KNOWN:=TRUE;
   END;
   P^.INDEX:=INDEX;
   EXIT;
  END;
  P:=P^.NEXT;
 END;
 NEW(P);
 P^.NEXT:=ADDRSYMS;
 P^.LAST:=NIL;
 P^.NAME:=NAME;
 P^.KNOWN:=KNOWN;
 P^.ADDR:=ADDR;
 P^.FILEID:=FILID;
 P^.INDEX:=INDEX;
 P^.ID:=SYMBOLID;
 IF ADDRSYMS<>NIL THEN ADDRSYMS^.LAST:=P;
 ADDRSYMS:=P;
 INC(SYMBOLID);
END;
PROCEDURE TPROGRAM.PROCESS_COFF(FILID:DWORD);
VAR BSSSECTION,DATASECTION,TEXTSECTION,COMMSECTION:DWORD;
    BSS,DATA,TEXT,COMM:DWORD;
    BSSP,DATAP,TEXTP,COMMP:POINTER;
    RELP:ARRAY[1..99] OF POINTER;
    RELC:ARRAY[1..99] OF DWORD;
    SECP:ARRAY[1..99] OF DWORD;
    P:POINTER;
    I,N,Z,SECTIONCOUNT,SYMBOLCOUNT:DWORD;
    STRINGP:POINTER;
    S:STRING;
BEGIN
 { Sektionen aufschlsseln }
 TEXT:=0;
 DATA:=0;
 BSS:=0;
 SECTIONCOUNT:=PCOFF_FILEHEADER(CFILE)^.SECTIONC;
 P:=CFILE+PCOFF_FILEHEADER(CFILE)^.OPTHEADER+SIZEOF(TCOFF_FILEHEADER);
 FOR I:=1 TO SECTIONCOUNT DO
 BEGIN
  WITH PCOFF_SECTIONHEADER(P)^ DO
  BEGIN
   WRITELN('SECTION ',I,'  ',NAME);
   RELP[I]:=CFILE+RELOCS;
   RELC[I]:=RELOCC;
   SECP[I]:=$FFFFFFFF;
   IF (NAME='/4') OR (NAME='.comment') THEN
   BEGIN
    COMMSECTION:=I;
    COMM:=SIZE;
    COMMP:=CFILE+DATAS;
    SECP[I]:=COMMPOS;
   END ELSE
   IF NAME='.text' THEN
   BEGIN
    TEXTSECTION:=I;
    TEXT:=SIZE;
    TEXTP:=CFILE+DATAS;
    SECP[I]:=TEXTPOS;
   END ELSE
   IF NAME='.data' THEN
   BEGIN
    DATASECTION:=I;
    DATA:=SIZE;
    DATAP:=CFILE+DATAS;
    SECP[I]:=DATAPOS;
   END ELSE
   IF NAME='.bss' THEN
   BEGIN
    BSSSECTION:=I;
    BSS:=SIZE;
    BSSP:=CFILE+DATAS;
    SECP[I]:=BSSPOS;
   END;
  END;
  INC(P,SIZEOF(TCOFF_SECTIONHEADER));
 END;
 { Hier Symbole verarbeiten }
 P:=CFILE+PCOFF_FILEHEADER(CFILE)^.SYMBOLS;
 SYMBOLCOUNT:=PCOFF_FILEHEADER(CFILE)^.SYMBOLC;
 STRINGP:=P+SYMBOLCOUNT*SIZEOF(TCOFF_SYMBOL);
 I:=0;
 WHILE SYMBOLCOUNT>0 DO
 BEGIN
  WITH PCOFF_SYMBOL(P)^ DO
  BEGIN
   IF ZEROS=0 THEN
   BEGIN
    S:=PCHAR(STRINGP+OFFSET);
   END
   ELSE
   BEGIN
    S:=PCHAR(P);
   END;
   IF POS(S,'-')<>0 THEN DELETE(S,POS(S,'-'),255);
   CASE CLASS OF
    2:
    BEGIN
     IF (SECTION=0) AND (VALUE=0) THEN
     BEGIN
      ADDSYMBOL(S,FALSE,0,0,I);
      WRITELN('ADD EXTERN ',S);
     END
     ELSE
     BEGIN
      IF SECTION<100 THEN
      BEGIN
       ADDSYMBOL(S,TRUE,SECP[SECTION]+VALUE,0,I);
       WRITELN('ADD INTERN ',S,'=',SECP[SECTION]+VALUE);
      END;
     END;
    END;
    3:
    BEGIN
     IF (SECTION>0) AND (SECTION<100) THEN
     BEGIN
      ADDSYMBOL(S,TRUE,SECP[SECTION]+VALUE,FILID,I);
      WRITELN('ADD PRIVAT ',S,'=',SECP[SECTION]+VALUE);
     END;
    END;
   END;
   DEC(SYMBOLCOUNT,AUX);
   INC(P,AUX*SIZEOF(TCOFF_SYMBOL));
   INC(I,AUX);
  END;
  INC(P,SIZEOF(TCOFF_SYMBOL));
  INC(I);
  DEC(SYMBOLCOUNT);
 END;
 { Hier Relocs verarbeiten }{ Fr alle Sektionen }
 FOR I:=1 TO SECTIONCOUNT DO
 BEGIN
  WRITELN('Relocs for Sektion ',I);
  P:=RELP[I];
  FOR N:=1 TO RELC[I] DO
  BEGIN
   WITH PCOFF_RELOC(P)^ DO
   BEGIN
    Z:=FINDSYMBOLBYINDEX(SYMBOL);
    IF Z=$FFFFFFFF THEN
    BEGIN
     CLOSE(OUTPUT);
     ASSIGN(OUTPUT,'');
     REWRITE(OUTPUT);
     WRITELN('Symbol nicht gefunden ! Dateifehler !');
     HALT;
    END;
    WRITELN('ADD RELOC : ',SECP[I],'/',VADDR,' (',I,'/',DWORD(P));
    CASE TYP OF
     6:ADDRELOC(SECP[I]+VADDR,Z,0);
     20:ADDRELOC(SECP[I]+VADDR,Z,1);
    END;
   END;
   INC(P,SIZEOF(TCOFF_RELOC));
  END;
 END;
 { Jetzt die Daten verschieben... File abschlieen}
 MOVE(TEXTP^,(MEM+TEXTPOS)^,TEXT);
 MOVE(DATAP^,(MEM+DATAPOS)^,DATA);
 MOVE(COMMP^,(MEM+COMMPOS)^,COMM);
 INC(TEXTPOS,TEXT);
 INC(DATAPOS,DATA);
 INC(BSSPOS,BSS);
 INC(COMMPOS,COMM);
END;
PROCEDURE TPROGRAM.LINKALL;
VAR P:PFILE;
BEGIN
 { 1. Gre des Programs ermitteln ! }
 P:=FILES;
 TEXTSIZE:=0;
 DATASIZE:=0;
 BSSSIZE:=0;
 COMMSIZE:=0;
 WHILE P<>NIL DO
 BEGIN
  INC(BSSSIZE,P^.BSSSIZE);
  INC(DATASIZE,P^.DATASIZE);
  INC(TEXTSIZE,P^.TEXTSIZE);
  INC(COMMSIZE,P^.COMMSIZE);
  P:=P^.NEXT;
 END;
 TEXTPOS:=0;
 DATAPOS:=TEXTPOS+TEXTSIZE;
 COMMPOS:=DATAPOS+DATASIZE;
 BSSPOS:=COMMPOS+COMMSIZE;
 { 2. Speicher reservieren ! }
 GETMEM(MEM,TEXTSIZE+DATASIZE+COMMSIZE+BSSSIZE);
 { 2. Alle Dateien abarbeiten ! }
 P:=FILES;
 WHILE P<>NIL DO
 BEGIN
  INVLDSYMBOLINDEX;
  LOADCFILE(P^.NAME);
  WRITELN('PROCESS FILE : ',P^.NAME);
  CASE P^.TYP OF
   FILETYPE_COFF:PROCESS_COFF(P^.FILEID);
  END;
  RELEASECFILE;
  P:=P^.NEXT;
 END;
END;
PROCEDURE TPROGRAM.ADDFILE(TYP:DWORD;NAME:STRING;TEXT,DATA,COMM,BSS:DWORD);
VAR P:PFILE;
BEGIN
 NEW(P);
 P^.NEXT:=NIL;
 P^.LAST:=LASTF;
 P^.TYP:=TYP;
 P^.NAME:=NAME;
 P^.BSSSIZE:=BSS;
 P^.DATASIZE:=DATA;
 P^.TEXTSIZE:=TEXT;
 P^.COMMSIZE:=COMM;
 P^.FILEID:=FILEID;
 INC(FILEID);
 IF LASTF<>NIL THEN LASTF^.NEXT:=P ELSE FILES:=P;
 LASTF:=P;
END;
PROCEDURE TPROGRAM.RELEASECFILE;
BEGIN
 FREEMEM(CFILE,CFILESIZE);
END;
FUNCTION TPROGRAM.LOADCFILE(FILEN:STRING):BOOLEAN;
VAR F:FILE;
    RL:DWORD;
    P:POINTER;
BEGIN
 LOADCFILE:=FINDFILE(FILEN,F);
 IF LOADCFILE THEN
 BEGIN
  CFILESIZE:=FILESIZE(F);
  GETMEM(CFILE,CFILESIZE);
  P:=CFILE;
  REPEAT
   BLOCKREAD(F,P^,32768,RL);
   INC(P,RL);
  UNTIL RL=0;
  CLOSE(F);
 END;
END;
PROCEDURE TPROGRAM.LINKCOFF(FILEN:STRING);
VAR COMM,I,BSS,DATA,TEXT:DWORD;
    P:PCOFF_SECTIONHEADER;
    SECTIONCOUNT:DWORD;
BEGIN
 IF NOT LOADCFILE(FILEN) THEN
 BEGIN
  WRITELN('COFF File ',FILEN,' not found !');
  EXIT;
 END;
 WRITELN('ADD COFF File ',FILEN);
 BSS:=0;
 DATA:=0;
 TEXT:=0;
 COMM:=0;
 SECTIONCOUNT:=PCOFF_FILEHEADER(CFILE)^.SECTIONC;
 P:=CFILE+PCOFF_FILEHEADER(CFILE)^.OPTHEADER+SIZEOF(TCOFF_FILEHEADER);
 FOR I:=1 TO SECTIONCOUNT DO
 BEGIN
  WITH P^ DO
  BEGIN
   IF NAME='.bss' THEN INC(BSS,SIZE) ELSE
   IF NAME='.data' THEN INC(DATA,SIZE) ELSE
   IF NAME='.text' THEN INC(TEXT,SIZE) ELSE
   IF (NAME='/4') OR (NAME='.comment') THEN INC(COMM,SIZE);
  END;
  INC(P);
 END;
 ADDFILE(FILETYPE_COFF,FILEN,TEXT,DATA,COMM,BSS);
 RELEASECFILE;
END;
FUNCTION TPROGRAM.FINDFILE(FILEN:STRING;VAR F:FILE):BOOLEAN;
VAR P:PPATH;
BEGIN
 ASSIGN(F,FILEN);
 RESET(F,1);
 IF IORESULT=0 THEN
 BEGIN
  FINDFILE:=TRUE;
  EXIT;
 END;
 P:=PATHS;
 WHILE P<>NIL DO
 BEGIN
  ASSIGN(F,P^.PATH+FILEN);
  RESET(F,1);
  IF IORESULT=0 THEN
  BEGIN
   FINDFILE:=TRUE;
   EXIT;
  END;
  P:=P^.NEXT;
 END;
 FINDFILE:=FALSE;
END;
PROCEDURE TPROGRAM.ADDFILEPATH(PATH:STRING);
VAR P:PPATH;
BEGIN
 WRITELN('NEW PATH : ',PATH);
 NEW(P);
 IF PATH[LENGTH(PATH)]<>'\' THEN PATH:=PATH+'\';
 P^.NEXT:=PATHS;
 P^.LAST:=NIL;
 P^.PATH:=PATH;
 IF PATHS<>NIL THEN PATHS^.LAST:=P;
 PATHS:=P;
END;
DESTRUCTOR TPROGRAM.DONE;
BEGIN
END;
CONSTRUCTOR TPROGRAM.INIT;
BEGIN
 PATHS:=NIL;
 ADDRSYMS:=NIL;
 FILES:=NIL;
 RELOCS:=NIL;
 SYMBOLID:=0;
 FILEID:=1;
END;
VAR PROG:PPROGRAM;
    I:DWORD;
    S:STRING;
    MODE:DWORD;
PROCEDURE COMMONLINE(S:STRING);
BEGIN
 CASE MODE OF
  0:
  BEGIN
   IF S<>'' THEN
   BEGIN
    IF S[1]<>'-' THEN
    BEGIN
     PROG^.LINKCOFF(S);
    END
    ELSE
    BEGIN
     IF S[2]='L' THEN
     BEGIN
      PROG^.ADDFILEPATH(COPY(S,3,LENGTH(S)));
     END;
     IF COPY(S,2,8)='-oformat'  THEN
     BEGIN
      MODE:=$FFFFFFFF;
     END;
    END;
   END;
  END;
  $FFFFFFFF:MODE:=0;
 END;
END;
PROCEDURE READRESOURCEFILE(S:STRING);
VAR T:TEXT;
BEGIN
 ASSIGN(T,S);
 RESET(T);
 IF IORESULT<>0 THEN EXIT;
 WHILE NOT EOF(T) DO
 BEGIN
  READLN(T,S);
  COMMONLINE(S);
 END;
 CLOSE(T);
END;
VAR FN:BOOLEAN;
BEGIN
 WRITELN('LINKER FOR RS3');
 ASSIGN(OUTPUT,'DEBUG.OUT');
 REWRITE(OUTPUT);
 NEW(PROG,INIT);
 S:=GETENV('LD_PREINC');
 WRITELN('LD_PREINC : ',S);
 IF S<>'' THEN PROG^.LINKCOFF(S);
 FOR I:=1 TO PARAMCOUNT DO
 BEGIN
  S:=PARAMSTR(I);
  WRITELN('PARAM : ',S);
  IF (MODE=0) AND (NOT FN) AND (S[1]<>'-') THEN FN:=TRUE ELSE
  BEGIN
   IF (S[1]='@') THEN READRESOURCEFILE(COPY(S,2,255)) ELSE COMMONLINE(S);
  END;
 END;
 PROG^.LINKALL;
 PROG^.MAKERELOCS;
 PROG^.WRITERS3OUTPUT('RES.BB');
 DISPOSE(PROG,DONE);
 CLOSE(OUTPUT);
END.
