  BITS 16
  ORG 0h
; Hier ist alles Hard-Wired auf 512 bytes pro Sektor...hab noch nie was
; anderes gesehen !
START:
  JMP SHORT MAIN
  NOP
  NOP
 LOADERSIZE DD LOADER_END-START
 MAIN:
  MOV AX,CS
  MOV DS,AX
  MOV [BOOTDRV],DL             ; 1. Informationen ber das Laufwerk ermitteln
  MOV [CURSECTOR],EDI
  MOV AH,8h                    ; 
  MOV DL,[BOOTDRV]             ;  Informationen ber das Bootlaufwerk
  INT 13h                      ;  ermitteln.
  MOV [LASTPAGE],DH            ;  (Die oberen 2 Bits von CL (Sektor),
  MOV AL,CL                    ;  werden fr die Bits 8 und 9 vom Track
  AND AL,00111111b             ;  benutzt.
  MOV [LASTSEC],AL             ; 
  MOV [LASTTRACK],CH           ; 
  SHR CL,6                     ; 
  MOV [LASTTRACK+1],CL         ; 
  MOV EDI,[CURSECTOR]
  CALL READSECTOR
  MOV ES,[AKTSEG]
  MOV EAX,[ES:4]               ; Gre des Kernel16 aus dem ersten Sektor ermitteln.
  MOV EBX,EAX
  SHR EBX,9                    ; Ich nehme mal 2^9 fr Sektorgre an
                               ; Unter Umstnden prfen...
  OR EBX,EBX
  JZ CALLKERNEL16
  TEST EAX,511
  JNZ NOHALFSECTOR
  DEC EBX
 NOHALFSECTOR:
  MOV [CURRESSIZE],EBX
  OR EBX,EBX                   ; Kernel16 nur 1 Sektor lang ?
  JZ CALLKERNEL16
 READKERNEL16LOOP:
  ADD WORD [AKTSEG],32
  INC DWORD [CURSECTOR]
  MOV EDI,[CURSECTOR]
  CALL READSECTOR  
  DEC DWORD [CURRESSIZE]
  JNZ READKERNEL16LOOP
 CALLKERNEL16:
  INC DWORD [CURSECTOR]
  MOV CX,CS
  MOV BX,EXTRN_READSECTOR
  MOV DX,2000h
  XOR SI,SI
  MOV DI,32768
  CALL FAR [STARTA]
  RETF
EXTRN_READSECTOR:
  PUSHAD
  PUSH ES
  PUSH DS
  MOV AX,CS
  MOV DS,AX
  MOV [AKTSEG],DWORD 2000h
  MOV [CURRESSIZE],DWORD 64
 LP:
  MOV EDI,[CURSECTOR]
  CALL READSECTOR
  ADD [AKTSEG],DWORD 32
  INC DWORD [CURSECTOR]
  DEC DWORD [CURRESSIZE]
  JNZ LP
  POP DS
  POP ES
  POPAD
  RETF
;ͻ
; READSECTOR                                                                
;  Funktion       : Liest einen SECTOR von Diskette.                        
;  Parameter      : EDI=SECTORnummer (0..x)                                 
;ͼ
READSECTOR:
  XOR EDX,EDX                  ; 
  MOV EAX,EDI                  ;  SECTOR entschlsseln.
  MOV EBX,[LASTSEC]            ; 
  DIV EBX                      ; 
  INC EDX                      ; 
  MOV [SECTOR_SE],EDX          ; 
  XOR EDX,EDX                  ; 
  MOV EBX,[LASTPAGE]           ;  Kopf entschlsseln.
  INC EBX                      ; 
  DIV EBX                      ; 
  MOV [SECTOR_PG],EDX          ; 
  XOR EDX,EDX                  ; 
  MOV EBX,[LASTTRACK]          ;  Track entschlsseln.
  INC EBX                      ; 
  DIV EBX                      ; 
  MOV [SECTOR_TR],EDX          ; 
  MOV [READSECTOR_TRY],BYTE 20 ; Anzahl versuche.
 READSECTOR_LP:
  MOV AX,201h                  ; 
  MOV DL,[BOOTDRV]             ;  Versuchen den SECTOR zu lesen.
  MOV DH,[SECTOR_PG]           ;  (SECTOR/Track Patch :
  MOV CH,[SECTOR_TR]           ;   Die obersten 2 Bits von CL (SECTOR),
  MOV CL,[SECTOR_SE]           ;   werden fr die Bits 8 und 9 vom Track
  MOV BL,[SECTOR_TR+1]         ;   benutzt !)
  SHL BL,6                     ; 
  OR CL,BL                     ; 
  LES BX,[AKTOFS]              ; 
  PUSH DS                      ; 
  INT 13h                      ; 
  POP DS                       ; 
  JNC READSECTOR_SUCCES        ; Konnte der SECTOR gelesen werden ?
  DEC BYTE [READSECTOR_TRY]    ; Ein Versuch weniger...
  JZ NEAR SECTORERR            ; Noch welche da ?
  XOR AX,AX
  MOV DL,[BOOTDRV]
  INT 13h
  JMP READSECTOR_LP
 READSECTOR_SUCCES:
  RET                          ; Fertig ?
SECTORERR:
 ; Was tun wenn ein SECTOR fehlerhaft ist ?
READSECTOR_TRY: DB 0           ; Zhler fr die Leseversuche auf Diskette.
SECTOR_PG: DD 0                ; Entschlsselter Kopf.
SECTOR_TR: DD 0                ; Entschlsselter Track.
SECTOR_SE: DD 0                ; Entschlsselter SECTOR.
LASTPAGE: DD 0                 ; Letzter Kopf.
LASTTRACK: DD 0                ; Letzter Track.
LASTSEC: DD 0                  ; Letzter SECTOR.
AKTOFS DW 0
AKTSEG DW 3000h
STARTA DW 0                    ; Aufruf-Struktur fr den Kernel16.
       DW 3000h
BOOTDRV DD 0
CURSECTOR DD 0                 ; Aktueller SECTOR
CURRESSIZE DD 0                ; Restliche SECTORen, die geladen werden men
LOADER_END:
