TYPE PDESKTOPCMDDESC=^TDESKTOPCMDDESC;
     TDESKTOPCMDDESC=RECORD
      NEXT,LAST:PDESKTOPCMDDESC;
      CMD:PCHAR;
      PROC:PROCEDURE(P:PCHAR);
     END;
VAR FIRSTDESKTOPCMD:PDESKTOPCMDDESC;
    DESKTOPCMDLOCK:TLOCK;
PROCEDURE ADDDESKTOPCMD(P:PDESKTOPCMDDESC);
BEGIN
 GETLOCK(@DESKTOPCMDLOCK);
 P^.NEXT:=FIRSTDESKTOPCMD;
 P^.LAST:=NIL;
 IF FIRSTDESKTOPCMD<>NIL THEN FIRSTDESKTOPCMD^.LAST:=P;
 FIRSTDESKTOPCMD:=P;
 FREELOCK(@DESKTOPCMDLOCK);
END;
PROCEDURE REMOVEDESKTOPCMD(P:PDESKTOPCMDDESC);
BEGIN
 GETLOCK(@DESKTOPCMDLOCK);
 IF P^.LAST<>NIL THEN P^.LAST^.NEXT:=P^.NEXT ELSE FIRSTDESKTOPCMD:=P^.NEXT;
 IF P^.NEXT<>NIL THEN P^.NEXT^.LAST:=P^.LAST;
 FREELOCK(@DESKTOPCMDLOCK);
END;
CONST DESKTOP_PROT1:ARRAY[0..1] OF POINTER=(
       @ADDDESKTOPCMD,
       @REMOVEDESKTOPCMD);
VAR DESK:PDESKTOP;
    B_END:PBUTTON;
    NORMALAREA:POBJ;
VAR DESKTOP_USERS:DWORD;
    SHUTDOWNTASK:POINTER;
    SHUTDOWNMODE:LONGBOOL;
PROCEDURE DEINITIALIZEDESKTOPDRV;
BEGIN
 RELEASEDEBUGSYS;
 SHUTDOWNTASK:=GETTASKHANDLE();
 SHUTDOWNMODE:=TRUE;
 IF DESKTOP_USERS<>0 THEN DISABLETASK(SHUTDOWNTASK);
 DISPOSE(DESK,DONE);
 WRITELNSTR('DESKTOP_DONE.');
 SIGNALSHUTDOWNOK;
 HALT;
END;
PROCEDURE FREEDESKTOPPROT(NR:DWORD);
BEGIN
 CASE NR OF
  1:
  BEGIN
   DECATOM(@DESKTOP_USERS);
   IF (SHUTDOWNMODE) AND (DESKTOP_USERS=0) THEN ENABLETASK(SHUTDOWNTASK);
  END;
 END;
END;
CONST DESKTOP_PROT0:ARRAY[0..1] OF POINTER=(
       @DEINITIALIZEDESKTOPDRV,
       @FREEDESKTOPPROT);
FUNCTION DOCK_DESKTOP(NR:DWORD):POINTER;
BEGIN
 CASE NR OF
  0:DOCK_DESKTOP:=@DESKTOP_PROT0;
  1:
  BEGIN
   INCATOM(@DESKTOP_USERS);
   DOCK_DESKTOP:=@DESKTOP_PROT1;
  END;
  ELSE DOCK_DESKTOP:=NIL;
 END;
END;
CONST DESKTOPDRV:TDRIVER=(NEXT:NIL;LAST:NIL;TYP:$13;ID:0;GETPROT:@DOCK_DESKTOP;
                          DESC:'Desktop driver ()');
PROCEDURE S_END(SENDER:PBUTTON);
BEGIN
 SHUTDOWN(NIL);
END;
