PROGRAM GUI;
{$ASMMODE INTEL}
USES GRAPH,MOUSE,KEYB,MEMORY;
{ IDEE : Objekte die als FOCUS-Ziele benutzt werden sollten einen
         Zhler enthalten, so knnen berflssige Suchen vermieden werden,
         sollte das Objekt gelscht werden ! Das sollte demnach auch zu
         einem Sonderfall verkommen, wenn die Objekte der Anwendungsprogramme
         richtig programmiert sind ! }
{$I ..\INCLUDE\GUI.DEF}
VAR MOUSEX,MOUSEY:LONGINT;
    MOUSEB:DWORD;
    GUIBH:POINTER;
    OLDMOUSEX,OLDMOUSEY:LONGINT;
    OLDMOUSEB:DWORD;
TYPE POBJ=^TOBJ;
     TOBJ=RECORD
      NEXT,LAST,OVER,UNDER,UNDERL:POBJ;
      INEXT,ILAST,IUNDER,IUNDERL:POBJ;
      GROUP,APP:POBJ;
      WIN:TWIN;
      X,Y:LONGINT;
      H,B:DWORD;
      VIS,MOUSETRANSP:LONGBOOL;      
      CALLP:PROCEDURE(MSG:DWORD;P:POINTER);
      DATAP:POINTER;
      USER:POINTER;
      MOUSEPIC:PPICTURE;
      MOUSEHX,MOUSEHY:DWORD;
      SELECTED,FOCUS:LONGBOOL;
      SEF,FOCF:LONGBOOL;
     END;
VAR OBJ_LOCK:TLOCK;
    OBJ_READ:TREADSTAT;
    REDRAW_LOCK:TLOCK;
    MOUSEFOC,ROOTOBJ:POBJ;
    CURMOUSEPIC:PPICTURE;
    CURMOUSEHX,CURMOUSEHY:DWORD;
    STOPGUI:LONGBOOL;
    FOCUS:POBJ;
PROCEDURE FOCUSOBJECT(Z:POBJ);
VAR P:POBJ;
    RH:DWORD;
BEGIN
 { Eventuell sollte hier ein FOCUS-Lock rein. Es herrscht sonst bei
   rekursiv-Aufrufen das totale Chaos ! }
 RH:=STARTREAD(@OBJ_READ);
 { Hier auf das zugehrige Gruppenobjekt gehen... }
 WHILE Z^.GROUP<>NIL DO Z:=Z^.GROUP;
 { Hier men eventuelle Unterobjekte ausgewhlt werden, aber erst mssen
   entsprechende Flags gesetzt werden ! }
 { Zielpfad markieren }
 IF Z=FOCUS THEN
 BEGIN
  STOPREAD(@OBJ_READ,RH);
  EXIT;
 END;
 Z^.FOCF:=TRUE;
 P:=Z^.OVER;
 WHILE P<>NIL DO
 BEGIN
  P^.SEF:=TRUE;
  P:=P^.OVER;
 END;
 { Alten Pfad entmarkieren... }
 IF FOCUS<>NIL THEN
 BEGIN
  IF NOT FOCUS^.SEF THEN FOCUS^.CALLP(GUIMSG_NSELECT,FOCUS^.DATAP);
  FOCUS^.FOCUS:=FALSE;
  P:=FOCUS^.OVER;
  WHILE P<>NIL DO
  BEGIN
   IF NOT (P^.SEF OR P^.FOCF) THEN
   BEGIN
    P^.CALLP(GUIMSG_NSELECT,P^.DATAP);
    P^.SELECTED:=FALSE;
   END;  
   P:=P^.OVER;
  END;
 END;
 { Neuen Pfad verarbeiten... }
 Z^.CALLP(GUIMSG_FOCUS,Z^.DATAP);
 Z^.FOCUS:=TRUE;
 Z^.FOCF:=FALSE;
 Z^.SELECTED:=FALSE;
 P:=Z^.OVER;
 WHILE P<>NIL DO
 BEGIN
  IF NOT P^.SELECTED THEN
  BEGIN
   P^.CALLP(GUIMSG_SELECT,P^.DATAP);
   P^.SELECTED:=TRUE;
  END;
  P^.SEF:=FALSE;
  P:=P^.OVER;
 END;
 FOCUS:=Z;
 STOPREAD(@OBJ_READ,RH);
END;
FUNCTION GETOBJATABSPOS(X,Y:LONGINT):POBJ;
VAR P,P2:POBJ;
    DUMMYC:DWORD;
BEGIN   
 P:=NIL;
 P2:=ROOTOBJ;
 DUMMYC:=0;
 WHILE P2<>NIL DO
 BEGIN
  IF (P2^.WIN.VIS) AND
     (P2^.WIN.ADDX<=X) AND
     (P2^.WIN.ADDY<=Y) AND
     (P2^.WIN.ADDX+P2^.WIN.MAXX>=X) AND
     (P2^.WIN.ADDY+P2^.WIN.MAXY>=Y) THEN
  BEGIN
   P:=P2;
   { Die DUMMYC Technik sieht nicht gut aus, sollte besser ein Zeiger
     installiert werden, der an der "richtigen" Stelle fortsetzt als das ! }
   IF P^.MOUSETRANSP THEN INC(DUMMYC);
   IF (DUMMYC<>0) AND (P2^.UNDERL=NIL) THEN
   BEGIN
    P2:=P2^.LAST;
    DEC(DUMMYC);
   END ELSE P2:=P2^.UNDERL;
  END
  ELSE
  BEGIN
   IF (P<>NIL) AND (NOT P^.MOUSETRANSP) THEN
   BEGIN
    IF P2^.LAST=NIL THEN
    BEGIN
     WHILE (DUMMYC<>0) DO
     BEGIN
      P2:=P2^.OVER;
      DEC(DUMMYC);
     END;
    END;
   END;
   P2:=P2^.LAST;
  END;
 END;
 GETOBJATABSPOS:=P;
END;
VAR REDRAWFRAME:TWIN;
    REDRAW:LONGBOOL;
PROCEDURE MSG_REDRAW;
VAR P:POBJ;
    UNDERN:LONGBOOL;
    RH:DWORD;
BEGIN
 RH:=STARTREAD(@OBJ_READ);
 GETLOCK(@REDRAW_LOCK);
 SETAREABW(@REDRAWFRAME);
 FREELOCK(@REDRAW_LOCK);
 REDRAW:=FALSE;
 REDRAWFRAME.VIS:=FALSE;
 P:=ROOTOBJ;
 WHILE P<>NIL DO
 BEGIN
  UNDERN:=SETWIN(@P^.WIN);
  IF UNDERN THEN P^.CALLP(GUIMSG_PAINT,P^.DATAP);
  IF UNDERN AND (P^.UNDER<>NIL) THEN P:=P^.UNDER ELSE
  BEGIN
   IF P^.NEXT<>NIL THEN P:=P^.NEXT ELSE
   BEGIN
    WHILE (P^.OVER<>NIL) AND (P^.OVER^.NEXT=NIL) DO P:=P^.OVER;
    IF P^.OVER<>NIL THEN P:=P^.OVER^.NEXT ELSE P:=NIL;
   END;
  END;
 END;
 SHOW();
 STOPREAD(@OBJ_READ,RH);
 DISABLETASK(GUIBH);
END;
PROCEDURE REDRAWAREA(P:PWIN);
VAR O:TWIN;
BEGIN
 GETLOCK(@REDRAW_LOCK);
 IF NOT REDRAW THEN
 BEGIN
  REDRAWFRAME:=P^;
  ENABLETASK(GUIBH);  
  REDRAW:=TRUE;
 END
 ELSE
 BEGIN
  O:=REDRAWFRAME;
  IF P^.ADDX<O.ADDX THEN
  BEGIN
   INC(REDRAWFRAME.MAXX,O.ADDX-P^.ADDX);
   REDRAWFRAME.ADDX:=P^.ADDX;
  END;
  IF P^.ADDY<O.ADDY THEN
  BEGIN
   INC(REDRAWFRAME.MAXY,O.ADDY-P^.ADDY);
   REDRAWFRAME.ADDY:=P^.ADDY;
  END;
  IF O.ADDX+O.MAXX<P^.ADDX+P^.MAXX THEN REDRAWFRAME.MAXX:=P^.ADDX+P^.MAXX-REDRAWFRAME.ADDX;
  IF O.ADDY+O.MAXY<P^.ADDY+P^.MAXY THEN REDRAWFRAME.MAXY:=P^.ADDY+P^.MAXY-REDRAWFRAME.ADDY;
 END;
 FREELOCK(@REDRAW_LOCK);
END;
PROCEDURE REDRAWOBJ(P:POBJ);
VAR RH:DWORD;
BEGIN
 RH:=STARTREAD(@OBJ_READ);
 { OBJEXISTS? }
 IF P^.WIN.VIS THEN REDRAWAREA(@P^.WIN);
 STOPREAD(@OBJ_READ,RH);
END;
PROCEDURE CALCWINS(P:POBJ);
VAR LEVEL:LONGINT;
    S:POBJ;
BEGIN
 IF P^.OVER<>NIL THEN
 BEGIN
  CREATESUBWIN(@P^.OVER^.WIN,P^.X,P^.Y,P^.H,P^.B,P^.VIS,P^.WIN);
 END ELSE CREATEABSWIN(P^.X,P^.Y,P^.H,P^.B,P^.VIS,P^.WIN);
 IF P^.UNDER=NIL THEN EXIT;
 S:=P;
 P:=P^.UNDER;
 LEVEL:=1;
 WHILE LEVEL>0 DO
 BEGIN
  CREATESUBWIN(@S^.WIN,P^.X,P^.Y,P^.H,P^.B,P^.VIS,P^.WIN);
  IF (P^.UNDER<>NIL) THEN
  BEGIN
   S:=P;
   P:=P^.UNDER;
   INC(LEVEL);
  END
  ELSE
  BEGIN
   IF P^.NEXT<>NIL THEN P:=P^.NEXT ELSE
   BEGIN
    WHILE (P^.OVER<>NIL) AND (P^.OVER^.NEXT=NIL) DO
    BEGIN
     P:=P^.OVER;
     DEC(LEVEL);
    END;
    DEC(LEVEL);
    IF P^.OVER<>NIL THEN P:=P^.OVER^.NEXT ELSE P:=NIL;
    S:=P^.OVER;
   END;
  END;
 END;
END;
PROCEDURE BRINGTOFRONT(P:POBJ);
VAR RH:DWORD;
BEGIN
 RH:=STARTREAD(@OBJ_READ);
 IF (P^.NEXT=NIL) THEN
 BEGIN
  STOPREAD(@OBJ_READ,RH);
  EXIT;
 END;
 IF P^.LAST<>NIL THEN P^.LAST^.NEXT:=P^.NEXT ELSE P^.OVER^.UNDER:=P^.NEXT;
 P^.NEXT^.LAST:=P^.LAST;
 P^.LAST:=P^.OVER^.UNDERL;
 IF P^.LAST<>NIL THEN P^.LAST^.NEXT:=P;
 P^.NEXT:=NIL;
 P^.OVER^.UNDERL:=P;
 IF P^.WIN.VIS THEN REDRAWAREA(@P^.WIN);
 STOPREAD(@OBJ_READ,RH);
END;
PROCEDURE MOVESIZEOBJECT(P:POBJ;X,Y:LONGINT;H,B:DWORD);
VAR RH:DWORD;
BEGIN
 RH:=STARTREAD(@OBJ_READ);
 { OBJEXISTS? }
 IF (X<>P^.X) OR (Y<>P^.Y) OR (H<>P^.H) OR (B<>P^.B) THEN
 BEGIN
  IF P^.WIN.VIS THEN REDRAWAREA(@P^.WIN);
  P^.X:=X;
  P^.Y:=Y;
  P^.H:=H;
  P^.B:=B;
  CALCWINS(P);
  IF P^.WIN.VIS THEN REDRAWAREA(@P^.WIN);
 END;
 STOPREAD(@OBJ_READ,RH);
END;
PROCEDURE SIZEOBJECT(P:POBJ;H,B:DWORD);
VAR RH:DWORD;
BEGIN
 RH:=STARTREAD(@OBJ_READ);
 { OBJEXISTS? }
 IF (H<>P^.H) OR (B<>P^.B) THEN
 BEGIN
  IF P^.WIN.VIS THEN REDRAWAREA(@P^.WIN);
  P^.H:=H;
  P^.B:=B;
  CALCWINS(P);
  IF P^.WIN.VIS THEN REDRAWAREA(@P^.WIN);
 END;
 STOPREAD(@OBJ_READ,RH);
END;
PROCEDURE MOVEOBJECT(P:POBJ;X,Y:LONGINT);
VAR RH:DWORD;
BEGIN
 RH:=STARTREAD(@OBJ_READ); 
 { OBJEXISTS? }
 IF (X<>P^.X) OR (Y<>P^.Y) THEN
 BEGIN
  IF P^.WIN.VIS THEN REDRAWAREA(@P^.WIN);
  P^.X:=X;
  P^.Y:=Y;
  CALCWINS(P);
  IF P^.WIN.VIS THEN REDRAWAREA(@P^.WIN);
 END;
 STOPREAD(@OBJ_READ,RH);
END;
FUNCTION CREATEOBJECT(BAS,GROUP:POBJ;X,Y:LONGINT;H,B:DWORD;VIS:LONGBOOL;C,D:POINTER):POBJ;
BEGIN
 NEW(CREATEOBJECT);
 GETLOCK(@OBJ_LOCK);
 WHILE (BAS<>NIL) AND (BAS^.APP<>NIL) DO BAS:=BAS^.APP;
 WHILE (GROUP<>NIL) AND (GROUP^.GROUP<>NIL) DO GROUP:=GROUP^.GROUP;
 POINTER(CREATEOBJECT^.CALLP):=C;
 CREATEOBJECT^.SELECTED:=FALSE;
 CREATEOBJECT^.FOCUS:=FALSE;
 CREATEOBJECT^.SEF:=FALSE;
 CREATEOBJECT^.FOCF:=FALSE;
 CREATEOBJECT^.DATAP:=D;
 CREATEOBJECT^.X:=X;
 CREATEOBJECT^.Y:=Y;
 CREATEOBJECT^.H:=H;
 CREATEOBJECT^.B:=B;
 CREATEOBJECT^.VIS:=VIS;
 CREATEOBJECT^.USER:=NIL; { System ! }
 CREATEOBJECT^.LAST:=NIL;
 CREATEOBJECT^.ILAST:=NIL;
 CREATEOBJECT^.UNDER:=NIL;
 CREATEOBJECT^.UNDERL:=NIL;
 CREATEOBJECT^.IUNDER:=NIL;
 CREATEOBJECT^.OVER:=BAS;
 CREATEOBJECT^.GROUP:=GROUP;
 CREATEOBJECT^.APP:=NIL;
 CREATEOBJECT^.MOUSETRANSP:=FALSE;
 CREATEOBJECT^.MOUSEPIC:=NIL;
 IF BAS=NIL THEN
 BEGIN
  CREATEABSWIN(X,Y,H,B,VIS,CREATEOBJECT^.WIN);
  CREATEOBJECT^.NEXT:=NIL;
  CREATEOBJECT^.INEXT:=NIL;
  ROOTOBJ:=CREATEOBJECT;
 END
 ELSE
 BEGIN
  CREATESUBWIN(@BAS^.WIN,X,Y,H,B,VIS,CREATEOBJECT^.WIN);
  CREATEOBJECT^.NEXT:=BAS^.UNDER;
  IF CREATEOBJECT^.NEXT<>NIL THEN CREATEOBJECT^.NEXT^.LAST:=CREATEOBJECT
   ELSE BAS^.UNDERL:=CREATEOBJECT;
  BAS^.UNDER:=CREATEOBJECT;
  CREATEOBJECT^.INEXT:=BAS^.IUNDER;
  IF CREATEOBJECT^.ILAST<>NIL THEN CREATEOBJECT^.ILAST^.INEXT:=CREATEOBJECT
   ELSE BAS^.IUNDER:=CREATEOBJECT;
  BAS^.IUNDERL:=CREATEOBJECT;
 END;
 FREELOCK(@OBJ_LOCK);
END;
{ Das ist das System-Interface hier !!! }
{ Die Untergeordneten GUI-Objekte werden so nicht gelscht, es soll nur
  ein Signal gesendet werden, da das Handle nicht mehr gltig ist...
  kann fr ein internes Delete verwendet werden...mal schauen ! }
{ Das Interne Delete braucht ein DELETE-Lock oder ?...wie geht das ?
  Der DESTROYOBJECT-Aufruf mu innerhalb dieses Locks erfolgen, und
  falls ein auto-del besteht, darf bei FALSE nicht deinitialisiert werden.
  (sonst ist es doppelt !) Kein Signal fr DESTROYOBJ-Sender !}
PROCEDURE UNLINKOBJ(P:POBJ);
BEGIN
 { Ist das Sicher ??? Sollte nochmal ne Technik rein, damit es keine
   Probleme mit dem Signales gibt ! }
 IF P=FOCUS THEN FOCUS:=NIL;
 IF P=MOUSEFOC THEN MOUSEFOC:=NIL;
 { --- }
 IF P^.LAST<>NIL THEN P^.LAST^.NEXT:=P^.NEXT ELSE
 BEGIN
  IF P^.OVER<>NIL THEN P^.OVER^.UNDER:=P^.NEXT ELSE ROOTOBJ:=NIL;
 END;
 IF P^.NEXT<>NIL THEN P^.NEXT^.LAST:=P^.LAST ELSE P^.OVER^.UNDERL:=P^.LAST;
 WAITFORREADCYCL(@OBJ_READ);
 { Hier noch den Speicher freigeben ! }
END;
FUNCTION DESTROYOBJECT(BAS:POBJ):BOOLEAN;
VAR P,P2:POBJ;
BEGIN
 GETLOCK(@OBJ_LOCK);
 { Baum-basierendes DESTR ? }
 { Done-Signale echoen. }
 { 1. Feststellen, ob das Objekt berhaupt noch existiert (++) }
  { Wird zunchst als WAHR angenommen ! }
 { Das erste Objekt lschen, kein Signal ! }
 UNLINKOBJ(BAS);
 FOCUS:=NIL;
 MOUSEFOC:=NIL;
{ P:=BAS^.UNDER;
 WHILE P<>NIL DO
 BEGIN
  P2:=P;
  IF P^.UNDER<>NIL THEN P:=P^.UNDER ELSE
  BEGIN
   IF P^.NEXT<>NIL THEN P:=P^.NEXT ELSE
   BEGIN
    WHILE (P<>NIL) AND (P^.OVER<>NIL) AND (P^.OVER^.NEXT=NIL) DO
    BEGIN
     IF P=BAS THEN P:=NIL ELSE P:=P^.OVER;
    END;
    IF P^.OVER^.NEXT<>NIL THEN P:=P^.OVER^.NEXT ELSE P:=NIL;
   END;
  END;
  { Hier : Signal-Handleinvalidate senden ! Noch implementieren ! }
  UNLINKOBJ(P2);
 END;}
 FREELOCK(@OBJ_LOCK);
 DESTROYOBJECT:=TRUE;
END;
VAR MSG_MOUSEX,MSG_MOUSEY:LONGINT;
PROCEDURE MSG_MOUSE;
VAR XMOVE,YMOVE:LONGINT;
    T:POBJ;
    RH:DWORD;
BEGIN
 GETMOUSEMSG(MOUSEB,XMOVE,YMOVE);
 INC(MOUSEX,XMOVE);
 INC(MOUSEY,YMOVE);
 IF MOUSEX<0 THEN MOUSEX:=0;
 IF MOUSEY<0 THEN MOUSEY:=0;
 IF MOUSEX>GRAPH.WIDTH-1 THEN MOUSEX:=GRAPH.WIDTH-1;
 IF MOUSEY>GRAPH.HEIGHT-1 THEN MOUSEY:=GRAPH.HEIGHT-1;
 { Mausdatenverarbeitung... }
 RH:=STARTREAD(@OBJ_READ);
 T:=GETOBJATABSPOS(MOUSEX,MOUSEY);
 IF T<>NIL THEN
 BEGIN
  IF (MOUSEB<>0) AND (OLDMOUSEB=0) THEN
  BEGIN
   { Hier war vorher eine Hilfe fr "Modal", diese sollte durch eine
     bessere FOCUS-Technik berflssig werden ! }
   MOUSEFOC:=T;
   FOCUSOBJECT(MOUSEFOC);
  END;
  IF (MOUSEB=0) OR (OLDMOUSEB=0) THEN
  BEGIN
   CURMOUSEPIC:=T^.MOUSEPIC;
   CURMOUSEHX:=T^.MOUSEHX;
   CURMOUSEHY:=T^.MOUSEHY;
  END;
 END;
 IF MOUSEFOC<>NIL THEN
 BEGIN
  WITH MOUSEFOC^ DO
  BEGIN
   MSG_MOUSEX:=MOUSEX-WIN.ADDX+WIN.SUBX;
   MSG_MOUSEY:=MOUSEY-WIN.ADDY+WIN.SUBY;
   CALLP(GUIMSG_MOUSE,DATAP);
  END;
 END;
 STOPREAD(@OBJ_READ,RH);
 OLDMOUSEX:=MOUSEX;
 OLDMOUSEY:=MOUSEY;
 OLDMOUSEB:=MOUSEB;
 GRAPH.SETMOUSE(MOUSEX,MOUSEY,CURMOUSEPIC,CURMOUSEHX,CURMOUSEHY);
 { Hier kann MOUSEFOC wieder freigegeben werden... }
 { Es mu nur darauf geachtet werden, da MOUSEFOC auf NIL gesetzt werden
   mu, wenn das OBJEKT gelscht wurde ! }
 DISABLETASK(GUIBH);
END;
VAR KEYFLAGS,KEYCODE,KCHAR:DWORD;
PROCEDURE MSG_KEYB;
VAR RH:DWORD;
BEGIN
 READKEY(KEYFLAGS,KEYCODE);
 KCHAR:=CONVERTKEYTOCHAR(KEYFLAGS,KEYCODE);
 RH:=STARTREAD(@OBJ_READ);
 IF (KEYCODE=$7F000007) AND (ROOTOBJ<>NIL) THEN REDRAWOBJ(ROOTOBJ) ELSE
 BEGIN
  IF FOCUS<>NIL THEN FOCUS^.CALLP(GUIMSG_KEY,FOCUS^.DATAP);
 END;
 STOPREAD(@OBJ_READ,RH);
 DISABLETASK(GUIBH);
END;
VAR GUI_USERS:DWORD;
    GUI_SHUTDOWNTASK:POINTER;
    GUI_SHUTDOWNMODE:LONGBOOL;
PROCEDURE DEINITIALIZEGUIDRV;
BEGIN
 WRITELNSTR('GUI INI');
 GUI_SHUTDOWNTASK:=GETTASKHANDLE();
 GUI_SHUTDOWNMODE:=TRUE;
 IF GUI_USERS<>0 THEN DISABLETASK(GUI_SHUTDOWNTASK);
 STOPGUI:=TRUE;
 ENABLETASK(GUIBH);
 WHILE GUIBH<>NIL DO SCHEDULE;
 WRITELNSTR('GUI DONE.');
 SIGNALSHUTDOWNOK;
 HALT;
END;
PROCEDURE FREEGUIPROT(NR:DWORD);
BEGIN
 CASE NR OF
  1,2:
  BEGIN
   DECATOM(@GUI_USERS);
   IF GUI_SHUTDOWNMODE AND (GUI_USERS=0) THEN ENABLETASK(GUI_SHUTDOWNTASK);
  END;
 END;
END;
PROCEDURE GETGUIMESSAGEDATA_MOUSE(VAR X,Y:LONGINT;VAR B,OB:DWORD;VAR AX,AY:LONGINT);
BEGIN
 X:=MSG_MOUSEX;
 Y:=MSG_MOUSEY;
 B:=MOUSEB;
 OB:=OLDMOUSEB;
 AX:=MOUSEX;
 AY:=MOUSEY;
END;
PROCEDURE GETGUIMESSAGEDATA_KEYB(VAR FLAGS,CODE,CH:DWORD);
BEGIN
 FLAGS:=KEYFLAGS;
 CODE:=KEYCODE;
 CH:=KCHAR;
END;
PROCEDURE SETMOUSEPIC(P:POBJ;PIC:PPICTURE;HX,HY:LONGINT);
BEGIN
 P^.MOUSEPIC:=PIC;
 P^.MOUSEHX:=HX;
 P^.MOUSEHY:=HY;
END;
CONST GUI_PROT2:ARRAY[0..1] OF POINTER=(
       @GETGUIMESSAGEDATA_MOUSE,
       @GETGUIMESSAGEDATA_KEYB);
CONST GUI_PROT1:ARRAY[0..9] OF POINTER=(
       @GETGRAPHDRIVER,
       @CREATEOBJECT,
       @REDRAWOBJ,
       @SETMOUSEPIC,
       @MOVEOBJECT,
       @SIZEOBJECT,
       @MOVESIZEOBJECT,
       @BRINGTOFRONT,
       @FOCUSOBJECT,
       @DESTROYOBJECT);
CONST GUI_PROT0:ARRAY[0..1] OF POINTER=(
       @DEINITIALIZEGUIDRV,
       @FREEGUIPROT);
FUNCTION DOCK_GUI(NR:DWORD):POINTER;
BEGIN
 CASE NR OF
  0:DOCK_GUI:=@GUI_PROT0;
  1:
  BEGIN
   INCATOM(@GUI_USERS);
   DOCK_GUI:=@GUI_PROT1;
  END;
  2:
  BEGIN
   INCATOM(@GUI_USERS);
   DOCK_GUI:=@GUI_PROT2;
  END;
  ELSE DOCK_GUI:=NIL;
 END;
END;
PROCEDURE CENTRALGUITASK;
BEGIN
 ASM
   STI
 END;
 DISABLETASK(GUIBH);
 REPEAT
  WHILE MOUSEMSGEXISTS() DO MSG_MOUSE;
  WHILE KEYPRESSED() DO MSG_KEYB;
  IF REDRAW THEN MSG_REDRAW;
 UNTIL STOPGUI;
 DESTROYTASK(GUIBH,@GUIBH);
END;
CONST GUIDRV:TDRIVER=(NEXT:NIL;LAST:NIL;TYP:$D;ID:0;GETPROT:@DOCK_GUI;
                      DESC:'GUI driver (1)');
BEGIN
 STARTDRIVERINITIALIZATION;
 FINDGRAPHDRIVER;
{ IF NOT INITMODE(1600,1200,8) THEN}
 IF NOT INITMODE(1024,768,8) THEN
 IF NOT INITMODE(800,600,8) THEN
 IF NOT INITMODE(640,480,8) THEN
 IF NOT INITMODE(320,240,8) THEN
 IF NOT INITMODE(320,200,8) THEN HALT('Grafikmodus nicht gefunden !'+#13+#10+'Um das System zu beenden, drcken Sie [PAUSE].');
 GUIBH:=CREATETASK(GETSYSTEMPROCESS(),@CENTRALGUITASK,$7FFFFFFF,'GUI Task');
 SETMOUSEBOTTOMHALF(GUIBH);
 SETKEYBBOTTOMHALF(GUIBH);
 ADDDRIVER(@GUIDRV);
 STOPDRIVERINITIALIZATION;
END.
 
