UNIT GUI;
{$ASMMODE INTEL}
INTERFACE
USES IRQS,MEMORY,GRAPH,PICSERV;
{$I ..\INCLUDE\GUI.DEF}
TYPE POBJ=^TOBJ;
     TOBJ=OBJECT
      HI,WI:DWORD;
      XP,YP:LONGINT;
      SELECTED,FOCUSED:LONGBOOL;
      CONSTRUCTOR INIT(BAS,GROUP:POBJ;X,Y:LONGINT;H,B:DWORD;VIS:LONGBOOL);
      DESTRUCTOR DONE;
      PROCEDURE ONPAINT;VIRTUAL;
      PROCEDURE ONMOUSE(X,Y:LONGINT;B,OB:DWORD;AX,AY:LONGINT);VIRTUAL;
      PROCEDURE ONKEY(FLAGS,CODE,CH:DWORD);VIRTUAL;
      PROCEDURE REDRAW;
      PROCEDURE SETMOUSEPIC(P:PPICTURE;HX,HY:LONGINT);
      PROCEDURE SETSTDMOUSEPIC(NR:DWORD);
      PROCEDURE MOVE(X,Y:LONGINT);
      PROCEDURE SIZE(H,B:DWORD);
      PROCEDURE MOVESIZE(X,Y:LONGINT;H,B:DWORD);
      PROCEDURE ONSIZE;VIRTUAL;
      PROCEDURE CHECKSIZE;VIRTUAL;
      PROCEDURE ONSELECT;VIRTUAL;
      PROCEDURE ONFOCUS;VIRTUAL;
      PROCEDURE ONNSELECT;VIRTUAL;
      PROCEDURE BRINGTOFRONT;
      FUNCTION GETAFH:DWORD;
      FUNCTION GETAFB:DWORD;
      PROCEDURE SETAPPOBJ(P:POBJ);
      PROCEDURE FOCUS;
      PRIVATE
      CALLED:LONGBOOL;
      HANDLE:POINTER;
      APPFRAME:POBJ;
     END;
IMPLEMENTATION
{ GUI-Protokoll 1 }
VAR GUIDRV:PDRIVER;
    GUIPROT:PPOINTERARRAY;
    GUIDRV2:PDRIVER;
    GUIPROT2:PPOINTERARRAY;
    GETGRAPHDRIVER:FUNCTION:PDRIVER;
    CREATEOBJECT:FUNCTION(BAS,GROUP:POINTER;X,Y:LONGINT;H,B:DWORD;VIS:LONGBOOL;C,D:POINTER):POINTER;
    REDRAWOBJECT:PROCEDURE(P:POINTER);
    SETMOUSEPICC:PROCEDURE(P:POINTER;PIC:PPICTURE;HX,HY:LONGINT);
    MOVEOBJECT:PROCEDURE(P:POINTER;X,Y:LONGINT);
    SIZEOBJECT:PROCEDURE(P:POINTER;H,B:DWORD);
    MOVESIZEOBJECT:PROCEDURE(P:POINTER;X,Y:LONGINT;H,B:DWORD);
    BRINGOBJECTTOFRONT:PROCEDURE(P:POINTER);
    FOCUSOBJECT:PROCEDURE(P:POINTER);
    DESTROYOBJECT:FUNCTION(P:POINTER):BOOLEAN;
{ GUI-Protokoll 2 }
VAR GETGUIMESSAGEDATA_MOUSE:PROCEDURE(VAR X,Y:LONGINT;VAR B,OB:DWORD;VAR AX,AY:LONGINT);
    GETGUIMESSAGEDATA_KEYB:PROCEDURE(VAR FLAGS,CODE,CH:DWORD);
PROCEDURE TOBJ.FOCUS;
BEGIN
 FOCUSOBJECT(HANDLE);
END;
PROCEDURE TOBJ.SETAPPOBJ(P:POBJ);
BEGIN
 APPFRAME:=P;
END;
FUNCTION TOBJ.GETAFB:DWORD;
VAR P:POBJ;
BEGIN
 P:=@SELF;
 WHILE P^.APPFRAME<>NIL DO P:=P^.APPFRAME;
 GETAFB:=P^.WI;
END;
FUNCTION TOBJ.GETAFH:DWORD;
VAR P:POBJ;
BEGIN
 P:=@SELF;
 WHILE P^.APPFRAME<>NIL DO P:=P^.APPFRAME;
 GETAFH:=P^.HI;
END;
PROCEDURE TOBJ.ONKEY(FLAGS,CODE,CH:DWORD);
BEGIN
END;
PROCEDURE TOBJ.BRINGTOFRONT;
BEGIN
 BRINGOBJECTTOFRONT(HANDLE);
END;
PROCEDURE TOBJ.ONSELECT;
BEGIN
END;
PROCEDURE TOBJ.ONFOCUS;
BEGIN
END;
PROCEDURE TOBJ.ONNSELECT;
BEGIN
END;
PROCEDURE TOBJ.CHECKSIZE;
BEGIN
END;
PROCEDURE TOBJ.ONSIZE;
BEGIN 
END;
PROCEDURE TOBJ.SIZE(H,B:DWORD);
BEGIN
 HI:=H;
 WI:=B;
 CHECKSIZE;
 SIZEOBJECT(HANDLE,HI,WI);
 ONSIZE;
END;
PROCEDURE TOBJ.MOVESIZE(X,Y:LONGINT;H,B:DWORD);
BEGIN
 XP:=X;
 YP:=Y;
 HI:=H;
 WI:=B;
 CHECKSIZE;
 MOVESIZEOBJECT(HANDLE,X,Y,HI,WI);
 ONSIZE;
END;
PROCEDURE TOBJ.MOVE(X,Y:LONGINT);
BEGIN
 XP:=X;
 YP:=Y;
 MOVEOBJECT(HANDLE,X,Y);
END;
PROCEDURE TOBJ.SETSTDMOUSEPIC(NR:DWORD);
VAR HX,HY:LONGINT;
    PIC:PPICTURE;
BEGIN
 PIC:=GETMOUSEPICTURE(NR,HX,HY);
 SETMOUSEPICC(HANDLE,PIC,HX,HY);
END;
PROCEDURE TOBJ.SETMOUSEPIC(P:PPICTURE;HX,HY:LONGINT);
BEGIN
 SETMOUSEPICC(HANDLE,P,HX,HY);
END;
PROCEDURE HANDLEMOUSEMESSAGE(P:POBJ);
VAR X,Y,AX,AY:LONGINT;
    B,OB:DWORD;
    R:POINTER;
BEGIN
 GETGUIMESSAGEDATA_MOUSE(X,Y,B,OB,AX,AY);
 P^.ONMOUSE(X,Y,B,OB,AX,AY);
END;
PROCEDURE HANDLEKEYMESSAGE(P:POBJ);
VAR FLAGS,CODE,CH:DWORD;
BEGIN
 GETGUIMESSAGEDATA_KEYB(FLAGS,CODE,CH);
 P^.ONKEY(FLAGS,CODE,CH);
END;
PROCEDURE HANDLEGUIMESSAGES(TYP:DWORD;P:POBJ);
BEGIN 
 P^.CALLED:=TRUE;
 CASE TYP OF
  GUIMSG_PAINT:P^.ONPAINT;
  GUIMSG_MOUSE:HANDLEMOUSEMESSAGE(P);
  GUIMSG_KEY:HANDLEKEYMESSAGE(P);
  GUIMSG_FOCUS:
  BEGIN
   P^.SELECTED:=TRUE;
   P^.FOCUSED:=TRUE;
   P^.ONFOCUS;
  END;
  GUIMSG_SELECT:
  BEGIN
   P^.SELECTED:=TRUE;
   P^.FOCUSED:=FALSE;
   P^.ONSELECT;
  END;
  GUIMSG_NSELECT:
  BEGIN
   P^.SELECTED:=FALSE;
   P^.FOCUSED:=FALSE;
   P^.ONNSELECT;
  END;
 END;
 P^.CALLED:=FALSE;
END;
PROCEDURE TOBJ.REDRAW;
BEGIN
 REDRAWOBJECT(HANDLE);
END;
PROCEDURE TOBJ.ONMOUSE(X,Y:LONGINT;B,OB:DWORD;AX,AY:LONGINT);
BEGIN
END;
PROCEDURE TOBJ.ONPAINT;
BEGIN
END;
CONSTRUCTOR TOBJ.INIT(BAS,GROUP:POBJ;X,Y:LONGINT;H,B:DWORD;VIS:LONGBOOL);
VAR BASH,GROUPH:POINTER;    
BEGIN
 XP:=X;
 YP:=Y;
 HI:=H;
 WI:=B;
 { GROUP+BAS iters fehlen !? oder ? }
 WHILE (BAS<>NIL) AND (BAS^.APPFRAME<>NIL) DO BAS:=BAS^.APPFRAME;
 IF BAS<>NIL THEN BASH:=BAS^.HANDLE ELSE BASH:=NIL;
 IF GROUP<>NIL THEN GROUPH:=GROUP^.HANDLE ELSE GROUPH:=NIL;
 HANDLE:=CREATEOBJECT(BASH,GROUPH,X,Y,H,B,VIS,@HANDLEGUIMESSAGES,@SELF);
 SETSTDMOUSEPIC(MSP_POINTER);
END;
DESTRUCTOR TOBJ.DONE;
BEGIN
{ Hier mu das verschachtelte DONE durchgefhrt werden, da sonst die
  Handles vom GUI-Treiber automatisch gelscht werden und die
  anderen Objekte sich ber Fehlermeldungen (Exceptions ?) wundern drfen ! }
 { Mit der Verschachtelung ist erst mal nicht... }
 DESTROYOBJECT(HANDLE);
 WHILE CALLED DO SCHEDULE;
END;
INITIALIZATION
 GUIPROT:=WAITFORADRIVER($D,1,GUIDRV);
 GUIPROT2:=WAITFORADRIVER($D,2,GUIDRV2);
 POINTER(GETGRAPHDRIVER):=GUIPROT^[0];
 POINTER(CREATEOBJECT):=GUIPROT^[1];
 POINTER(REDRAWOBJECT):=GUIPROT^[2];
 POINTER(SETMOUSEPICC):=GUIPROT^[3];
 POINTER(MOVEOBJECT):=GUIPROT^[4];
 POINTER(SIZEOBJECT):=GUIPROT^[5];
 POINTER(MOVESIZEOBJECT):=GUIPROT^[6];
 POINTER(BRINGOBJECTTOFRONT):=GUIPROT^[7];
 POINTER(FOCUSOBJECT):=GUIPROT^[8];
 POINTER(DESTROYOBJECT):=GUIPROT^[9];
 SELECTGRAPHDRIVER(GETGRAPHDRIVER());
 JOINMODE;
 POINTER(GETGUIMESSAGEDATA_MOUSE):=GUIPROT2^[0];
 POINTER(GETGUIMESSAGEDATA_KEYB):=GUIPROT2^[1];
FINALIZATION
 SIGNALEXIT(GUIDRV,1);
 SIGNALEXIT(GUIDRV2,2);
END.
