UNIT GUIOBJ;
{$ASMMODE INTEL}
INTERFACE
USES ALLBAS,GRAPH,GUI,PICSERV,KEYB;
TYPE PDESKTOP=^TDESKTOP;
     TDESKTOP=OBJECT(TOBJ)
      CONSTRUCTOR INIT(CRGB:DWORD);
      PROCEDURE ONPAINT;VIRTUAL;      
      PRIVATE
      COLOR_RGB:DWORD;
      COLOR:DWORD;
     END;
TYPE PBUTTON=^TBUTTON;
     TBUTTON=OBJECT(TOBJ)
      ONCLICKP:PROCEDURE(SENDER:PBUTTON);
      CONSTRUCTOR INIT(BAS,GROUP:POBJ;X,Y:LONGINT;H,B:DWORD;VIS:LONGBOOL;CAP:STRING;PI:PPICTURE;FON:PSTRING;FONS:DWORD);
      PROCEDURE ONPAINT;VIRTUAL;
      PROCEDURE ONMOUSE(X,Y:LONGINT;B,OB:DWORD;AX,AY:LONGINT);VIRTUAL;
      PROCEDURE ONCLICK;VIRTUAL;
      PRIVATE
      CAPTION:STRING;
      FONT:PSTRING;
      FONTS:DWORD;
      DOWN:LONGBOOL;
      PIC:PPICTURE;
     END;
TYPE PWINDOW_TIT=^TWINDOW_TIT;
     PWINDOW=^TWINDOW;
     PWINDOW_SIZE=^TWINDOW_SIZE;
     TWINDOW_SIZE=OBJECT(TOBJ)
      CONSTRUCTOR INIT(BAS:PWINDOW;T:DWORD);
      PROCEDURE ADJUST;
      PROCEDURE ONMOUSE(X,Y:LONGINT;B,OLDB:DWORD;AX,AY:LONGINT);VIRTUAL;
      PRIVATE
      MX,MY,BX,BY,OX,OY:LONGINT;
      TYP,OH,OB:DWORD;
      WINDOW:PWINDOW;
      SIZEING:LONGBOOL;
     END;
     TWINDOW_TIT=OBJECT(TOBJ)
      CONSTRUCTOR INIT(BAS:PWINDOW);
      PROCEDURE ONPAINT;VIRTUAL;
      PROCEDURE ONMOUSE(X,Y:LONGINT;B,OB:DWORD;AX,AY:LONGINT);VIRTUAL;
      WINDOW:PWINDOW;
      DRAGGING:LONGBOOL;
      BX,BY,OX,OY:LONGINT;
     END;
     TWINDOW=OBJECT(TOBJ)
      CONSTRUCTOR INIT(BAS:POBJ;X,Y:LONGINT;H,B:DWORD;VIS:LONGBOOL;TIT:STRING;FON:PSTRING;SZ:DWORD);
      PROCEDURE ONPAINT;VIRTUAL;
      PROCEDURE ONSIZE;VIRTUAL;
      PROCEDURE CHECKSIZE;VIRTUAL;
      PROCEDURE ONFOCUS;VIRTUAL;
      PROCEDURE ONSELECT;VIRTUAL;
      PROCEDURE ONNSELECT;VIRTUAL;
      PRIVATE
      FONT:PSTRING;
      FONTS:DWORD;
      SIZEABLE:LONGBOOL;
      TITLE:STRING;
      TITLEBAR:PWINDOW_TIT;
      SIZEF:ARRAY[1..9] OF PWINDOW_SIZE;
      APPF:POBJ;
     END;
TYPE PVSCROLLBAR=^TVSCROLLBAR;
     TVSCROLLBAR=OBJECT(TOBJ)
      CONSTRUCTOR INIT(BAS,GR:POBJ;X,Y:LONGINT;H,B:DWORD;VIS:LONGBOOL;PP,MP:DWORD);
      PROCEDURE ONPAINT;VIRTUAL;
      PROCEDURE ONMOUSE(X,Y:LONGINT;B,OB:DWORD;AX,AY:LONGINT);VIRTUAL;
      PROCEDURE ONCHANGE(POS:DWORD);VIRTUAL;
      PROCEDURE SETPOS(W:DWORD);
      FUNCTION GETPOS:DWORD;
      PROCEDURE SETRANGE(W:DWORD);
      FUNCTION GETRANGE:DWORD;
      PROCEDURE ONSIZE;VIRTUAL;
      PRIVATE
      POINTS,CURP:DWORD;
      BARSIZE,BARPOS:DWORD;
      PROCEDURE CALCBAR;
      BARMULTI,BARDIV:DWORD;
      BARVIS:LONGBOOL;
      BSTAT:DWORD;
      OLDPOS:DWORD;
     END;
TYPE PHSCROLLBAR=^THSCROLLBAR;
     THSCROLLBAR=OBJECT(TOBJ)
      CONSTRUCTOR INIT(BAS,GR:POBJ;X,Y:LONGINT;H,B:DWORD;VIS:LONGBOOL;PP,MP:DWORD);
      PROCEDURE ONPAINT;VIRTUAL;
      PROCEDURE ONMOUSE(X,Y:LONGINT;B,OB:DWORD;AX,AY:LONGINT);VIRTUAL;
      PROCEDURE ONCHANGE(POS:DWORD);VIRTUAL;
      PROCEDURE SETPOS(W:DWORD);
      FUNCTION GETPOS:DWORD;
      PROCEDURE SETRANGE(W:DWORD);
      PROCEDURE ONSIZE;VIRTUAL;
      PRIVATE
      POINTS,CURP:DWORD;
      BARSIZE,BARPOS:DWORD;
      PROCEDURE CALCBAR;
      BARMULTI,BARDIV:DWORD;
      BARVIS:LONGBOOL;
      BSTAT:DWORD;
      OLDPOS:DWORD;
     END;
TYPE PCHECKBOX=^TCHECKBOX;
     TCHECKBOX=OBJECT(TOBJ)
      CONSTRUCTOR INIT(BAS:POBJ;X,Y:LONGINT;H,B:DWORD;VIS:LONGBOOL;TXT:STRING;COL:DWORD;CHK:LONGBOOL;F:PSTRING;SZ:DWORD);
      PROCEDURE ONPAINT;VIRTUAL;
      PROCEDURE ONNSELECT;VIRTUAL;
      PROCEDURE ONFOCUS;VIRTUAL;
      PROCEDURE ONCHANGE(STAT:LONGBOOL);VIRTUAL;
      PROCEDURE ONMOUSE(X,Y:LONGINT;B,OB:DWORD;AX,AY:LONGINT);VIRTUAL;
      PROCEDURE DISABLE;
      PROCEDURE ENABLE;
      PROCEDURE SETCHECK(F:LONGBOOL);
      FUNCTION ISCHECKED:LONGBOOL;
      PRIVATE
      CHECK:LONGBOOL;
      CAPTION:STRING;
      COLOR:DWORD;
      FONT:PSTRING;
      FONTS:DWORD;
      DOWN:LONGBOOL;
      ENABLED:LONGBOOL;
     END;
TYPE PINPUTLINE=^TINPUTLINE;
     TINPUTLINE=OBJECT(TOBJ)
      ONRETURNP:PROCEDURE(SENDER:PINPUTLINE);
      PROCEDURE ONPAINT;VIRTUAL;
      PROCEDURE ONMOUSE(MX,MY:LONGINT;MB,OB:DWORD;ABX,ABY:LONGINT);VIRTUAL;
      PROCEDURE ONKEY(FLAGS,CODE,CH:DWORD);VIRTUAL;
      PROCEDURE ONCHANGE;VIRTUAL;
      PROCEDURE ONRETURN;VIRTUAL;
      CONSTRUCTOR INIT(BAS,GR:POBJ;X,Y:LONGINT;H,B:DWORD;VIS:BOOLEAN;F:PSTRING;SZ:DWORD);
      FUNCTION GETTEXT:STRING;
      PROCEDURE SETTEXT(S:STRING);
      PROCEDURE ONFOCUS;VIRTUAL;
      PROCEDURE ONNSELECT;VIRTUAL;
      PROCEDURE INSERTCHAR(C:CHAR);
      PROCEDURE DELETELAST;
      PROCEDURE GOTOPOS1;
      PROCEDURE GOTOLAST;
      PROCEDURE GOTONEXT;
      PROCEDURE GOTOEND;
      PROCEDURE GOTOP(X:DWORD);
      PROCEDURE DELETE;
      PRIVATE
      FONT:PSTRING;
      FONTS:DWORD;
      CONT:STRING;
      CURX,CURS:LONGINT;
      PROCEDURE CALCCURX;
     END;
TYPE PMEMOF=^TMEMOF;
     PMEMO=^TMEMO;
     PMEMOV=^TMEMOV;
     PMEMOH=^TMEMOH;
     TMEMOV=OBJECT(TVSCROLLBAR)
      CONSTRUCTOR INIT(BAS:PMEMO;X,H:DWORD;VIS:BOOLEAN);
      PROCEDURE ONCHANGE(POS:DWORD);VIRTUAL;
      PRIVATE
      MEMO:PMEMO;
     END;
     TMEMOH=OBJECT(THSCROLLBAR)
      CONSTRUCTOR INIT(BAS:PMEMO;Y,B:DWORD;VIS:BOOLEAN);
      PROCEDURE ONCHANGE(POS:DWORD);VIRTUAL;
      PRIVATE
      MEMO:PMEMO;
     END;
     TMEMOF=OBJECT(TOBJ)
      CONSTRUCTOR INIT(BAS:PMEMO;H,B:DWORD);
      PROCEDURE ONPAINT;VIRTUAL;
      PROCEDURE ONMOUSE(X,Y:LONGINT;B,OB:DWORD;AX,AY:LONGINT);VIRTUAL;
      PRIVATE
      MEMO:PMEMO;
     END;
     TMEMO=OBJECT(TOBJ)
      CONSTRUCTOR INIT(BAS:POBJ;X,Y:LONGINT;H,B:DWORD;VIS:BOOLEAN;SC:DWORD;F:PSTRING;SZ:DWORD);
      PROCEDURE ONDONE;VIRTUAL;
      PROCEDURE SIZE(H,B:DWORD);VIRTUAL;
      PROCEDURE CHECKSIZE(VAR H,B:DWORD);VIRTUAL;
      PROCEDURE ONKEY(FLAGS,CODE,CH:DWORD);VIRTUAL;
      PROCEDURE ONCHANGE;VIRTUAL;
      PROCEDURE ONNEWPOS(LIN,COL:DWORD);VIRTUAL;
      FUNCTION GETCOLUM:DWORD;
      FUNCTION GETLINE:DWORD;
      FUNCTION LINECOUNT:DWORD;
      PROCEDURE CLEAR;
      PROCEDURE ONFOCUS;VIRTUAL;
      PROCEDURE ONNSELECT;VIRTUAL;
      PROCEDURE INSERT(LIN,COL:DWORD;S:STRING);
      PROCEDURE INSERTLINE(LIN,COL:DWORD);
      FUNCTION GETLINELENGTH(LIN:DWORD):DWORD;      
      PRIVATE
      FONT:PSTRING;
      FONTS:DWORD;
      SCV:PMEMOV;
      SCH:PMEMOH;
      XSCROLL:LONGINT;
      E:PMEMOF;
      TEXT:PSTRINGLIST;
      SCB,SCRLINE,AKTLINE,AKTCOLUM:DWORD;
      MAXSCH:DWORD;
      PROCEDURE CALCSCROLL;
      PROCEDURE CALCSCH;
     END;
TYPE PMEMOWINF=^TMEMOWINF;
     PMEMOWIN=^TMEMOWIN;
     TMEMOWINF=OBJECT(TMEMO)
      CONSTRUCTOR INIT(BAS:PMEMOWIN;SC:DWORD;TF:PSTRING;SZ:DWORD);
      PROCEDURE ONCHANGE;VIRTUAL;
      PROCEDURE ONNEWPOS;VIRTUAL;
      PRIVATE
      MEMOWIN:PMEMOWIN;
     END;
     TMEMOWIN=OBJECT(TWINDOW)
      CONSTRUCTOR INIT(BAS:POBJ;X,Y:LONGINT;H,B:DWORD;VIS:BOOLEAN;TIT:STRING;
                       SCB:DWORD;F,TF:PSTRING;FSZ,FSZ2:DWORD);
      PROCEDURE ONSIZE;VIRTUAL;
      PROCEDURE CHECKSIZE;VIRTUAL;
      PROCEDURE ONCHANGE;VIRTUAL;
      PROCEDURE ONNEWPOS;VIRTUAL;
      FUNCTION GETLINE:DWORD;
      FUNCTION GETCOLUM:DWORD;
      PROCEDURE CLEAR;
      PROCEDURE INSERT(LIN,COL:DWORD;S:STRING);
      PROCEDURE INSERTLINE(LIN,COL:DWORD);
      FUNCTION GETLINELENGTH(LIN:DWORD):DWORD;
      FUNCTION LINECOUNT:DWORD;
      PRIVATE
      MEMO:PMEMOWINF;
     END;
IMPLEMENTATION
PROCEDURE TMEMOWIN.CLEAR;
BEGIN
 MEMO^.CLEAR;
END;
FUNCTION TMEMOWIN.GETLINE:DWORD;
BEGIN
 GETLINE:=MEMO^.GETLINE;
END;
FUNCTION TMEMOWIN.GETCOLUM:DWORD;
BEGIN
 GETCOLUM:=MEMO^.GETCOLUM;
END;
PROCEDURE TMEMOWIN.ONCHANGE;
BEGIN
END;
PROCEDURE TMEMOWIN.ONNEWPOS;
BEGIN
END;
PROCEDURE TMEMOWINF.ONCHANGE;
BEGIN
 MEMOWIN^.ONCHANGE;
END;
PROCEDURE TMEMOWINF.ONNEWPOS;
BEGIN
 MEMOWIN^.ONNEWPOS;
END;
CONSTRUCTOR TMEMOWINF.INIT(BAS:PMEMOWIN;SC:DWORD;TF:PSTRING;SZ:DWORD);
BEGIN
 INHERITED INIT(BAS,0,0,BAS^.GETAFH,BAS^.GETAFB,TRUE,SC,TF,SZ);
 MEMOWIN:=BAS;
END;
PROCEDURE TMEMOWIN.CHECKSIZE;
BEGIN
 INHERITED CHECKSIZE;
 IF LONGINT(HI)<93 THEN HI:=93;
 IF LONGINT(WI)<68 THEN WI:=68;
END;
PROCEDURE TMEMOWIN.ONSIZE;
BEGIN
 INHERITED ONSIZE;
 MEMO^.SIZE(GETAFH,GETAFB);
END;
PROCEDURE TMEMOWIN.INSERT(LIN,COL:DWORD;S:STRING);
BEGIN
 MEMO^.INSERT(LIN,COL,S);
END;
PROCEDURE TMEMOWIN.INSERTLINE(LIN,COL:DWORD);
BEGIN
 MEMO^.INSERTLINE(LIN,COL);
END;
FUNCTION TMEMOWIN.LINECOUNT:DWORD;
BEGIN
 LINECOUNT:=MEMO^.LINECOUNT;
END;
FUNCTION TMEMOWIN.GETLINELENGTH(LIN:DWORD):DWORD;
BEGIN
 GETLINELENGTH:=MEMO^.GETLINELENGTH(LIN);
END;
CONSTRUCTOR TMEMOWIN.INIT(BAS:POBJ;X,Y:LONGINT;H,B:DWORD;VIS:BOOLEAN;
                          TIT:STRING;SCB:DWORD;F,TF:PSTRING;FSZ,FSZ2:DWORD);
BEGIN
 INHERITED INIT(BAS,X,Y,H,B,VIS,TIT,F,FSZ);
 NEW(MEMO,INIT(@SELF,SCB,TF,FSZ2));
END;
PROCEDURE TMEMOF.ONMOUSE(X,Y:LONGINT;B,OB:DWORD;AX,AY:LONGINT);
VAR NX,NY:LONGINT;
    I,L:DWORD;
    S:STRING;
BEGIN
 IF B=1 THEN
 BEGIN
  SELECTFONT(MEMO^.FONT^);
  NY:=MEMO^.SCRLINE+Y DIV LONGINT(GETSTRINGHEIGHT(MEMO^.FONTS));
  L:=MEMO^.TEXT^.LINECOUNT;
  IF NY<0 THEN NY:=0;
  IF NY>=L THEN
  BEGIN
   IF L=0 THEN NY:=0 ELSE NY:=L-1;
  END;
  MEMO^.TEXT^.GOTOLINE(NY);
  S:=MEMO^.TEXT^.READLINE;
  NX:=0;
  INC(X,MEMO^.XSCROLL);
  WHILE (NX<BYTE(S[0])) AND (X>LONGINT(GETSTRINGWIDTH(STR_COPY(S,1,NX+1),MEMO^.FONTS))) DO INC(NX);
  IF (NX<>MEMO^.AKTCOLUM) OR (NY<>MEMO^.AKTLINE) THEN
  BEGIN
   MEMO^.AKTCOLUM:=NX;
   MEMO^.AKTLINE:=NY;
   MEMO^.ONNEWPOS(NY,NX);
   MEMO^.CALCSCROLL;
  END;
 END;
END;
PROCEDURE TMEMOF.ONPAINT;
VAR Y:LONGINT;
    I,CO:DWORD;
    TXT:PSTRINGLIST;
    S:STRING;
    BX:LONGINT;
    FH:DWORD;
BEGIN
 BAR(0,0,HI,WI,CL_WHITE);
 TXT:=MEMO^.TEXT;
 Y:=0;
 SELECTFONT(MEMO^.FONT^);
 FH:=GETSTRINGHEIGHT(MEMO^.FONTS);
 CO:=HI DIV FH;
 TXT^.GOTOLINE(MEMO^.SCRLINE);
 FOR I:=0 TO CO DO
 BEGIN
  S:=TXT^.READLINE;
  PUTSTRING(-MEMO^.XSCROLL,Y,S,CL_BLACK,MEMO^.FONTS);
  IF MEMO^.SCRLINE+I=MEMO^.AKTLINE THEN
  BEGIN
   BX:=GETSTRINGWIDTH(STR_COPY(S,1,MEMO^.AKTCOLUM),MEMO^.FONTS)-MEMO^.XSCROLL;
   IF MEMO^.FOCUSED THEN BAR(BX,Y,FH,2,CL_RED) ELSE
    BAR(BX,Y,FH,2,CL_GRAY);
  END;
  INC(Y,FH+1);
 END;
END;
CONSTRUCTOR TMEMOF.INIT(BAS:PMEMO;H,B:DWORD);
BEGIN
 INHERITED INIT(BAS,BAS,0,0,H,B,TRUE);
 MEMO:=BAS;
END;
PROCEDURE TMEMOV.ONCHANGE(POS:DWORD);
BEGIN
 MEMO^.SCRLINE:=POS;
 MEMO^.REDRAW;
END;
CONSTRUCTOR TMEMOV.INIT(BAS:PMEMO;X,H:DWORD;VIS:BOOLEAN);
BEGIN
 INHERITED INIT(BAS,BAS,X,0,H,20,VIS,0,0);
 MEMO:=BAS;
END;
PROCEDURE TMEMOH.ONCHANGE(POS:DWORD);
BEGIN
 MEMO^.XSCROLL:=POS;
 MEMO^.REDRAW;
END;
CONSTRUCTOR TMEMOH.INIT(BAS:PMEMO;Y,B:DWORD;VIS:BOOLEAN);
BEGIN
 INHERITED INIT(BAS,BAS,0,Y,20,B,VIS,0,0);
 MEMO:=BAS;
END;
PROCEDURE TMEMO.CLEAR;
BEGIN
 TEXT^.CLEAR;
END;
PROCEDURE TMEMO.ONFOCUS;
BEGIN
 REDRAW;
END;
PROCEDURE TMEMO.ONNSELECT;
BEGIN
 REDRAW;
END;
FUNCTION TMEMO.GETCOLUM:DWORD;
BEGIN
 GETCOLUM:=AKTCOLUM;
END;
FUNCTION TMEMO.GETLINE:DWORD;
BEGIN
 GETLINE:=AKTLINE;
END;
PROCEDURE TMEMO.ONNEWPOS(LIN,COL:DWORD);
BEGIN
END;
PROCEDURE TMEMO.ONCHANGE;
BEGIN
END;
PROCEDURE TMEMO.CALCSCH;
VAR I,L,S:DWORD;
BEGIN
 TEXT^.GOTOLINE(0);
 L:=TEXT^.LINECOUNT;
 MAXSCH:=0;
 IF L<>0 THEN
 BEGIN
  SELECTFONT(FONT^);
  FOR I:=0 TO L-1 DO
  BEGIN
   S:=GETSTRINGWIDTH(TEXT^.READLINE,FONTS);
   IF S>MAXSCH THEN MAXSCH:=S;
  END;
 END;
 L:=MAXSCH-E^.WI+10;
 IF LONGINT(L)<0 THEN L:=0;
 SCH^.SETRANGE(L);
END;
PROCEDURE TMEMO.CALCSCROLL;
VAR L:LONGINT;
    AX:LONGINT;
    CONT:STRING;
    FH:DWORD;
BEGIN
 TEXT^.GOTOLINE(AKTLINE);
 CONT:=TEXT^.READLINE;
 SELECTFONT(FONT^);
 AX:=GETSTRINGWIDTH(STR_COPY(CONT,1,AKTCOLUM),FONTS);
 FH:=GETSTRINGHEIGHT(FONTS);
 IF XSCROLL>AX THEN
 BEGIN
  IF AX>20 THEN XSCROLL:=AX-20 ELSE XSCROLL:=0;
 END;
 IF XSCROLL+E^.WI-11<=AX THEN XSCROLL:=AX-E^.WI+10;
 IF SCRLINE>AKTLINE THEN SCRLINE:=AKTLINE;
 IF SCRLINE+(E^.HI DIV (FH+1))-1<AKTLINE THEN SCRLINE:=AKTLINE-(E^.HI DIV (FH+1))+1;
 L:=TEXT^.LINECOUNT-(E^.HI DIV (FH+1))+1;
 IF L<0 THEN L:=0;
 SCV^.SETRANGE(L);
 SCV^.SETPOS(SCRLINE);
 CALCSCH;
 SCH^.SETPOS(XSCROLL);
 REDRAW;
END;
PROCEDURE TMEMO.ONKEY(FLAGS,CODE,CH:DWORD);
VAR LIM:DWORD;
    OL,OC:DWORD;
BEGIN
 IF CH AND $7FFFFFFF<>0 THEN
 BEGIN
  IF (CH AND $80000000=0) AND (AKTCOLUM<255) THEN
  BEGIN
   TEXT^.INSERT(AKTLINE,AKTCOLUM,CHAR(CH));
   INC(AKTCOLUM);
   ONCHANGE;
   CALCSCROLL;
  END;
  EXIT;
 END;
 OL:=AKTLINE;
 OC:=AKTCOLUM;
 CASE CODE OF
  KEYC_BEGIN:IF AKTCOLUM>0 THEN
  BEGIN
   AKTCOLUM:=0;
   CALCSCROLL;
  END;
  KEYC_MOVEUP:
  BEGIN
   IF AKTLINE>0 THEN
   BEGIN
    DEC(AKTLINE);
    LIM:=TEXT^.LINELEN(AKTLINE);
    IF AKTCOLUM>LIM THEN AKTCOLUM:=LIM;
    CALCSCROLL;
   END;
  END;
  KEYC_MOVELEFT:
  BEGIN
   IF AKTCOLUM>0 THEN
   BEGIN
    DEC(AKTCOLUM);
    CALCSCROLL;
   END
   ELSE
   BEGIN
    IF AKTLINE>0 THEN
    BEGIN
     DEC(AKTLINE);
     AKTCOLUM:=TEXT^.LINELEN(AKTLINE);
     CALCSCROLL;
    END;
   END;
  END;
  KEYC_MOVERIGHT:
  BEGIN
   LIM:=TEXT^.LINELEN(AKTLINE);
   IF AKTCOLUM<LIM THEN
   BEGIN
    INC(AKTCOLUM);
    CALCSCROLL;
   END
   ELSE
   BEGIN
    INC(AKTLINE);
    AKTCOLUM:=0;
    CALCSCROLL;
   END;
  END;
  KEYC_END:
  BEGIN
   LIM:=TEXT^.LINELEN(AKTLINE);
   IF AKTCOLUM<LIM THEN
   BEGIN
    AKTCOLUM:=LIM;
    CALCSCROLL;
   END;
  END;
  KEYC_MOVEDOWN:
  BEGIN
   INC(AKTLINE);
   LIM:=TEXT^.LINELEN(AKTLINE);
   IF AKTCOLUM>LIM THEN AKTCOLUM:=LIM;
   CALCSCROLL;
  END;
  KEYC_DELETE:
  BEGIN
   TEXT^.DELETE(AKTLINE,AKTCOLUM);
   ONCHANGE;
   CALCSCROLL;
  END;
  KEYC_BACKSPACE:
  BEGIN
   TEXT^.DELETELAST(AKTLINE,AKTCOLUM);
   IF AKTCOLUM=0 THEN
   BEGIN
    IF AKTLINE>0 THEN
    BEGIN
     DEC(AKTLINE);
     AKTCOLUM:=TEXT^.LINELEN(AKTLINE);
     ONCHANGE;
    END;
   END
   ELSE
   BEGIN
    DEC(AKTCOLUM);
    ONCHANGE;
   END;
   CALCSCROLL;
  END;
  KEYC_RETURN:
  BEGIN
   TEXT^.INSERTLINE(AKTLINE,AKTCOLUM);
   INC(AKTLINE);
   AKTCOLUM:=0;
   ONCHANGE;
   CALCSCROLL;
  END;
 END;
 IF (AKTLINE<>OL) OR (AKTCOLUM<>OC) THEN ONNEWPOS(AKTLINE,AKTCOLUM);
END;
PROCEDURE TMEMO.CHECKSIZE(VAR H,B:DWORD);
BEGIN
 IF LONGINT(H)<21 THEN H:=21;
 IF LONGINT(B)<21 THEN B:=21;
END;
PROCEDURE TMEMO.SIZE(H,B:DWORD);
VAR L:LONGINT;
BEGIN
 INHERITED SIZE(H,B);
 CASE SCB OF
  0:E^.SIZE(HI,WI);
  1:
  BEGIN
   SCV^.MOVESIZE(WI-20,0,HI,20);
   E^.SIZE(HI,WI-20);
  END;
  2:
  BEGIN
   SCV^.MOVESIZE(0,HI-20,20,WI);
   E^.SIZE(HI-20,WI);
  END;
  3:
  BEGIN
   SCV^.MOVESIZE(WI-20,0,HI-20,20);
   SCH^.MOVESIZE(0,HI-20,20,WI-20);
   E^.SIZE(HI-20,WI-20);
  END;
 END;
 L:=MAXSCH-E^.WI+10;
 IF L<0 THEN L:=0;
 SCH^.SETRANGE(L);
 SELECTFONT(FONT^);
 L:=TEXT^.LINECOUNT-(E^.HI DIV (GETSTRINGHEIGHT(FONTS)+1))+1;
 IF L<0 THEN L:=0;
 SCV^.SETRANGE(L);
END;
PROCEDURE TMEMO.ONDONE;
BEGIN
 DISPOSE(TEXT,DONE);
END;
FUNCTION TMEMO.LINECOUNT:DWORD;
BEGIN
 LINECOUNT:=TEXT^.LINECOUNT;
END;
PROCEDURE TMEMO.INSERT(LIN,COL:DWORD;S:STRING);
BEGIN
 TEXT^.INSERT(LIN,COL,S);
 CALCSCH;
 CALCSCROLL;
 REDRAW;
END;
FUNCTION TMEMO.GETLINELENGTH(LIN:DWORD):DWORD;
BEGIN
 IF LIN>=TEXT^.LINECOUNT THEN GETLINELENGTH:=0 ELSE
 BEGIN
  TEXT^.GOTOLINE(LIN);
  GETLINELENGTH:=BYTE(TEXT^.READLINE[0]);
 END;
END;
PROCEDURE TMEMO.INSERTLINE(LIN,COL:DWORD);
BEGIN
 TEXT^.INSERTLINE(LIN,COL);
 CALCSCH;
 CALCSCROLL;
 REDRAW;
END;
CONSTRUCTOR TMEMO.INIT(BAS:POBJ;X,Y:LONGINT;H,B:DWORD;VIS:BOOLEAN;SC:DWORD;F:PSTRING;SZ:DWORD);
BEGIN
 INHERITED INIT(BAS,NIL,X,Y,H,B,VIS);
 NEW(TEXT,INIT);
 FONT:=F;
 FONTS:=SZ;
 SCB:=SC;
 XSCROLL:=0;
 AKTLINE:=0;
 AKTCOLUM:=0;
 SCRLINE:=0;
 CASE SC OF
  0:
  BEGIN
   NEW(E,INIT(@SELF,HI,WI));
   NEW(SCV,INIT(@SELF,WI-20,HI-20,FALSE));
   NEW(SCH,INIT(@SELF,HI-20,WI-20,FALSE));
  END;
  1:
  BEGIN
   NEW(E,INIT(@SELF,HI,WI-20));
   NEW(SCV,INIT(@SELF,WI-20,HI,TRUE));
   NEW(SCH,INIT(@SELF,HI-20,WI-20,FALSE));
  END;
  2:
  BEGIN
   NEW(E,INIT(@SELF,HI-20,WI));
   NEW(SCV,INIT(@SELF,WI-20,HI-20,FALSE));
   NEW(SCH,INIT(@SELF,HI-20,WI,TRUE));
  END;
  3:
  BEGIN
   NEW(E,INIT(@SELF,HI-20,WI-20));
   NEW(SCV,INIT(@SELF,WI-20,HI-20,TRUE));
   NEW(SCH,INIT(@SELF,HI-20,WI-20,TRUE));
  END;
 END;
 CALCSCH;
 CALCSCROLL;
END;
PROCEDURE TINPUTLINE.ONNSELECT;
BEGIN
 REDRAW;
END;
PROCEDURE TINPUTLINE.GOTOP(X:DWORD);
BEGIN
 IF X>BYTE(CONT[0]) THEN X:=BYTE(CONT[0]);
 IF CURS<>X THEN
 BEGIN
  CURS:=X;
  CALCCURX;
 END;
END;
PROCEDURE TINPUTLINE.DELETE;
VAR I:DWORD;
BEGIN
 IF CURS<BYTE(CONT[0]) THEN
 BEGIN
  DEC(CONT[0]);
  STR_DELETE(CONT,CURS+1,1);
  ONCHANGE;
  REDRAW;
 END;
END;
PROCEDURE TINPUTLINE.GOTOEND;
BEGIN
 CURS:=BYTE(CONT[0]);
 CALCCURX;
END;
PROCEDURE TINPUTLINE.GOTONEXT;
BEGIN
 IF CURS<BYTE(CONT[0]) THEN
 BEGIN
  INC(CURS);
  CALCCURX;
 END;
END;
PROCEDURE TINPUTLINE.GOTOLAST;
BEGIN
 IF CURS>0 THEN
 BEGIN
  DEC(CURS);
  CALCCURX;
 END;
END;
PROCEDURE TINPUTLINE.CALCCURX;
VAR AX:LONGINT;
BEGIN
 SELECTFONT(FONT^);
 AX:=GETSTRINGWIDTH(STR_COPY(CONT,1,CURS),FONTS);
 IF CURX>AX THEN
 BEGIN
  IF AX>20 THEN CURX:=AX-20 ELSE CURX:=0;
 END;
 IF CURX+WI-11<=AX THEN CURX:=AX-WI+10;
 REDRAW;
END;
PROCEDURE TINPUTLINE.GOTOPOS1;
BEGIN
 CURS:=0;
 CALCCURX;
END;
PROCEDURE TINPUTLINE.DELETELAST;
BEGIN
 IF CURS>0 THEN
 BEGIN
  STR_DELETE(CONT,CURS,1);
  DEC(CURS);
  ONCHANGE;
  CALCCURX;
 END;
END;
PROCEDURE TINPUTLINE.INSERTCHAR(C:CHAR);
BEGIN
 IF BYTE(CONT[0])<255 THEN
 BEGIN
  INC(CURS);
  STR_INSERT(C,CONT,CURS);
  ONCHANGE;
  CALCCURX;
 END;
END;
PROCEDURE TINPUTLINE.ONFOCUS;
BEGIN
 REDRAW;
END;
PROCEDURE TINPUTLINE.ONRETURN;
BEGIN
 IF ONRETURNP<>NIL THEN ONRETURNP(@SELF);
END;
PROCEDURE TINPUTLINE.ONCHANGE;
BEGIN
END;
PROCEDURE TINPUTLINE.SETTEXT(S:STRING);
BEGIN
 IF CONT<>S THEN
 BEGIN
  CONT:=S;
  IF CURS>BYTE(S[0]) THEN CURS:=BYTE(S[0]);
  ONCHANGE;
  CALCCURX;
 END;
END;
FUNCTION TINPUTLINE.GETTEXT:STRING;
BEGIN
 GETTEXT:=CONT;
END;
PROCEDURE TINPUTLINE.ONMOUSE(MX,MY:LONGINT;MB,OB:DWORD;ABX,ABY:LONGINT);
VAR AX,NEWS:DWORD;
    S:STRING;
BEGIN
 SELECTFONT(FONT^);
 IF MB=1 THEN
 BEGIN
  NEWS:=0;
  S:=CONT[1];
  WHILE (NEWS<BYTE(S[0])) AND (LONGINT(GETSTRINGWIDTH(S,FONTS))<MX+CURX) DO
  BEGIN
   INC(NEWS);
   S:=S+CONT[NEWS+1];
  END;
  IF NEWS>BYTE(CONT[0]) THEN NEWS:=BYTE(CONT[0]);
  IF NEWS<>CURS THEN
  BEGIN
   CURS:=NEWS;
   AX:=GETSTRINGWIDTH(STR_COPY(CONT,1,NEWS),FONTS);
   IF CURX>AX THEN
   BEGIN
    IF AX>20 THEN CURX:=AX-20 ELSE CURX:=0;
   END;
   IF CURX+WI-11<=AX THEN CURX:=AX-WI+10;
   REDRAW;
  END;
 END;
END;
PROCEDURE TINPUTLINE.ONKEY(FLAGS,CODE,CH:DWORD);
BEGIN
 IF CODE AND $80000000=0 THEN
 BEGIN
  IF CH<>0 THEN INSERTCHAR(CHAR(CH)) ELSE
  BEGIN
   CASE CODE OF
    KEYC_BACKSPACE:DELETELAST;
    KEYC_DELETE:DELETE;
    KEYC_MOVELEFT:GOTOLAST;
    KEYC_MOVERIGHT:GOTONEXT;
    KEYC_BEGIN:GOTOPOS1;
    KEYC_END:GOTOEND;
    KEYC_RETURN:ONRETURN;
   END;
  END;
 END;
END;
PROCEDURE TINPUTLINE.ONPAINT;
BEGIN
 SELECTFONT(FONT^);
 BAR(2,2,HI-4,WI-4,CL_WHITE);
 PUTSTRING(-CURX+4,(HI-GETSTRINGHEIGHT(FONTS)) DIV 2,CONT,CL_BLACK,FONTS);
 IF FOCUSED THEN
 BEGIN
  BAR(GETSTRINGWIDTH(STR_COPY(CONT,1,CURS),FONTS)+3-CURX,4,HI-8,2,CL_RED);
 END ELSE BAR(GETSTRINGWIDTH(STR_COPY(CONT,1,CURS),FONTS)+3-CURX,4,HI-8,2,CL_GRAY);
 FRAMEI3D(0,0,HI,WI);
END;
CONSTRUCTOR TINPUTLINE.INIT(BAS,GR:POBJ;X,Y:LONGINT;H,B:DWORD;VIS:BOOLEAN;F:PSTRING;SZ:DWORD);
BEGIN
 INHERITED INIT(BAS,GR,X,Y,H,B,VIS);
 CONT:='';
 CURX:=0;
 CURS:=0;
 FONT:=F;
 FONTS:=SZ;
 ONRETURNP:=NIL;
END;
FUNCTION TCHECKBOX.ISCHECKED:LONGBOOL;
BEGIN
 ISCHECKED:=CHECK;
END;
PROCEDURE TCHECKBOX.SETCHECK(F:LONGBOOL);
BEGIN
 IF CHECK<>F THEN
 BEGIN
  CHECK:=F;
  REDRAW;
 END;
END;
PROCEDURE TCHECKBOX.DISABLE;
BEGIN
 IF ENABLED THEN
 BEGIN
  ENABLED:=FALSE;
  REDRAW;
 END;
END;
PROCEDURE TCHECKBOX.ENABLE;
BEGIN
 IF NOT ENABLED THEN
 BEGIN
  ENABLED:=TRUE;
  REDRAW;
 END;
END;
PROCEDURE TCHECKBOX.ONMOUSE(X,Y:LONGINT;B,OB:DWORD;AX,AY:LONGINT);
BEGIN
 IF DOWN THEN
 BEGIN
  IF B=0 THEN
  BEGIN
   IF (DWORD(X)<HI) AND (DWORD(Y)<HI) THEN
   BEGIN
    CHECK:=NOT CHECK;
    ONCHANGE(CHECK);
    REDRAW;
   END;
   DOWN:=FALSE;
   REDRAW;
  END;
 END
 ELSE
 BEGIN
  IF ENABLED AND (B=1) AND (OB=0) AND (DWORD(X)<HI) AND (DWORD(Y)<HI) THEN
  BEGIN
   DOWN:=TRUE;
   REDRAW;
  END;
 END;
END;
PROCEDURE TCHECKBOX.ONCHANGE(STAT:LONGBOOL);
BEGIN
END;
PROCEDURE TCHECKBOX.ONFOCUS;
BEGIN
 REDRAW;
END;
PROCEDURE TCHECKBOX.ONNSELECT;
BEGIN
 REDRAW;
END;
PROCEDURE TCHECKBOX.ONPAINT;
BEGIN
 SELECTFONT(FONT^);
 FRAMEI3D(0,0,HI,HI);
 IF ENABLED THEN BAR(2,2,HI-4,HI-4,CL_WHITE)
  ELSE BAR(2,2,HI-4,HI-4,CL_SILVER);
 IF CHECK THEN DRAWCROSS(4,4,HI-8,CL_BLACK);
 { Noch keine FOCUS-Besonderheit vorhanden ! }
 PUTSTRING(HI+3,(HI-GETSTRINGHEIGHT(FONTS)) DIV 2,CAPTION,COLOR,FONTS)
END;
CONSTRUCTOR TCHECKBOX.INIT(BAS:POBJ;X,Y:LONGINT;H,B:DWORD;VIS:LONGBOOL;TXT:STRING;COL:DWORD;CHK:LONGBOOL;F:PSTRING;SZ:DWORD);
BEGIN
 INHERITED INIT(BAS,NIL,X,Y,H,B,VIS);
 CAPTION:=TXT;
 COLOR:=COL;
 CHECK:=CHK;
 FONT:=F;
 FONTS:=SZ;
 DOWN:=FALSE;
 ENABLED:=TRUE;
END;
PROCEDURE THSCROLLBAR.ONSIZE;
BEGIN
 CALCBAR;
END;
PROCEDURE THSCROLLBAR.SETRANGE(W:DWORD);
BEGIN
 IF W<>POINTS THEN
 BEGIN
  POINTS:=W;
  CALCBAR;
  REDRAW;
  SETPOS(CURP);
 END;
END;
FUNCTION THSCROLLBAR.GETPOS:DWORD;
BEGIN
 GETPOS:=CURP;
END;
PROCEDURE THSCROLLBAR.ONCHANGE(POS:DWORD);
BEGIN
END;
PROCEDURE THSCROLLBAR.SETPOS(W:DWORD);
BEGIN
 IF LONGINT(W)>LONGINT(POINTS-1) THEN W:=POINTS-1;
 IF LONGINT(W)<0 THEN W:=0;
 IF CURP<>W THEN
 BEGIN
  CURP:=W;
  IF BARVIS THEN BARPOS:=CURP*BARMULTI DIV BARDIV;
  ONCHANGE(CURP);
  REDRAW;
 END;
END;
PROCEDURE THSCROLLBAR.ONMOUSE(X,Y:LONGINT;B,OB:DWORD;AX,AY:LONGINT);
VAR NX:LONGINT;
BEGIN
 CASE BSTAT OF
  0:IF (OB=0) AND (B=1) THEN
  BEGIN
   OLDPOS:=CURP;
   IF (X<20) THEN
   BEGIN
    BSTAT:=2;
    SETPOS(CURP-1);
    REDRAW;
   END ELSE IF (X>=WI-20) THEN
   BEGIN
    BSTAT:=3;
    SETPOS(CURP+1);
    REDRAW;
   END ELSE IF (BARVIS) THEN
   BEGIN
    BSTAT:=1;
    NX:=X-20-BARSIZE DIV 2;
    IF NX<0 THEN NX:=0;
    IF NX>WI-40-BARSIZE THEN NX:=WI-40-BARSIZE;
    SETPOS(NX*BARDIV DIV BARMULTI);
   END;
  END;
  1:IF B=1 THEN
  BEGIN
   NX:=X-20-BARSIZE DIV 2;
   IF NX<0 THEN NX:=0;
   IF NX>WI-40-BARSIZE THEN NX:=WI-40-BARSIZE;
   SETPOS(NX*BARDIV DIV BARMULTI);
  END
  ELSE
  BEGIN
   IF B<>0 THEN SETPOS(OLDPOS);
   BSTAT:=0;
  END;
  2:IF B<>1 THEN
  BEGIN
   IF B<>0 THEN SETPOS(OLDPOS);
   BSTAT:=0;
   REDRAW;
  END;
  3:IF B<>1 THEN
  BEGIN
   IF B<>0 THEN SETPOS(OLDPOS);
   BSTAT:=0;
   REDRAW;
  END;
 END;
END;
PROCEDURE THSCROLLBAR.ONPAINT;
VAR X:LONGINT;
    H:DWORD;
BEGIN
 CLEAR(CL_RED);
 IF BSTAT<>3 THEN
 BEGIN
  BAR3D(WI-20,0,HI,20);
  DRAWSPOINTERRIGHT(WI-12,HI DIV 2-4,4,CL_BLACK);
 END
 ELSE
 BEGIN
  BARI3D(WI-20,0,HI,20);
  DRAWSPOINTERRIGHT(WI-11,HI DIV 2-3,4,CL_BLACK);
 END;
 IF BSTAT<>2 THEN
 BEGIN
  BAR3D(0,0,HI,20);
  DRAWSPOINTERLEFT(8,HI DIV 2-4,4,CL_BLACK);
 END
 ELSE
 BEGIN
  BARI3D(0,0,HI,20);
  DRAWSPOINTERLEFT(9,HI DIV 2-3,4,CL_BLACK);
 END;
 IF BARVIS THEN
 BEGIN
  BAR3D(20+BARPOS,0,HI,BARSIZE);
  X:=20+BARPOS+BARSIZE DIV 2;
  H:=HI-8;
  BAR(X-4,4,H,1,CL_GRAY);
  BAR(X-3,4,H,1,CL_LSILVER);
  BAR(X-1,4,H,1,CL_GRAY);
  BAR(X,4,H,1,CL_LSILVER);
  BAR(X+2,4,H,1,CL_GRAY);
  BAR(X+3,4,H,1,CL_LSILVER);
 END;
END;
PROCEDURE THSCROLLBAR.CALCBAR;
VAR B:DWORD;
BEGIN
 IF WI>=52 THEN
 BEGIN
  B:=WI-40;
  BARVIS:=TRUE;
  IF POINTS<>0 THEN BARSIZE:=B-(POINTS-1) ELSE BARSIZE:=B;
  IF LONGINT(BARSIZE)<12 THEN BARSIZE:=12; { Force ! }
  IF POINTS>1 THEN
  BEGIN
   BARMULTI:=B-BARSIZE;
   BARDIV:=POINTS-1;
  END
  ELSE
  BEGIN
   BARMULTI:=1;
   BARDIV:=1;
  END;
  BARPOS:=CURP*BARMULTI DIV BARDIV;
 END ELSE BARVIS:=FALSE;
END;
CONSTRUCTOR THSCROLLBAR.INIT(BAS,GR:POBJ;X,Y:LONGINT;H,B:DWORD;VIS:LONGBOOL;PP,MP:DWORD);
BEGIN
 INHERITED INIT(BAS,GR,X,Y,H,B,VIS);
 POINTS:=MP;
 CURP:=PP;
 IF MP=0 THEN CURP:=0 ELSE IF CURP>POINTS-1 THEN CURP:=POINTS-1;
 CALCBAR;
END;
PROCEDURE TVSCROLLBAR.ONSIZE;
BEGIN
 CALCBAR;
END;
FUNCTION TVSCROLLBAR.GETRANGE:DWORD;
BEGIN
 GETRANGE:=POINTS;
END;
PROCEDURE TVSCROLLBAR.SETRANGE(W:DWORD);
BEGIN
 IF W<>POINTS THEN
 BEGIN
  POINTS:=W;
  CALCBAR;
  REDRAW;
  SETPOS(CURP);
 END;
END;
FUNCTION TVSCROLLBAR.GETPOS:DWORD;
BEGIN
 GETPOS:=CURP;
END;
PROCEDURE TVSCROLLBAR.ONCHANGE(POS:DWORD);
BEGIN
END;
PROCEDURE TVSCROLLBAR.SETPOS(W:DWORD);
BEGIN
 IF LONGINT(W)>LONGINT(POINTS-1) THEN W:=POINTS-1;
 IF LONGINT(W)<0 THEN W:=0;
 IF CURP<>W THEN
 BEGIN
  CURP:=W;
  IF BARVIS THEN BARPOS:=CURP*BARMULTI DIV BARDIV;
  ONCHANGE(CURP);
  REDRAW;
 END;
END;
PROCEDURE TVSCROLLBAR.ONMOUSE(X,Y:LONGINT;B,OB:DWORD;AX,AY:LONGINT);
VAR NY:LONGINT;
BEGIN
 CASE BSTAT OF
  0:IF (OB=0) AND (B=1) THEN
  BEGIN
   OLDPOS:=CURP;
   IF (Y<20) THEN
   BEGIN
    BSTAT:=2;
    SETPOS(CURP-1);
    REDRAW;
   END ELSE IF (Y>=HI-20) THEN
   BEGIN
    BSTAT:=3;
    SETPOS(CURP+1);
    REDRAW;
   END ELSE IF (BARVIS) THEN
   BEGIN
    BSTAT:=1;
    NY:=Y-20-BARSIZE DIV 2;
    IF NY<0 THEN NY:=0;
    IF NY>HI-40-BARSIZE THEN NY:=HI-40-BARSIZE;
    SETPOS(NY*BARDIV DIV BARMULTI);
   END;
  END;
  1:IF B=1 THEN
  BEGIN
   NY:=Y-20-BARSIZE DIV 2;
   IF NY<0 THEN NY:=0;
   IF NY>HI-40-BARSIZE THEN NY:=HI-40-BARSIZE;
   SETPOS(NY*BARDIV DIV BARMULTI);
  END
  ELSE
  BEGIN
   IF B<>0 THEN SETPOS(OLDPOS);
   BSTAT:=0;
  END;
  2:IF B<>1 THEN
  BEGIN
   IF B<>0 THEN SETPOS(OLDPOS);
   BSTAT:=0;
   REDRAW;
  END;
  3:IF B<>1 THEN
  BEGIN
   IF B<>0 THEN SETPOS(OLDPOS);
   BSTAT:=0;
   REDRAW;
  END;
 END;
END;
PROCEDURE TVSCROLLBAR.ONPAINT;
VAR Y:LONGINT;
    B:DWORD;
BEGIN
 CLEAR(CL_RED);
 IF BSTAT<>3 THEN
 BEGIN
  BAR3D(0,HI-20,20,WI);
  DRAWSPOINTERDOWN(WI DIV 2-4,HI-12,4,CL_BLACK);
 END
 ELSE
 BEGIN
  BARI3D(0,HI-20,20,WI);
  DRAWSPOINTERDOWN(WI DIV 2-3,HI-11,4,CL_BLACK);
 END;
 IF BSTAT<>2 THEN
 BEGIN
  BAR3D(0,0,20,WI);
  DRAWSPOINTERUP(WI DIV 2-4,8,4,CL_BLACK);
 END
 ELSE
 BEGIN
  BARI3D(0,0,20,WI);
  DRAWSPOINTERUP(WI DIV 2-3,9,4,CL_BLACK);
 END;
 IF BARVIS THEN
 BEGIN
  BAR3D(0,20+BARPOS,BARSIZE,WI);
  Y:=20+BARPOS+BARSIZE DIV 2;
  B:=WI-8;
  BAR(4,Y-4,1,B,CL_GRAY);
  BAR(4,Y-3,1,B,CL_LSILVER);
  BAR(4,Y-1,1,B,CL_GRAY);
  BAR(4,Y,1,B,CL_LSILVER);
  BAR(4,Y+2,1,B,CL_GRAY);
  BAR(4,Y+3,1,B,CL_LSILVER);
 END;
END;
PROCEDURE TVSCROLLBAR.CALCBAR;
VAR H:DWORD;
BEGIN
 IF HI>=52 THEN
 BEGIN
  H:=HI-40;
  BARVIS:=TRUE;
  IF POINTS<>0 THEN BARSIZE:=H-(POINTS-1) ELSE BARSIZE:=H;
  IF LONGINT(BARSIZE)<12 THEN BARSIZE:=12; { Force ! }
  IF POINTS>1 THEN
  BEGIN
   BARMULTI:=H-BARSIZE;
   BARDIV:=POINTS-1;
  END
  ELSE
  BEGIN
   BARMULTI:=1;
   BARDIV:=1;
  END;
  BARPOS:=CURP*BARMULTI DIV BARDIV;
 END ELSE BARVIS:=FALSE;
END;
CONSTRUCTOR TVSCROLLBAR.INIT(BAS,GR:POBJ;X,Y:LONGINT;H,B:DWORD;VIS:LONGBOOL;PP,MP:DWORD);
BEGIN
 INHERITED INIT(BAS,GR,X,Y,H,B,VIS);
 POINTS:=MP;
 CURP:=PP;
 IF MP=0 THEN CURP:=0 ELSE IF CURP>POINTS-1 THEN CURP:=POINTS-1;
 CALCBAR;
END;
PROCEDURE TWINDOW.ONNSELECT;
BEGIN
 REDRAW;
END;
PROCEDURE TWINDOW.ONSELECT;
BEGIN
 BRINGTOFRONT;
 REDRAW;
END;
PROCEDURE TWINDOW.ONFOCUS;
BEGIN
 BRINGTOFRONT;
 REDRAW;
END;
PROCEDURE TWINDOW.CHECKSIZE;
BEGIN
 IF LONGINT(HI)<33 THEN HI:=33;
 IF LONGINT(WI)<33 THEN WI:=33;
END;
PROCEDURE TWINDOW.ONSIZE;
VAR I:DWORD;
BEGIN
 TITLEBAR^.SIZE(23,WI-8);
 FOR I:=1 TO 9 DO SIZEF[I]^.ADJUST;
 APPF^.SIZE(HI-33,WI-8);
END;
PROCEDURE TWINDOW_SIZE.ONMOUSE(X,Y:LONGINT;B,OLDB:DWORD;AX,AY:LONGINT);
BEGIN
 IF SIZEING THEN
 BEGIN
  CASE TYP OF
   1:WINDOW^.MOVESIZE(OX+AX-BX,OY,OH+AY-BY,OB-AX+BX);
   2:WINDOW^.SIZE(OH+AY-BY,OB);
   3:WINDOW^.SIZE(OH+AY-BY,OB+AX-BX);
   4:WINDOW^.MOVESIZE(OX+AX-BX,OY,OH,OB-AX+BX);
   6:WINDOW^.SIZE(OH,OB+AX-BX);
   7:WINDOW^.MOVESIZE(OX+AX-BX,OY+AY-BY,OH-AY+BY,OB-AX+BX);
   8:WINDOW^.MOVESIZE(OX,OY+AY-BY,OH-AY+BY,OB);
   9:WINDOW^.MOVESIZE(OX,OY+AY-BY,OH-AY+BY,OB+AX-BX);
  END;
  IF B<>1 THEN
  BEGIN
   IF B<>0 THEN WINDOW^.MOVESIZE(OX,OY,OH,OB);
   SIZEING:=FALSE;
  END;
 END
 ELSE
 BEGIN
  IF (WINDOW^.SIZEABLE) AND (OLDB=0) AND (B=1) THEN
  BEGIN
   SIZEING:=TRUE;
   OX:=WINDOW^.XP;
   OY:=WINDOW^.YP;
   OH:=WINDOW^.HI;
   OB:=WINDOW^.WI;
   BX:=AX;
   BY:=AY;
  END;
 END;
END;
PROCEDURE TWINDOW_SIZE.ADJUST;
BEGIN
 CASE TYP OF
  1:MOVE(0,WINDOW^.HI-4);
  2:MOVESIZE(4,WINDOW^.HI-4,4,WINDOW^.WI-8);
  3:MOVE(WINDOW^.WI-4,WINDOW^.HI-4);
  4:SIZE(WINDOW^.HI-8,4);
  6:MOVESIZE(WINDOW^.WI-4,4,WINDOW^.HI-8,4);
  8:SIZE(4,WINDOW^.WI-8);
  9:MOVE(WINDOW^.WI-4,0);
 END;
END;
CONSTRUCTOR TWINDOW_SIZE.INIT(BAS:PWINDOW;T:DWORD);
BEGIN
 TYP:=T;
 WINDOW:=BAS;
 CASE T OF
  1:
  BEGIN
   MX:=7;
   MY:=7;
   INHERITED INIT(BAS,BAS,0,BAS^.HI-4,4,4,TRUE);
   SETSTDMOUSEPIC(MSP_SZ19);
  END;
  2:
  BEGIN
   MX:=7;
   MY:=7;
   INHERITED INIT(BAS,BAS,4,BAS^.HI-4,4,BAS^.WI-8,TRUE);
   SETSTDMOUSEPIC(MSP_SZ28);
  END;
  3:
  BEGIN
   MX:=7;
   MY:=7;
   INHERITED INIT(BAS,BAS,BAS^.WI-4,BAS^.HI-4,4,4,TRUE);
   SETSTDMOUSEPIC(MSP_SZ37);
  END;
  4:
  BEGIN
   MX:=7;
   MY:=7;
   INHERITED INIT(BAS,BAS,0,4,BAS^.HI-8,4,TRUE);
   SETSTDMOUSEPIC(MSP_SZ46);
  END;
  6:
  BEGIN
   MX:=7;
   MY:=7;
   INHERITED INIT(BAS,BAS,BAS^.WI-4,4,BAS^.HI-8,4,TRUE);
   SETSTDMOUSEPIC(MSP_SZ46);
  END;
  7:
  BEGIN
   MX:=7;
   MY:=7;
   INHERITED INIT(BAS,BAS,0,0,4,4,TRUE);
   SETSTDMOUSEPIC(MSP_SZ37);
  END;
  8:
  BEGIN
   MX:=7;
   MY:=7;
   INHERITED INIT(BAS,BAS,4,0,4,BAS^.WI-8,TRUE);
   SETSTDMOUSEPIC(MSP_SZ28);
  END;
  9:
  BEGIN
   MX:=7;
   MY:=7;
   INHERITED INIT(BAS,BAS,BAS^.WI-4,0,4,4,TRUE);
   SETSTDMOUSEPIC(MSP_SZ19);
  END;
 END;
END;
PROCEDURE TWINDOW_TIT.ONMOUSE(X,Y:LONGINT;B,OB:DWORD;AX,AY:LONGINT);
BEGIN
 IF DRAGGING THEN
 BEGIN
  WINDOW^.MOVE(OX+AX-BX,OY+AY-BY);
  IF B<>1 THEN
  BEGIN
   IF B<>0 THEN WINDOW^.MOVE(OX,OY);
   DRAGGING:=FALSE;
  END;
 END
 ELSE
 BEGIN
  IF (OB=0) AND (B=1) THEN
  BEGIN
   DRAGGING:=TRUE;
   BX:=AX;
   BY:=AY;
   OX:=WINDOW^.XP;
   OY:=WINDOW^.YP;
  END;
 END;
END;
PROCEDURE TWINDOW_TIT.ONPAINT;
BEGIN
 SELECTFONT(WINDOW^.FONT^);
 IF WINDOW^.SELECTED THEN
 BEGIN
  CLEAR(CL_BLUE);
  PUTSTRING(2,
            LONGINT(HI-GETSTRINGHEIGHT(WINDOW^.FONTS)) DIV 2,WINDOW^.TITLE,
            CL_YELLOW,12);
 END
 ELSE
 BEGIN
  CLEAR(CL_GRAY);
  PUTSTRING(2,
            LONGINT(HI-GETSTRINGHEIGHT(WINDOW^.FONTS)) DIV 2,WINDOW^.TITLE,
            CL_SILVER,12);
 END;
END;
CONSTRUCTOR TWINDOW_TIT.INIT(BAS:PWINDOW);
BEGIN
 INHERITED INIT(BAS,BAS,4,4,23,BAS^.WI-8,TRUE);
 WINDOW:=BAS;
END;
PROCEDURE TWINDOW.ONPAINT;
BEGIN
 BAR3D(0,0,HI,WI);
END;
CONSTRUCTOR TWINDOW.INIT(BAS:POBJ;X,Y:LONGINT;H,B:DWORD;VIS:LONGBOOL;TIT:STRING;FON:PSTRING;SZ:DWORD);
VAR I:DWORD;
BEGIN
 INHERITED INIT(BAS,NIL,X,Y,H,B,VIS);
 SIZEABLE:=TRUE;
 TITLE:=TIT;
 FONT:=FON;
 FONTS:=SZ;
 NEW(TITLEBAR,INIT(@SELF));
 FOR I:=1 TO 9 DO NEW(SIZEF[I],INIT(@SELF,I));
 NEW(APPF,INIT(@SELF,@SELF,4,29,HI-33,WI-8,TRUE));
 SETAPPOBJ(APPF);
END;
PROCEDURE TDESKTOP.ONPAINT;
BEGIN
 CLEAR(COLOR);
END;
CONSTRUCTOR TDESKTOP.INIT(CRGB:DWORD);
BEGIN
 INHERITED INIT(NIL,NIL,0,0,GRAPH.HEIGHT,GRAPH.WIDTH,TRUE);
 COLOR_RGB:=CRGB;
 COLOR:=CONV(CRGB);
END;
PROCEDURE TBUTTON.ONCLICK;
BEGIN
 IF ONCLICKP<>NIL THEN ONCLICKP(@SELF);
END;
PROCEDURE TBUTTON.ONMOUSE(X,Y:LONGINT;B,OB:DWORD;AX,AY:LONGINT);
BEGIN
 IF DOWN THEN
 BEGIN
  IF (B<>1) OR (DWORD(X)>=WI) OR (DWORD(Y)>=HI) THEN
  BEGIN
   IF (B=0) AND (DWORD(X)<WI) AND (DWORD(Y)<HI) THEN ONCLICK;
   DOWN:=FALSE;
   REDRAW;
  END;
 END
 ELSE
 BEGIN
  IF (B=1) AND (DWORD(X)<WI) AND (DWORD(Y)<HI) THEN
  BEGIN
   DOWN:=TRUE;
   REDRAW;
  END;
 END;
END;
PROCEDURE TBUTTON.ONPAINT;
VAR PX,PY,PX2,PY2:LONGINT;
    PB:DWORD;
BEGIN
 SELECTFONT(FONT^);
 IF DOWN THEN BARI3D(0,0,HI,WI) ELSE BAR3D(0,0,HI,WI);
 PB:=GETSTRINGWIDTH(CAPTION,12);
 IF PIC<>NIL THEN
 BEGIN
  PX:=(WI-PIC^.B) DIV 2;
  IF CAPTION='' THEN
  BEGIN
   PY:=(HI-PIC^.H) DIV 2;
   IF DOWN THEN
   BEGIN
    PUTPIC(PX+1,PY+1,PIC);
   END
   ELSE
   BEGIN
    PUTPIC(PX,PY,PIC);
   END;
  END
  ELSE
  BEGIN
   PX2:=(WI-PB) DIV 2;
   PY:=(HI-(PIC^.H+GETSTRINGHEIGHT(FONTS)+5)) DIV 2;
   PY2:=PY+PIC^.H;
   IF DOWN THEN
   BEGIN
    PUTPIC(PX+1,PY+1,PIC);
    PUTSTRING(PX2+1,PY2+1,CAPTION,CL_BLACK,FONTS);
   END
   ELSE
   BEGIN
    PUTPIC(PX,PY,PIC);
    PUTSTRING(PX2,PY2,CAPTION,CL_BLACK,FONTS);
   END;
  END;
 END
 ELSE
 BEGIN
  PX:=(WI-PB) DIV 2;
  PY:=(HI-GETSTRINGHEIGHT(FONTS)) DIV 2;
  IF DOWN THEN
  BEGIN
   PUTSTRING(PX+1,PY+1,CAPTION,CL_BLACK,FONTS);
  END
  ELSE
  BEGIN
   PUTSTRING(PX,PY,CAPTION,CL_BLACK,FONTS);
  END;
 END;
END;
CONSTRUCTOR TBUTTON.INIT(BAS,GROUP:POBJ;X,Y:LONGINT;H,B:DWORD;VIS:LONGBOOL;CAP:STRING;PI:PPICTURE;FON:PSTRING;FONS:DWORD);
BEGIN
 INHERITED INIT(BAS,GROUP,X,Y,H,B,VIS);
 CAPTION:=CAP;
 FONT:=FON;
 FONTS:=FONS;
 PIC:=PI;
END;
END.
