UNIT IRQS;
INTERFACE
{$I ..\INCLUDE\IRQS.DEF}
VAR ADDIRQHANDLER:PROCEDURE(IRQ:DWORD;P:PIRQHANDLER);
    ADDIRQHANDLERAEOI:PROCEDURE(IRQ:DWORD;P:PIRQHANDLER);
    REMOVEIRQHANDLER:PROCEDURE(IRQ:DWORD;P:PIRQHANDLER);
    REMOVEIRQHANDLERAEOI:PROCEDURE(IRQ:DWORD;P:PIRQHANDLER);
    ENABLEIRQ:PROCEDURE(NR:DWORD);
    DISABLEIRQ:PROCEDURE(NR:DWORD);
    GETIRQ:FUNCTION(NR:DWORD):LONGBOOL;
    GETIRQALONE:FUNCTION(NR:DWORD):LONGBOOL;
    FREEIRQ:PROCEDURE(NR:DWORD);
IMPLEMENTATION
VAR IRQPROT1:PPOINTERARRAY;
    IRQSDRV:PDRIVER;
INITIALIZATION
 IRQPROT1:=WAITFORADRIVER(5,1,IRQSDRV);
 POINTER(ADDIRQHANDLER):=IRQPROT1^[0];
 POINTER(ADDIRQHANDLERAEOI):=IRQPROT1^[1];
 POINTER(REMOVEIRQHANDLER):=IRQPROT1^[2];
 POINTER(REMOVEIRQHANDLERAEOI):=IRQPROT1^[3];
 POINTER(ENABLEIRQ):=IRQPROT1^[4];
 POINTER(DISABLEIRQ):=IRQPROT1^[5];
 POINTER(GETIRQ):=IRQPROT1^[6];
 POINTER(GETIRQALONE):=IRQPROT1^[7];
 POINTER(FREEIRQ):=IRQPROT1^[8];
 ASM
   STI
 END;
FINALIZATION
 ASM
   CLI
 END;
 SIGNALEXIT(IRQSDRV,1);
END.
