UNIT TASKS;
INTERFACE
VAR STARTREADPROCESSLIST:FUNCTION:DWORD;
    STOPREADPROCESSLIST:PROCEDURE(GR:DWORD);
    GETFIRSTPROCESS:FUNCTION:POINTER;
    GETNEXTPROCESS:FUNCTION(P:POINTER):POINTER;
    GETTASKENABLE:FUNCTION(T:POINTER):DWORD;
    ENTERSCHEDULER:FUNCTION(T:POINTER):LONGBOOL;
    LEAVESCHEDULER:PROCEDURE(T:POINTER);
    GETFIRSTTASK:FUNCTION(P:POINTER):POINTER;
    GETNEXTTASK:FUNCTION(T:POINTER):POINTER;
    GETTASKTSS:FUNCTION(T:POINTER):DWORD;
    STARTREADTASKLIST:FUNCTION(P:POINTER):DWORD;
    STOPREADTASKLIST:PROCEDURE(P:POINTER;GR:DWORD);
    GETTASKDESC:FUNCTION(T:POINTER):STRING;
    GETPROCESSDESC:FUNCTION(P:POINTER):STRING;
PROCEDURE WRITETASKLIST;
IMPLEMENTATION
VAR TASKSDRV:PDRIVER;
    TASKSPROT:PPOINTERARRAY;
PROCEDURE WRITETASKLIST;
VAR P,T:POINTER;
    GR,GR2:DWORD;
BEGIN
 GR:=STARTREADPROCESSLIST();
 P:=GETFIRSTPROCESS();
 WRITESTR('[Tasks]ͻ');
 WRITESTR(' Process   Task      Activ     Description                                 ');
 WRITESTR('Ķ');
 WHILE P<>NIL DO
 BEGIN
  GR2:=STARTREADTASKLIST(P);
  WRITESTR(' '+FORMATRSTR(HEXSTR(DWORD(P)),8)+'                      '+
             FORMATLSTR(GETPROCESSDESC(P),43)+' ');
  T:=GETFIRSTTASK(P);
  WHILE T<>NIL DO
  BEGIN
   WRITESTR('           '+FORMATRSTR(HEXSTR(DWORD(T)),8)+'  '+
              FORMATRSTR(HEXSTR(GETTASKENABLE(T)),8)+'  '+FORMATLSTR(GETTASKDESC(T),43)+' ');
   T:=GETNEXTTASK(T);
  END;
  STOPREADTASKLIST(P,GR2);
  P:=GETNEXTPROCESS(P);
 END;
 WRITESTR('ͼ');
 STOPREADPROCESSLIST(GR);
END;
INITIALIZATION
 TASKSPROT:=WAITFORADRIVER(1,2,TASKSDRV);
 POINTER(STARTREADPROCESSLIST):=TASKSPROT^[0];
 POINTER(STOPREADPROCESSLIST):=TASKSPROT^[1];
 POINTER(GETFIRSTPROCESS):=TASKSPROT^[2];
 POINTER(GETNEXTPROCESS):=TASKSPROT^[3];
 POINTER(GETTASKENABLE):=TASKSPROT^[4];
 POINTER(ENTERSCHEDULER):=TASKSPROT^[5];
 POINTER(LEAVESCHEDULER):=TASKSPROT^[6];
 POINTER(GETFIRSTTASK):=TASKSPROT^[7];
 POINTER(GETNEXTTASK):=TASKSPROT^[8];
 POINTER(GETTASKTSS):=TASKSPROT^[9];
 POINTER(GETTASKDESC):=TASKSPROT^[10];
 POINTER(GETPROCESSDESC):=TASKSPROT^[11];
 POINTER(STARTREADTASKLIST):=TASKSPROT^[12];
 POINTER(STOPREADTASKLIST):=TASKSPROT^[13];
FINALIZATION
 SIGNALEXIT(TASKSDRV,2);
END.
