PROGRAM MFS;
USES FSDRV,MEMORY;
{$I ..\INCLUDE\FS.DEF}
TYPE PMFSE=^TMFSE;
     TMFSE=RECORD
      TYP:DWORD; { 0=Directory }
      NEXT,LAST,FATHER,CHILD:PMFSE; { CHILD kann alles sein ! }
      NAME:PCHAR;
      WID,RID,AID:DWORD;
     END;
FUNCTION CREATEMFSDIR(BAS:PMFSE;NAME:PCHAR;RID,WID,AID:DWORD):DWORD;FORWARD;
FUNCTION DESTROYMFSE(P:PMFSE):DWORD;FORWARD;
FUNCTION FINDFIRST(VAR BAS:PMFSE;NAME:PCHAR;VAR CLASS:DWORD):DWORD;FORWARD;
FUNCTION FINDNEXT(VAR POS:PMFSE;NAME:PCHAR;VAR CLASS:DWORD):DWORD;FORWARD;
FUNCTION NAMEEXISTS(BAS:PMFSE;NAME:PCHAR;VAR CLASS:DWORD;VAR DATA,CALL:POINTER;VAR RI,WI,AI:DWORD):DWORD;FORWARD;
FUNCTION CHECKNAME(NAME:PCHAR):DWORD;FORWARD;
PROCEDURE RELEASEDIRP(DATA:POINTER);FORWARD;
CONST MFSCALLPROT2:ARRAY[0..6] OF POINTER=(
       @CREATEMFSDIR,
       @DESTROYMFSE,
       @FINDFIRST,
       @FINDNEXT,
       @NAMEEXISTS,
       @CHECKNAME,
       @RELEASEDIRP);
VAR ROOTDIR:PMFSE;
PROCEDURE RELEASEDIRP(DATA:POINTER);
BEGIN
END;
FUNCTION CHECKNAME(NAME:PCHAR):DWORD;
BEGIN
 IF (NAME^=#0) OR (NAME='.') OR (NAME='..') THEN
 BEGIN
  CHECKNAME:=FS_ILLEGALNAME;
  EXIT;
 END
 ELSE
 BEGIN
  WHILE NAME^<>#0 DO
  BEGIN
   IF NAME^ IN ['/','?','*',':'] THEN
   BEGIN
    CHECKNAME:=FS_ILLEGALNAME;
    EXIT;
   END;
   INC(NAME);
  END;
 END;
 CHECKNAME:=FS_SUCCESSFULL;
END;
FUNCTION FINDFIRST(VAR BAS:PMFSE;NAME:PCHAR;VAR CLASS:DWORD):DWORD;
BEGIN
 IF BAS^.CHILD<>NIL THEN
 BEGIN
  BAS:=BAS^.CHILD;
  MOVE(BAS^.NAME^,NAME^,LENGTH(BAS^.NAME)+1);
  IF BAS^.TYP=0 THEN CLASS:=2;
  FINDFIRST:=FS_SUCCESSFULL;  
 END ELSE FINDFIRST:=FS_NOTHINGFOUND;
END;
FUNCTION FINDNEXT(VAR POS:PMFSE;NAME:PCHAR;VAR CLASS:DWORD):DWORD;
BEGIN
 IF POS^.NEXT<>NIL THEN
 BEGIN
  POS:=POS^.NEXT;
  MOVE(POS^.NAME^,NAME^,LENGTH(POS^.NAME)+1);
  IF POS^.TYP=0 THEN CLASS:=2;
  FINDNEXT:=FS_SUCCESSFULL;
 END ELSE FINDNEXT:=FS_NOTHINGFOUND;
END;
FUNCTION NAMEEXISTS(BAS:PMFSE;NAME:PCHAR;VAR CLASS:DWORD;VAR DATA,CALL:POINTER;VAR RI,WI,AI:DWORD):DWORD;
BEGIN
 IF BAS^.CHILD<>NIL THEN
 BEGIN
  BAS:=BAS^.CHILD;
  WHILE BAS<>NIL DO
  BEGIN
   IF COMPARE(BAS^.NAME,NAME) THEN
   BEGIN
    { Vorsicht, hier Sonderflle beachten. }
    { Hier sollen spter andere DATA/CALL mglich sein, um simpel
      Unterverzeichnisse einbinden zu knnen ! }
    { Zunchst nur Interne Verzeichnisse/Dateien }
    CASE BAS^.TYP OF
     0:
     BEGIN
      CLASS:=2;
      DATA:=BAS;
      CALL:=@MFSCALLPROT2;
      RI:=BAS^.RID;
      WI:=BAS^.WID;
      AI:=BAS^.AID;
     END;
    END;
    NAMEEXISTS:=FS_SUCCESSFULL;
    EXIT;
   END;
   BAS:=BAS^.NEXT;
  END;
 END;
 NAMEEXISTS:=FS_NOTPRESENT;
END;
FUNCTION CREATEMFSDIR(BAS:PMFSE;NAME:PCHAR;RID,WID,AID:DWORD):DWORD;
VAR LEN:DWORD;
    P:PMFSE;
BEGIN
 NEW(P); {SSP}
 LEN:=LENGTH(NAME);
 GETMEM(P^.NAME,LEN+1); {SSP}
 MOVE(NAME^,P^.NAME^,LEN);
 (P^.NAME+LEN)^:=#0;
 P^.LAST:=NIL;
 P^.FATHER:=BAS;
 P^.CHILD:=NIL;
 P^.RID:=RID;
 P^.WID:=WID;
 P^.AID:=AID;
 P^.TYP:=0; { Directory ! }
 IF BAS=NIL THEN
 BEGIN
  P^.NEXT:=NIL;
  ROOTDIR:=P;
 END
 ELSE
 BEGIN
  P^.NEXT:=BAS^.CHILD;
  IF P^.NEXT<>NIL THEN P^.NEXT^.LAST:=P;
  BAS^.CHILD:=P;
 END;
 CREATEMFSDIR:=FS_SUCCESSFULL;
END;
FUNCTION DESTROYMFSE(P:PMFSE):DWORD;
BEGIN
 CASE P^.TYP OF
  0:
  BEGIN
   { Hier wird nur die simple-Variante untersttzt ! CHILD=NIL ! }
   IF P^.CHILD<>NIL THEN
   BEGIN
    DESTROYMFSE:=FS_DIRECTORYNOTEMPTY;
    EXIT;
   END;
  END;
 END;
 FREEMEM(P^.NAME,LENGTH(P^.NAME)+1);
 IF P^.LAST<>NIL THEN P^.LAST^.NEXT:=P^.NEXT ELSE IF P^.FATHER<>NIL THEN P^.FATHER^.CHILD:=P^.NEXT;
 IF P^.NEXT<>NIL THEN P^.NEXT^.LAST:=P^.LAST;
 DISPOSE(P);
 DESTROYMFSE:=FS_SUCCESSFULL;
END;
PROCEDURE UNINSTALLMFSDRV;
BEGIN
 SIGNALSHUTDOWNOK;
 HALT;
END;
PROCEDURE FREEMFSPROT(NR:DWORD);
BEGIN
END;
CONST MFS_PROT0:ARRAY[0..1] OF POINTER=(
       @UNINSTALLMFSDRV,
       @FREEMFSPROT);
FUNCTION DOCK_MFS(NR:DWORD):POINTER;
BEGIN
 CASE NR OF
  0:DOCK_MFS:=@MFS_PROT0;
  ELSE DOCK_MFS:=NIL;
 END;
END;
CONST MFSDRV:TDRIVER=(NEXT:NIL;LAST:NIL;TYP:$15;ID:0;GETPROT:@DOCK_MFS;
                      DESC:'Memory File System ()');
BEGIN
 STARTDRIVERINITIALIZATION;
 IF CREATEMFSDIR(NIL,'',0,0,0)<>0 THEN
 BEGIN
  STOPDRIVERINITIALIZATION;
  HALT('Fehler beim erstellen des Root-Verzeichnisses !');
 END;
 IF NOT SETROOTFS(ROOTDIR,@MFSCALLPROT2) THEN
 BEGIN
  DESTROYMFSE(ROOTDIR);
  STOPDRIVERINITIALIZATION;
  HALT('Es gibt bereits ein ROOT-FS !');
 END;
 ADDDRIVER(@MFSDRV);
 STOPDRIVERINITIALIZATION;
END.
