FUNCTION TRYMODE:POINTER;
BEGIN
 WRSEG:=0;
 IF (MODEINFO.WINBATTR AND 1=1) THEN
 BEGIN
  IF (MODEINFO.WINBATTR AND 4<>0) THEN
  BEGIN
   WRSEG:=MODEINFO.WINBSEG;
   WRWIN:=1;
  END;
 END;
 IF (MODEINFO.WINAATTR AND 1=1) THEN
 BEGIN
  IF (MODEINFO.WINAATTR AND 4<>0) THEN
  BEGIN
   WRSEG:=MODEINFO.WINASEG;
   WRWIN:=0;
  END;
 END;
 IF WRSEG=0 THEN
 BEGIN
  TRYMODE:=NIL;
  EXIT;
 END;
 WRSEGL:=DWORD(WRSEG)*16;
 WIDTH:=MODEINFO.XRES;
 HEIGHT:=MODEINFO.YRES;
 ADDX:=0;
 ADDY:=0;
 SUBX:=0;
 SUBY:=0;
 MAXX:=WIDTH-1;
 MAXY:=HEIGHT-1;
 AREAVIS:=FALSE;
 VIS:=TRUE;
 PIXELS:=HEIGHT*WIDTH;
 CASE MODEINFO.BPP OF
  8:TRYMODE:=INIT8BITMODE;
  32:TRYMODE:=INIT32BITMODE;
  ELSE TRYMODE:=NIL;
 END;
 IF TRYMODE<>NIL THEN
 BEGIN
  CL_BLACK:=CONV($000000);
  CL_BLUE:=CONV($7F0000);
  CL_GREEN:=CONV($007F00);
  CL_RED:=CONV($00007F);
  CL_GRAY:=CONV($7F7F7F);
  CL_SILVER:=CONV($BFBFBF);
  CL_YELLOW:=CONV($00FFFF);
  CL_WHITE:=CONV($FFFFFF);
  CL_LSILVER:=CONV($CFCFCF);
  CL_LBLUE:=CONV($FF0000);
 END;
END;
FUNCTION INITMODE(WIDTH,HEIGHT,BPP:DWORD):POINTER;
VAR I:DWORD;
    REGS:TREGISTERS;
BEGIN
 IF (HEIGHT=200) AND (WIDTH=320) AND (BPP=8) THEN
 BEGIN
  INITMODE:=INIT320X200X8;
  IF INITMODE<>NIL THEN
  BEGIN
   CURMODESPECPROCS:=INITMODE;
   EXIT;
  END;
 END;
 { Ein LOCK sollte hier rein ! => Bis Grafikmodus beendet ! }
 { Vorerst mal nur die Liste durchgehen... }
 IF MODECOUNT=0 THEN
 BEGIN
  INITMODE:=NIL;
  EXIT;
 END;
 FOR I:=0 TO MODECOUNT-1 DO
 BEGIN
  SELECTMODE(MODES^[I]);
  IF (MODEINFO.YRES=HEIGHT) AND (MODEINFO.XRES=WIDTH) AND
     (MODEINFO.BPP=BPP) THEN
  BEGIN
   INITMODE:=TRYMODE;
   IF INITMODE<>NIL THEN
   BEGIN
    CURMODESPECPROCS:=INITMODE;
    EXIT;
   END;
  END;
 END;
 INITMODE:=NIL;
END;
FUNCTION COUNTMODES(P:POINTER):DWORD;ASSEMBLER;
ASM
  MOV EDI,P
  XOR EAX,EAX
 @LP:
  INC EAX
  MOV BX,FS:[EDI]
  INC EDI
  INC EDI
  CMP BX,0FFFFh
  JNZ @LP
  DEC EAX
END;
FUNCTION INITVESA:BOOLEAN;
VAR REALMODEBUFFER:POINTER;
    REGS:TREGISTERS;
    TABLE:POINTER;
BEGIN
 REPEAT
  REALMODEBUFFER:=ALLOCREALMODEBUFFER(4096);
 UNTIL REALMODEBUFFER<>NIL;
 REGS.EAX:=$4F00;
 REGS.ES:=DWORD(REALMODEBUFFER) SHR 4;
 REGS.EDI:=DWORD(REALMODEBUFFER) AND $F;
 REALINT($10,REGS);
 MOVE(REALMODEBUFFER^,MAININFO,SIZEOF(TMAININFO));
 IF (MAININFO.VESASIGN<>'VESA') THEN
 BEGIN
  RELEASEREALMODEBUFFER(REALMODEBUFFER,4096);
  INITVESA:=FALSE;
  EXIT;
 END;
 MAININFO.OEM:=POINTER((DWORD(MAININFO.OEM) SHR 16) SHL 4+DWORD(MAININFO.OEM) AND $FFFF);
 MAININFO.MODES:=POINTER((DWORD(MAININFO.MODES) SHR 16) SHL 4+DWORD(MAININFO.MODES) AND $FFFF);
 MODECOUNT:=COUNTMODES(MAININFO.MODES);
 GETMEM(MODES,MODECOUNT*2);
 MOVE(MAININFO.MODES^,MODES^,MODECOUNT*2);
 RELEASEREALMODEBUFFER(REALMODEBUFFER,4096);
 INITVESA:=TRUE;
END;
PROCEDURE DONEMODE;
BEGIN
 { Noch nicht implementiert, sollte aber schon benutzt werden, vor allem
   in INITMODE um einen bereits gesetzten Modus zu deinitialisieren ! }
 { Hier auch das MODELOCK beachten ! }
END;
FUNCTION JOINMODE(VAR HEIGHT,WIDTH:DWORD):POINTER;
BEGIN
 HEIGHT:=VESA.HEIGHT;
 WIDTH:=VESA.WIDTH;
 JOINMODE:=CURMODESPECPROCS;
END;
