PROCEDURE PUTPIC32(X,Y:LONGINT;PIC:PPICTURE);ASSEMBLER;
ASM
  MOV EAX,[VIS]
  OR EAX,EAX
  JZ @EXT
  MOV ESI,PIC
  MOV ECX,[ESI]                { Hhe berprfen }
  OR ECX,ECX
  JZ @EXT
  MOV EBX,[ESI+4]              { Breite berprfen }
  OR EBX,EBX
  JZ @EXT
  ADD ESI,8
  MOV EDX,Y                    {  Y-SUBY auf Signed berprfen ! }
  SUB EDX,SUBY
  JNS @NONEGY
  NEG EDX
  SUB ECX,EDX                  { Hhe korrigieren }
  JS @EXT
  JZ @EXT
  MOV EAX,EBX                  { Breite stimmt noch... (keine x-Prfung) }
  MUL EDX                      { Anfangsposition korrigieren }
  SHL EAX,2
  ADD ESI,EAX
  XOR EDX,EDX                  { Y=0 ! }
  JMP @TOKNEGY
 @NONEGY:
  CMP EDX,MAXY                 { Y innerhalb des Fensters ? }
  JA @EXT
 @TOKNEGY:
  MOV EDI,X                    { X-SUBX auf Signed berprfen ! }
  SUB EDI,SUBX
  JNS @NONEGX
  NEG EDI
  SUB EBX,EDI                  { Breite korrigieren ! }
  JS @EXT
  JZ @EXT
  SHL EDI,2                    { Anfangsposition korrigieren ! }
  ADD ESI,EDI
  XOR EDI,EDI                  { X=0 ! }
  JMP @TOKNEGX
 @NONEGX:
  CMP EDI,[MAXX]               { X innerhalb des Fensters ? }
  JA @EXT
 @TOKNEGX:
  { Breite mu noch berprft werden ! }
  MOV EAX,EDI
  ADD EAX,EBX
  CMP EAX,MAXX
  JNA @OVERFLOWX
  MOV EBX,MAXX
  SUB EBX,EDI
  INC EBX
 @OVERFLOWX:
  { Hhe mu noch berprft werden ! }
  MOV EAX,EDX
  ADD EAX,ECX
  CMP EAX,MAXY
  JNA @OVERFLOWY
  MOV ECX,MAXY
  SUB ECX,EDX
  INC ECX
 @OVERFLOWY:
  ADD EDI,ADDX                 { Fensterverschiebung X }
  ADD EDX,ADDY                 { Fensterverschiebung Y }
  MOV EAX,WIDTH
  MUL EDX
  ADD EDI,EAX                  { Damit ist in EDI schon mal die Pre-Ziel-Ver }
  SHL EDI,2
  ADD EDI,[BUFFER]             { Und Zielposition fertig ! }
  MOV EDX,ECX                  { EDX wird als Zhler fr die Hhe verwendet }
  MOV EAX,PIC                  { HADD berechnen => EAX }
  MOV EAX,[EAX+4]
  SUB EAX,EBX
  SHL EAX,2
  PUSH EBP
  MOV EBP,WIDTH
  SUB EBP,EBX
  SHL EBP,2
 @BIGLOOP:
  MOV ECX,EBX
  REP MOVSD
  ADD ESI,EAX
  ADD EDI,EBP
  DEC EDX
  JNE @BIGLOOP
  POP EBP
 @EXT:
END;
PROCEDURE CLEAR32(C:DWORD);ASSEMBLER;
ASM
  MOV EAX,VIS
  OR EAX,EAX
  JZ @EXT
  MOV EAX,WIDTH
  MOV EBX,EAX
  MOV ECX,[ADDY]
  MUL ECX
  ADD EAX,[ADDX]
  MOV EDX,[MAXX]
  INC EDX
  SHL EAX,2
  SUB EBX,EDX
  MOV EDI,EAX
  MOV ESI,[MAXY]
  INC ESI
  SHL EBX,2
  ADD EDI,[BUFFER]
  MOV EAX,C
 @LP:
  MOV ECX,EDX
  REP STOSD
  ADD EDI,EBX
  DEC ESI
  JNZ @LP
 @EXT:
END;
PROCEDURE PUTPIXEL32(X,Y:LONGINT;C:DWORD);ASSEMBLER;
ASM
  MOV EAX,VIS
  OR EAX,EAX
  JZ @EXT
  MOV EDX,Y
  SUB EDX,SUBY
  CMP EDX,MAXY
  JA @EXT
  MOV EAX,WIDTH
  MOV ECX,X
  SUB ECX,SUBX
  CMP ECX,MAXX
  JA @EXT
  ADD EDX,ADDY
  ADD ECX,ADDX
  MUL EDX
  ADD EAX,ECX
  SHL EAX,2
  ADD EAX,[BUFFER]
  MOV EBX,C
  MOV [EAX],EBX
 @EXT:
END;
PROCEDURE BAR32(X,Y:LONGINT;H,B,C:DWORD);ASSEMBLER;
ASM
  MOV EAX,VIS
  OR EAX,EAX
  JZ @EXT
  MOV ESI,H
  OR ESI,ESI
  JZ NEAR @EXT
  MOV EBX,B
  OR EBX,EBX
  JZ NEAR @EXT
  MOV ECX,X
  SUB ECX,[SUBX]
  JNS @NXSIGN
  ADD EBX,ECX
  JS @EXT
  JZ @EXT
  XOR ECX,ECX
  JMP @XSIGN
 @NXSIGN:
  CMP ECX,[MAXX]
  JA @EXT
 @XSIGN:
  MOV EDX,Y
  SUB EDX,[SUBY]
  JNS @NYSIGN
  ADD ESI,EDX
  JS @EXT
  JZ @EXT
  XOR EDX,EDX
  JMP @YSIGN
 @NYSIGN:
  CMP EDX,[MAXY]
  JA @EXT
 @YSIGN:
  MOV EAX,ECX
  ADD EAX,EBX
  JC @NXCOR
  CMP EAX,[MAXX]
  JNA @NXOVER
 @NXCOR:
  MOV EBX,[MAXX]
  SUB EBX,ECX
  INC EBX
 @NXOVER:
  MOV EAX,EDX
  ADD EAX,ESI
  JC @NYCOR
  CMP EAX,[MAXY]
  JNA @NYOVER
 @NYCOR:
  MOV ESI,[MAXY]
  SUB ESI,EDX
  INC ESI
 @NYOVER:
  MOV EAX,[WIDTH]
  ADD EDX,[ADDY]
  MUL EDX
  ADD EAX,ECX
  ADD EAX,[ADDX]
  SHL EAX,2
  MOV EDI,EAX
  ADD EDI,[BUFFER]
  MOV EDX,[WIDTH]
  SUB EDX,EBX
  SHL EDX,2
  MOV EAX,C
 @MAINLOOP:
  MOV ECX,EBX
  REP STOSD
  ADD EDI,EDX
  DEC ESI
  JNE @MAINLOOP
 @EXT:
END;
PROCEDURE SHOW32_LFB;ASSEMBLER;
ASM
{$IFNDEF DEBUG}
  MOV EAX,[AREAVIS]
  OR EAX,EAX
  JZ @EXT
  PUSH EBP
  MOV EAX,[WIDTH]
  MOV EBP,EAX
  MOV ECX,[AREAY]
  MUL ECX
  ADD EAX,[AREAX]
  SHL EAX,2
  MOV ESI,EAX
  MOV EDI,EAX
  ADD ESI,[BUFFER]
  ADD EDI,[FRAMEADDR]
  MOV EBX,[AREAB]
  SUB EBP,EBX
  SHL EBP,2
  MOV EDX,[AREAH]
 @LP:
  MOV ECX,EBX
  REP MOVSD
  ADD EDI,EBP
  ADD ESI,EBP
  DEC EDX
  JNE @LP
  POP EBP
 @EXT:
{$ENDIF}
END;
PROCEDURE BAR3D32(X,Y:LONGINT;H,B:DWORD);
BEGIN
 BAR32(X,Y,1,B,CL_LSILVER);
 BAR32(X,Y+1,H-2,1,CL_LSILVER);
 BAR32(X,Y+H-1,1,B,CL_BLACK);
 BAR32(X+B-1,Y+1,H-2,1,CL_BLACK);
 BAR32(X+1,Y+1,1,B-2,CL_WHITE);
 BAR32(X+1,Y+2,H-4,1,CL_WHITE);
 BAR32(X+1,Y+H-2,1,B-2,CL_GRAY);
 BAR32(X+B-2,Y+2,H-4,1,CL_GRAY);
 BAR32(X+2,Y+2,H-4,B-4,CL_SILVER);
END;
PROCEDURE FRAME3D32(X,Y:LONGINT;H,B:DWORD);
BEGIN
 BAR32(X,Y,1,B,CL_LSILVER);
 BAR32(X,Y+1,H-2,1,CL_LSILVER);
 BAR32(X,Y+H-1,1,B,CL_BLACK);
 BAR32(X+B-1,Y+1,H-2,1,CL_BLACK);
 BAR32(X+1,Y+1,1,B-2,CL_WHITE);
 BAR32(X+1,Y+2,H-4,1,CL_WHITE);
 BAR32(X+1,Y+H-2,1,B-2,CL_GRAY);
 BAR32(X+B-2,Y+2,H-4,1,CL_GRAY); 
END;
PROCEDURE BARI3D32(X,Y:LONGINT;H,B:DWORD);
BEGIN
 BAR32(X,Y,1,B,CL_GRAY);
 BAR32(X,Y+1,H-2,1,CL_GRAY);
 BAR32(X,Y+H-1,1,B,CL_WHITE);
 BAR32(X+B-1,Y+1,H-2,1,CL_WHITE);
 BAR32(X+1,Y+1,1,B-2,CL_BLACK);
 BAR32(X+1,Y+2,H-4,1,CL_BLACK);
 BAR32(X+1,Y+H-2,1,B-2,CL_LSILVER);
 BAR32(X+B-2,Y+2,H-4,1,CL_LSILVER);
 BAR32(X+2,Y+2,H-4,B-4,CL_SILVER);
END;
PROCEDURE FRAMEI3D32(X,Y:LONGINT;H,B:DWORD);
BEGIN
 BAR32(X,Y,1,B,CL_GRAY);
 BAR32(X,Y+1,H-2,1,CL_GRAY);
 BAR32(X,Y+H-1,1,B,CL_WHITE);
 BAR32(X+B-1,Y+1,H-2,1,CL_WHITE);
 BAR32(X+1,Y+1,1,B-2,CL_BLACK);
 BAR32(X+1,Y+2,H-4,1,CL_BLACK);
 BAR32(X+1,Y+H-2,1,B-2,CL_LSILVER);
 BAR32(X+B-2,Y+2,H-4,1,CL_LSILVER);
END;
PROCEDURE ABS_PUT32(X,Y:LONGINT;C:DWORD);ASSEMBLER;
ASM
  MOV EDX,Y
  CMP EDX,[HEIGHT]
  JNB @EXT
  MOV EAX,[WIDTH]
  MOV ECX,X
  CMP ECX,EAX
  JNB @EXT
  MUL EDX
  ADD EAX,ECX
  SHL EAX,2
  MOV EBX,C
  ADD EAX,[BUFFER]
  MOV [EAX],EBX
 @EXT:
END;
FUNCTION ABS_GET32(X,Y:LONGINT):DWORD;ASSEMBLER;
ASM
  MOV EDX,Y
  CMP EDX,[HEIGHT]
  JNB @EXT
  MOV EAX,[WIDTH]
  MOV ECX,X
  CMP ECX,EAX
  JNB @EXT
  MUL EDX
  ADD EAX,ECX
  SHL EAX,2
  ADD EAX,[BUFFER]
  MOV EAX,[EAX]
 @EXT:
END;
PROCEDURE DIRECT_PUT32LFB(X,Y:LONGINT;C:DWORD);ASSEMBLER;
ASM
{$IFNDEF DEBUG}
  MOV EDX,Y
  CMP EDX,[HEIGHT]
  JNB @EXT
  MOV EAX,[WIDTH]
  MOV ECX,X
  CMP ECX,EAX
  JNB @EXT
  MUL EDX
  ADD EAX,ECX
  SHL EAX,2
  MOV EBX,C
  ADD EAX,[FRAMEADDR]
  MOV [EAX],EBX
 @EXT:
{$ENDIF}
END;
PROCEDURE ABS_PUTPIC32(X,Y:LONGINT;P:PPICTURE);
VAR I,N:WORD;
    S:DWORD;
BEGIN
 IF (P^.H=0) OR (P^.B=0) THEN EXIT;
 S:=0;
 FOR I:=0 TO P^.H-1 DO
 BEGIN
  FOR N:=0 TO P^.B-1 DO
  BEGIN
   ABS_PUT32(X+N,Y+I,P^.P[S]);
   INC(S);
  END;
 END;
END;
PROCEDURE ABS_PUTPICSPZ32(X,Y:LONGINT;P:PPICTURE);
VAR I,N:WORD;
    S:DWORD;
BEGIN
 IF (P^.H=0) OR (P^.B=0) THEN EXIT;
 S:=0;
 FOR I:=0 TO P^.H-1 DO
 BEGIN
  FOR N:=0 TO P^.B-1 DO
  BEGIN
   IF P^.P[S] AND $80000000=0 THEN ABS_PUT32(X+N,Y+I,P^.P[S]);
   INC(S);
  END;
 END;
END;
PROCEDURE ABS_GETPIC32(X,Y:LONGINT;P:PPICTURE);
VAR I,N:WORD;
    S:PDWORD;
BEGIN
 IF (P^.H=0) OR (P^.B=0) THEN EXIT;
 S:=@P^.P;
 FOR I:=0 TO P^.H-1 DO
 BEGIN
  FOR N:=0 TO P^.B-1 DO
  BEGIN
   S^:=ABS_GET32(X+N,Y+I);
   INC(S);
  END;
 END;
END;
PROCEDURE DIRECT_PUTPICSPZ32LFB(X,Y:LONGINT;P:PPICTURE);
VAR I,N:WORD;
    S:DWORD;
BEGIN
 {$IFNDEF DEBUG}
 IF (P^.H=0) OR (P^.B=0) THEN EXIT;
 S:=0;
 FOR I:=0 TO P^.H-1 DO
 BEGIN
  FOR N:=0 TO P^.B-1 DO
  BEGIN
   IF P^.P[S] AND $80000000=0 THEN DIRECT_PUT32LFB(X+N,Y+I,P^.P[S]);
   INC(S);
  END;
 END;
 {$ENDIF DEBUG}
END;
PROCEDURE DIRECT_PUTPIC32LFB(X,Y:LONGINT;P:PPICTURE);
VAR I,N:DWORD;
    S:DWORD;
BEGIN
 {$IFNDEF DEBUG}
 IF (P^.H=0) OR (P^.B=0) THEN EXIT;
 S:=0;
 FOR I:=0 TO P^.H-1 DO
 BEGIN
  FOR N:=0 TO P^.B-1 DO
  BEGIN
   DIRECT_PUT32LFB(X+N,Y+I,P^.P[S]);
   INC(S);
  END;
 END;
 {$ENDIF DEBUG}
END;
PROCEDURE PUTSTRING32_TYP1(X,Y:LONGINT;S:STRING;C,SZ:DWORD);
VAR CI:DWORD;
    I,N:DWORD;
    P:PDWORDARRAY;
    CH,T:DWORD;
    B:DWORD;
BEGIN
 FOR CI:=1 TO BYTE(S[0]) DO
 BEGIN
  CH:=BYTE(S[CI]);
  IF CH<FONT1_CHARS THEN
  BEGIN
   P:=FONT1_ARRAY^[CH];
   B:=P^[1];
   T:=8;
   IF (FONT1_HEIGHT<>0) AND (B<>0) THEN
   BEGIN
    FOR I:=0 TO FONT1_HEIGHT-1 DO
    BEGIN
     FOR N:=0 TO B-1 DO
     BEGIN
      IF PBYTEARRAY(P)^[T]=1 THEN PUTPIXEL32(X+N,Y+I,C);
      INC(T);
     END;
    END;
    INC(X,B);
   END;
  END;
 END;
END;
FUNCTION SELECTFONT32(NAME:STRING):BOOLEAN;
BEGIN
 IF NAME=FONT_NAME THEN EXIT;
 GETLOCK(@FONT_LOCK);
 IF CURFONT<>NIL THEN RELEASEFONT(CURFONT);
 CURFONT:=USEFONT(NAME);
 IF CURFONT<>NIL THEN
 BEGIN
  CASE CURFONT^.TYP OF
   1:
   BEGIN
    WITH PFONT1(CURFONT^.DATA)^ DO
    BEGIN
     FONT1_HEIGHT:=HEIGHT;
     FONT1_CHARS:=CHARS;
     FONT1_ARRAY:=CHARTAB;
    END;
    INTERN_PUTSTRING:=@PUTSTRING32_TYP1;
    INTERN_GETSTRINGWIDTH:=@GETSTRINGWIDTH_TYP1;
    INTERN_GETSTRINGHEIGHT:=@GETSTRINGHEIGHT_TYP1;
   END;
   ELSE INTERN_PUTSTRING:=NIL; { Hier knnte nach externem Prog ges. werden }
  END;
 END
 ELSE
 BEGIN
  INTERN_PUTSTRING:=NIL;
  INTERN_GETSTRINGWIDTH:=NIL;
  INTERN_GETSTRINGHEIGHT:=NIL;
  SELECTFONT32:=FALSE;
 END;
 FREELOCK(@FONT_LOCK);
END;
PROCEDURE DRAWSPOINTERUP32(X,Y:LONGINT;D,C:DWORD);
VAR I:DWORD;
BEGIN
 FOR I:=0 TO D-1 DO
 BEGIN
  BAR32(X+(D-I-1),Y+I,1,(I+1)*2,C);
 END;
END;
PROCEDURE DRAWSPOINTERDOWN32(X,Y:LONGINT;D,C:DWORD);
VAR I:DWORD;
BEGIN
 FOR I:=0 TO D-1 DO
 BEGIN
  BAR32(X+I,Y+I,1,(D-I)*2,C);
 END;
END;
PROCEDURE DRAWSPOINTERRIGHT32(X,Y:LONGINT;D,C:DWORD);
VAR I:DWORD;
BEGIN
 FOR I:=0 TO D-1 DO
 BEGIN
  BAR32(X+I,Y+I,(D-I)*2,1,C);
 END;
END;
PROCEDURE DRAWSPOINTERLEFT32(X,Y:LONGINT;D,C:DWORD);
VAR I:DWORD;
BEGIN
 FOR I:=0 TO D-1 DO
 BEGIN
  BAR32(X+I,Y+(D-I-1),(I+1)*2,1,C);
 END;
END;
PROCEDURE DRAWCROSS32(X,Y:LONGINT;H,CL:DWORD);
VAR I:DWORD;
    X2:LONGINT;
BEGIN
 X2:=X+H-1;
 FOR I:=0 TO H-1 DO
 BEGIN
  PUTPIXEL32(X+I,Y+I,CL);
  PUTPIXEL32(X2-I,Y+I,CL);
 END;
END;
CONST PROCS32BITMODE:ARRAY[0..17] OF POINTER=(
       @SHOW,
       @PUTPIXEL32,
       @CLEAR32,
       @BAR32,
       @PUTPIC32,
       @BAR3D32,
       @BARI3D32,
       @FRAME3D32,
       @FRAMEI3D32,
       @SELECTFONT32,
       @PUTSTRING,
       @GETSTRINGWIDTH,
       @GETSTRINGHEIGHT,
       @DRAWSPOINTERUP32,
       @DRAWSPOINTERLEFT32,
       @DRAWSPOINTERRIGHT32,
       @DRAWSPOINTERDOWN32,
       @DRAWCROSS32);
FUNCTION INIT32BITMODE:POINTER;
VAR REGS:TREGISTERS;
BEGIN
 IF (MODEINFO.PHYSBASEPTR<>0) AND (MODEINFO.MEMM=6) THEN
 BEGIN
  REDPOS:=MODEINFO.REDP;
  REDDIV:=8-MODEINFO.REDS;
  GREENPOS:=MODEINFO.GREENP;
  GREENDIV:=8-MODEINFO.GREENS;
  BLUEPOS:=MODEINFO.BLUEP;
  BLUEDIV:=8-MODEINFO.BLUES;
  BUFFER:=ALLOCMEM(PIXELS*4);
  WRSEGL:=MODEINFO.PHYSBASEPTR;
  FRAMEADDR:=MAPSPACE(WRSEGL,PIXELS*4);
  DIRECT_PUTPIC:=@DIRECT_PUTPIC32LFB;
  DIRECT_PUTPICSPZ:=@DIRECT_PUTPICSPZ32LFB;
  ABS_GETPIC:=@ABS_GETPIC32;
  ABS_PUTPICSPZ:=@ABS_PUTPICSPZ32;
  ABS_PUTPIC:=@ABS_PUTPIC32;
  REGS.EAX:=$4F02;
  REGS.EBX:=AKTMODE OR 16384;
  {$IFNDEF DEBUG}REALINT($10,REGS);{$ENDIF}
  CLEAR32(CL_BLACK);
  INTERN_SHOW:=@SHOW32_LFB;
  INIT32BITMODE:=@PROCS32BITMODE;  
 END ELSE INIT32BITMODE:=NIL;
END;
