TYPE PWIN=^TWIN;
     TWIN=RECORD
      ADDX,ADDY,SUBX,SUBY,MAXX,MAXY:LONGINT;
      VIS:BOOLEAN;
     END;
PROCEDURE SHOW;
VAR MOUSEINAREA:BOOLEAN;
BEGIN
 GETLOCK(@MOUSELOCK);
 IF (MOUSEPIC<>NIL) AND (MOUSESAVEPIC<>NIL) AND
    PICINSIDEAREA(CURMOUSEX,CURMOUSEY,MOUSESAVEPIC) THEN
 BEGIN
  ABS_GETPIC(CURMOUSEX,CURMOUSEY,MOUSESAVEPIC);
  ABS_PUTPICSPZ(CURMOUSEX,CURMOUSEY,MOUSEPIC);
  MOUSEINAREA:=TRUE;
 END ELSE MOUSEINAREA:=FALSE;
 INTERN_SHOW;
 IF MOUSEINAREA THEN
 BEGIN
  ABS_PUTPIC(CURMOUSEX,CURMOUSEY,MOUSESAVEPIC);
 END;
 AREAVIS:=FALSE;
 FREELOCK(@MOUSELOCK);
END;
PROCEDURE ZEROAREA;
BEGIN
 AREAVIS:=FALSE;
END;
FUNCTION SETWIN(W:PWIN):BOOLEAN;
VAR DX,DY:LONGINT;
BEGIN
 IF (NOT AREAVIS) OR (NOT W^.VIS) OR (W^.ADDX>=AREAX+AREAB) OR
    (W^.ADDY>=AREAY+AREAH) OR (W^.ADDX+W^.MAXX<AREAX) OR (W^.ADDY+W^.MAXY<AREAY) THEN
 BEGIN
  VIS:=FALSE;
  SETWIN:=FALSE;
  EXIT;
 END;
 IF W^.ADDX>=AREAX THEN ADDX:=W^.ADDX ELSE ADDX:=AREAX;
 IF W^.ADDY>=AREAY THEN ADDY:=W^.ADDY ELSE ADDY:=AREAY;
 DX:=(ADDX-W^.ADDX);
 DY:=(ADDY-W^.ADDY);
 SUBX:=W^.SUBX+DX;
 SUBY:=W^.SUBY+DY;
 MAXX:=W^.MAXX-DX;
 MAXY:=W^.MAXY-DY;
 IF ADDX+MAXX>=AREAX+AREAB THEN MAXX:=AREAX+AREAB-ADDX-1;
 IF ADDY+MAXY>=AREAY+AREAH THEN MAXY:=AREAY+AREAH-ADDY-1;
 VIS:=TRUE;
 SETWIN:=TRUE;
END;
PROCEDURE CREATESUBWIN(BAS:PWIN;X,Y:LONGINT;H,B:DWORD;VIS:BOOLEAN;VAR W:TWIN);
BEGIN
 X:=X-BAS^.SUBX;
 Y:=Y-BAS^.SUBY;
 IF (NOT BAS^.VIS) OR (NOT VIS) OR (LONGINT(H)=0) OR (LONGINT(B)=0) OR
    (LONGINT(X+B)<=0) OR (LONGINT(Y+H)<=0) OR (LONGINT(X)>LONGINT(BAS^.MAXX)) OR
    (LONGINT(Y)>LONGINT(BAS^.MAXY)) THEN
 BEGIN
  W.VIS:=FALSE;
  EXIT;
 END;
 IF X<0 THEN
 BEGIN
  W.ADDX:=BAS^.ADDX;
  W.SUBX:=-X;
 END
 ELSE
 BEGIN
  W.ADDX:=BAS^.ADDX+X;
  W.SUBX:=0;
 END;
 IF Y<0 THEN
 BEGIN
  W.ADDY:=BAS^.ADDY;
  W.SUBY:=-Y;
 END
 ELSE
 BEGIN
  W.ADDY:=BAS^.ADDY+Y;
  W.SUBY:=0;
 END;
 H:=H-W.SUBY;
 B:=B-W.SUBX;
 W.MAXY:=BAS^.MAXY-(W.ADDY-BAS^.ADDY);
 W.MAXX:=BAS^.MAXX-(W.ADDX-BAS^.ADDX);
 IF H<W.MAXY+1 THEN W.MAXY:=H-1;
 IF B<W.MAXX+1 THEN W.MAXX:=B-1;
 W.VIS:=TRUE;
END;
PROCEDURE CREATEABSWIN(X,Y:LONGINT;H,B:DWORD;VIS:BOOLEAN;VAR W:TWIN);
BEGIN
 IF (B=0) OR (H=0) OR (NOT VIS) OR (X+B<=0) OR (Y+H<=0) OR (Y>=HEIGHT) OR (X>=WIDTH) THEN
 BEGIN
  W.VIS:=FALSE;
  EXIT;
 END;
 IF X<0 THEN
 BEGIN
  B:=B+X;
  X:=0;
 END;
 IF Y<0 THEN
 BEGIN
  H:=H+Y;
  Y:=0;
 END;
 W.VIS:=TRUE;
 W.MAXX:=B-1;
 W.MAXY:=H-1;
 W.ADDX:=X;
 W.ADDY:=Y;
 W.SUBX:=0;
 W.SUBY:=0;
END;
PROCEDURE SETAREABW(P:PWIN);
BEGIN
 GETLOCK(@MOUSELOCK);
 AREAVIS:=P^.VIS;
 AREAX:=P^.ADDX;
 AREAY:=P^.ADDY;
 AREAH:=P^.MAXY+1;
 AREAB:=P^.MAXX+1;
 FREELOCK(@MOUSELOCK);
END;
PROCEDURE SETAREA(X,Y:LONGINT;H,B:DWORD);
VAR M:BOOLEAN;
BEGIN
 IF (LONGINT(X+B)<0) OR (LONGINT(Y+H)<0) OR (X>=LONGINT(WIDTH)) OR (Y>=LONGINT(HEIGHT)) OR (H=0) OR (B=0) THEN
 BEGIN
  AREAVIS:=FALSE;
  EXIT;
 END;
 IF X<0 THEN
 BEGIN
  INC(B,X);
  X:=0;
 END;
 IF Y<0 THEN
 BEGIN
  INC(H,Y);
  Y:=0;
 END;
 IF X+B>WIDTH THEN B:=WIDTH-X;
 IF Y+H>HEIGHT THEN H:=HEIGHT-Y;
 GETLOCK(@MOUSELOCK);
 AREAX:=X;
 AREAY:=Y;
 AREAH:=H;
 AREAB:=B;
 AREAVIS:=TRUE;
 FREELOCK(@MOUSELOCK);
END;
