CONST OTHERGRP:ARRAY[0..1] OF DWORD=(4,0);
PROCEDURE RESETATOM(P:PLOCK);
BEGIN
 FILLCHAR(P^,SIZEOF(TLOCK),0);
END;
PROCEDURE WAITFORREADCYCLNOSCHED(P:PREADSTAT);ASSEMBLER;
ASM
  MOV EDI,P
  MOV EDX,[EDI+TREADSTAT.GRPSTAT]
  MOV EBX,[OTHERGRP+EDX]
  MOV [EDI+TREADSTAT.GRPSTAT],EBX
 @LP:
  MOV EAX,[EDI+TREADSTAT.GRPCO+EDX]
  OR EAX,EAX
  JNZ @LP
END;
PROCEDURE WAITFORREADCYCL(P:PREADSTAT);ASSEMBLER;
ASM
  MOV EDI,P
  MOV EDX,[EDI+TREADSTAT.GRPSTAT]
  MOV EBX,[OTHERGRP+EDX]
  MOV [EDI+TREADSTAT.GRPSTAT],EBX
 @LP:
  MOV EAX,[EDI+TREADSTAT.GRPCO+EDX]
  OR EAX,EAX
  JZ @OK
  CALL SCHEDULE
  JMP @LP
 @OK:
END;
FUNCTION STARTREAD(P:PREADSTAT):DWORD;ASSEMBLER;
ASM
  MOV EDI,P
  MOV EAX,[EDI+TREADSTAT.GRPSTAT]
  LOCK INC DWORD [EDI+TREADSTAT.GRPCO+EAX]
END;
PROCEDURE STOPREAD(P:PREADSTAT;GR:DWORD);ASSEMBLER;
ASM
  MOV EDI,P
  MOV EAX,GR
  LOCK DEC DWORD [EDI+TREADSTAT.GRPCO+EAX]
END;
PROCEDURE INCATOM(P:PDWORD);ASSEMBLER;
ASM
  MOV EDI,P
  LOCK INC DWORD [EDI]
END;
PROCEDURE DECATOM(P:PDWORD);ASSEMBLER;
ASM
  MOV EDI,P
  LOCK DEC DWORD [EDI]
END;
FUNCTION TRYTOSETBYTE(P:PBYTE):LONGBOOL;ASSEMBLER;
ASM
  MOV EDI,P
  MOV AL,0FFh
  XCHG AL,[EDI]
  NOT EAX
  AND EAX,1
END;
FUNCTION TRYTOSETDWORD(P:PDWORD):LONGBOOL;ASSEMBLER;
ASM
  MOV EDI,P
  MOV EAX,0FFFFFFFFh
  XCHG EAX,[EDI]
  NOT EAX
  AND EAX,1
END;
PROCEDURE GETLOCKNOSCHED(P:PLOCK);ASSEMBLER;
ASM
  MOV EDI,P
  MOV EBX,[EDI+TLOCK.GRPSTAT]
  MOV EDX,[OTHERGRP+EBX]
  LOCK INC DWORD [EDI+TLOCK.GRPCO+EDX]
 @LO:
  MOV EAX,[EDI+TLOCK.GRPCO+EBX]
  OR EAX,EAX
  JZ @NOONELEFT
  CMP EDX,[EDI+TLOCK.GRPSTAT]
  JZ @MYGROUP
  JMP @LO
 @NOONELEFT:
  MOV [EDI+TLOCK.GRPSTAT],EDX
 @MYGROUP:
  MOV EAX,0FFFFFFFFh
 @LO2:
  XCHG EAX,[EDI+TLOCK.LOCK]
  OR EAX,EAX
  JZ @SUCCESFULL
  JMP @LO2
 @SUCCESFULL:
  MOV [EDI+TLOCK.LOCKGR],EDX
END;
PROCEDURE GETLOCK(P:PLOCK);ASSEMBLER;
ASM
  MOV EDI,P
  MOV EBX,[EDI+TLOCK.GRPSTAT]
  MOV EDX,[OTHERGRP+EBX]
  LOCK INC DWORD [EDI+TLOCK.GRPCO+EDX]
 @LO:
  MOV EAX,[EDI+TLOCK.GRPCO+EBX]
  OR EAX,EAX
  JZ @NOONELEFT
  CMP EDX,[EDI+TLOCK.GRPSTAT]
  JZ @MYGROUP
  CALL SCHEDULE
  JMP @LO
 @NOONELEFT:
  MOV [EDI+TLOCK.GRPSTAT],EDX
 @MYGROUP:
  MOV EAX,0FFFFFFFFh
 @LO2:
  XCHG EAX,[EDI+TLOCK.LOCK]
  OR EAX,EAX
  JZ @SUCCESFULL
  CALL SCHEDULE
  JMP @LO2
 @SUCCESFULL:
  MOV [EDI+TLOCK.LOCKGR],EDX
END;
PROCEDURE FREELOCK(P:PLOCK);ASSEMBLER;
ASM
  MOV EDI,P
  MOV EAX,[EDI+TLOCK.LOCKGR]
  LOCK DEC DWORD [EDI+TLOCK.GRPCO+EAX]
  XOR EAX,EAX
  MOV [EDI+TLOCK.LOCK],EAX
END;
PROCEDURE FREEELOCK(P:PELOCK);
BEGIN
 FREELOCK(@P^.LOCK);
END;
PROCEDURE GETELOCK(P:PELOCK);
BEGIN
 GETLOCK(@P^.LOCK);
 WHILE P^.READ<>0 DO SCHEDULE;
END;
PROCEDURE STARTREADLOCK(P:PELOCK);
BEGIN
 REPEAT
  IF P^.LOCK.LOCK=0 THEN
  BEGIN
   INCATOM(@P^.READ);
   IF P^.LOCK.LOCK<>0 THEN DECATOM(@P^.READ) ELSE EXIT;
  END;
 UNTIL FALSE;
END;
PROCEDURE STOPREADLOCK(P:PELOCK);
BEGIN
 DECATOM(@P^.READ);
END;
PROCEDURE RESETREAD(P:PREADSTAT);
BEGIN
 P^.GRPSTAT:=0;
 P^.GRPCO[0]:=0;
 P^.GRPCO[1]:=0;
END;
