PROCEDURE GETSEMAPHORE(P:PSEMAPHORE);
VAR E:TSEMAPHOREENTRY;
BEGIN
 IF TRYTOSETDWORD(@P^.RLOCK) THEN EXIT;
 E.NEXT:=NIL;
 E.THREAD:=GETTASKHANDLE();
 GETLOCK(@P^.LLOCK);
 E.LAST:=P^.LAST;
 IF E.LAST<>NIL THEN E.LAST^.NEXT:=@E ELSE P^.FIRST:=@E;
 P^.LAST:=@E;
 FREELOCK(@P^.LLOCK);
 DISABLETASK(E.THREAD);
 GETLOCK(@P^.LLOCK);
 P^.FIRST:=E.NEXT;
 IF E.NEXT<>NIL THEN E.NEXT^.LAST:=NIL ELSE P^.LAST:=NIL;
 FREELOCK(@P^.LLOCK);
END;
PROCEDURE FREESEMAPHORE(P:PSEMAPHORE);
BEGIN
 GETLOCK(@P^.LLOCK);
 IF P^.FIRST<>NIL THEN ENABLETASK(P^.FIRST^.THREAD) ELSE P^.RLOCK:=0;
 FREELOCK(@P^.LLOCK);
END;
