SECTION .text
BITS 32
  GLOBAL start
  EXTERN PASCALMAIN
  EXTERN HEAP
  EXTERN HEAPSIZE
  EXTERN U_SYSTEM_PROG_BASE
  EXTERN U_SYSTEM_PROG_SIZE
  EXTERN U_SYSTEM_PROG_BSS
  EXTERN U_SYSTEM_RETURN_SS
  EXTERN U_SYSTEM_RETURN_ESP
  EXTERN U_SYSTEM_SYSMEMORY
  EXTERN U_SYSTEM_REALMODEDESC
  EXTERN U_SYSTEM_FIRSTADDR
; Parameter : EDI=Basis
;             EAX=Gre des Systemspeichers
;             EDX=Realmode-Funktionen
;             EBX=Erstes Byte nach dem Bootblock
 start:
   JMP SHORT main
   NOP
   NOP
 NEXT DD 0
 SIZE DD 0
 BSSSIZE DD 0
 PARA DD 0
 PARS DD 0
 main:
  PUSH EDI                     ; 
  PUSH EAX                     ;  .BSS initalisieren.
  PUSH EDX                     ; 
  PUSH EBX                     ; 
  MOV ECX,[BSSSIZE]            ; 
  MOV EDX,ECX                  ; 
  ADD EDI,[SIZE]               ; 
  SHR ECX,2                    ; 
  XOR EAX,EAX                  ; 
  REP STOSD                    ; 
  MOV ECX,EDX                  ; 
  AND ECX,3                    ; 
  REP STOSB                    ; 
  POP EBX                      ; 
  POP EDX                      ; 
  POP EAX                      ; 
  POP EDI                      ; 
  MOV [U_SYSTEM_REALMODEDESC],EDX;
  MOV [U_SYSTEM_SYSMEMORY],EAX ;  Parameter sichern.
  MOV [U_SYSTEM_FIRSTADDR],EBX ; 
  MOV [U_SYSTEM_PROG_BASE],EDI ; 
  MOV EBX,[SIZE]               ; 
  MOV EAX,[BSSSIZE]
  ADD EBX,EAX                  ; 
  MOV [U_SYSTEM_PROG_BSS],EAX
  MOV [U_SYSTEM_PROG_SIZE],EBX ; 
  MOV [U_SYSTEM_RETURN_SS],SS  ; 
  MOV [U_SYSTEM_RETURN_ESP],ESP; 
  MOV ESP,[U_SYSTEM_RETURN_ESP]
  MOV SS,[U_SYSTEM_RETURN_SS]
  MOV ESP,[U_SYSTEM_FIRSTADDR]
  MOV EAX,ESP
  AND EAX,0FFFh
  AND ESP,0FFFFF000h
  OR EAX,EAX
  JZ STACKALIGN
  ADD ESP,4096
 STACKALIGN:
  ADD ESP,16384
  MOV EDI,ESP
  MOV [U_SYSTEM_FIRSTADDR],EDI
  MOV AX,20h
  MOV SS,AX
  JMP PASCALMAIN
