FUNCTION GDT_ADDLDT(BAS:POINTER;LIMIT:DWORD):DWORD;
VAR I:DWORD;
BEGIN
 GETLOCK(@GDT_LOCK);
 FOR I:=1 TO GDT_SIZE-1 DO
 BEGIN
  IF GDTTABLE^[I*2+1]=0 THEN
  BEGIN
   GDTTABLE^[I*2]:=DWORD(BAS) SHL 16+LIMIT AND $FFFF;
   GDTTABLE^[I*2+1]:=(DWORD(BAS) SHR 16 AND $FF)+(DWORD(BAS) AND $FF000000)+$8200;
   FREELOCK(@GDT_LOCK);
   GDT_ADDLDT:=I*8;
   EXIT;
  END;
 END;
 FREELOCK(@GDT_LOCK);
 GDT_ADDLDT:=0;
END;
FUNCTION GDT_GETBASE(DESC:DWORD):POINTER;ASSEMBLER;
ASM
  MOV ESI,[GDTTABLE]
  ADD ESI,DESC { DESC wird hier nicht maskiert, mal schauen ob das
                 jemand braucht ! }
  MOV EAX,[ESI+2]
  AND EAX,000FFFFFFh
  MOV EBX,[ESI+4]
  AND EBX,0FF000000h
  OR EAX,EBX
END;
FUNCTION GDT_ADDTSS(BAS:POINTER;LIMIT:DWORD):DWORD;
VAR I:DWORD;
BEGIN
 GETLOCK(@GDT_LOCK);
 FOR I:=1 TO GDT_SIZE-1 DO
 BEGIN
  IF GDTTABLE^[I*2+1]=0 THEN
  BEGIN
   GDTTABLE^[I*2]:=DWORD(BAS) SHL 16+LIMIT AND $FFFF;
   GDTTABLE^[I*2+1]:=(DWORD(BAS) SHR 16 AND $FF)+(DWORD(BAS) AND $FF000000)+$8900;
   FREELOCK(@GDT_LOCK);
   GDT_ADDTSS:=I*8;
   EXIT;
  END;
 END;
 FREELOCK(@GDT_LOCK);
 GDT_ADDTSS:=0;
END;
PROCEDURE INITGDT;
VAR I:DWORD;
BEGIN
 GDTTABLE:=GSTARTUPALLOC(GDT_SIZE*8);
 NEWGDT.SIZE:=GDT_SIZE*8-1;
 NEWGDT.BASE:=GDTTABLE;
 FILLDWORD(GDTTABLE^,GDT_SIZE*2,0);
 GDTTABLE^[2]:=$0000FFFF; { Code 0 : 8h  }
 GDTTABLE^[3]:=$00CF9B00;
 GDTTABLE^[4]:=$0000FFFF; { Data 3 : 10h }
 GDTTABLE^[5]:=$00CF9200;
 GDTTABLE^[6]:=$0000FFFF; { Code 3 : 18h }
 GDTTABLE^[7]:=$00CFFB00;
 ASM
   NOP
   DB 00Fh,001h,005h { Alte GDT sichern }
   DD OLDGDT
   NOP
   DB 00Fh,001h,015h { Neue GDT laden }
   DD NEWGDT
   NOP
   DB 0EAh
   DD @NEWGDTLABEL
   DW 8h
  @NEWGDTLABEL:
   MOV AX,10h
   MOV ES,AX
   MOV DS,AX
   MOV FS,AX
   MOV GS,AX
 END;
END;
PROCEDURE DONEGDT;ASSEMBLER;
ASM
  DB 00Fh,001h,015h { Alte GDT laden }
  DD OLDGDT
  DB 0EAh
  DD @OLDGDTLABEL
  DW 18h
 @OLDGDTLABEL:
  MOV AX,20h
  MOV ES,AX
  MOV DS,AX
  MOV FS,AX
  MOV GS,AX
END;
