PROCEDURE INITMEM;
VAR I,X:DWORD;
BEGIN
 SYSTEMPAGEDIR:=GSTARTUPALLOC(4096);
 PAGETABLES:=GSTARTUPALLOC(SYSMEM_SIZE*4096);
 MEMALLOC:=GSTARTUPALLOC(1024*1024);
 FILLDWORD(SYSTEMPAGEDIR^,1024,0);
 FILLDWORD(PAGETABLES^,SYSMEM_SIZE*1024,0);
 FILLDWORD(MEMALLOC^,1024*256,$FFFFFFFF); { Erst mal den Speicher belegen. }
 FILLCHAR(MEMALLOC^,SYSMEMORY,0); { Vorhandenen Speicher freigeben... }
 FOR I:=0 TO SYSMEM_SIZE-1 DO SYSTEMPAGEDIR^[I]:=DWORD(PAGETABLES)+I*4096+1+2+4+512;
 X:=(STARTUPALLOC SHR 12)+BYTE(STARTUPALLOC AND $FFF<>0);
 FOR I:=0 TO 255 DO PAGETABLES^[I]:=I*4096+1+2+4+512;
 FOR I:=256 TO X-1 DO PAGETABLES^[I]:=I*4096+1+2+512;
 FILLCHAR(MEMALLOC^,X,$FF);
 ASM
   MOV EAX,SYSTEMPAGEDIR
   MOV CR3,EAX
   MOV EAX,CR0
   OR EAX,2147483648
   MOV CR0,EAX
 END;
END;
FUNCTION ALLOCPAGEAREA(PAGES:DWORD):DWORD; { SUB ! }
VAR I:DWORD;
    START,COUNT:DWORD;
BEGIN
 START:=0;
 COUNT:=0;
 FOR I:=256 TO (SYSMEM_SIZE*1024)-1 DO
 BEGIN
  IF PAGETABLES^[I]<>0 THEN
  BEGIN
   COUNT:=0;
   START:=I+1;
  END
  ELSE
  BEGIN
   INC(COUNT);
   IF COUNT=PAGES THEN
   BEGIN
    ALLOCPAGEAREA:=START;
    EXIT;
   END;
  END;
 END;
 ALLOCPAGEAREA:=0;
END;
FUNCTION ALLOCMEMFRAME:DWORD;ASSEMBLER;
ASM
  MOV EAX,[MEMALLOC]
  MOV ECX,100000h
  MOV BL,0FFh
 @LP:
NOP
  XCHG BL,[EAX]
NOP
  OR BL,BL
  JZ @SUCCESFULL
  INC EAX
  DEC ECX
  JNE @LP
  XOR EAX,EAX
  RET
 @SUCCESFULL:
  SUB EAX,[MEMALLOC]
  SHL EAX,12
END;
PROCEDURE RELEASEPAGEAREA(S,SIZE:DWORD);
VAR I,X:DWORD;
BEGIN
 { MP-Support fehlt ! }
 FOR I:=0 TO SIZE-1 DO
 BEGIN
  X:=S+I;
  ASM
    MOV EDI,X
    SHL EDI,12
    INVLPG [EDI]
  END;
 END;
 FOR I:=0 TO SIZE-1 DO PAGETABLES^[S+I]:=0;
END;
VAR X:DWORD;
PROCEDURE RELEASEMEM(P:POINTER;SIZE:DWORD);
VAR I,A:DWORD;
    PSIZE,S,X:DWORD;
BEGIN
 { MP-Support fehlt ! }
 IF SIZE=0 THEN EXIT;
 GETLOCK(@PAGES_LOCK);
 S:=DWORD(P) SHR 12;
 PSIZE:=SIZE SHR 12+BYTE(SIZE AND $FFF<>0);
 FOR I:=0 TO PSIZE-1 DO
 BEGIN
  X:=S+I;
  A:=PAGETABLES^[X] SHR 12;
  MEMALLOC^[A]:=0;
  ASM
    MOV EDI,X
    SHL EDI,12
    INVLPG [EDI]
  END;
 END;
 FOR I:=0 TO PSIZE-1 DO PAGETABLES^[S+I]:=0;
 FREELOCK(@PAGES_LOCK);
END;
PROCEDURE UNMAPSPACE(P:POINTER;SIZE:DWORD);
VAR I,PSIZE:DWORD;
BEGIN
 PSIZE:=SIZE SHR 12+BYTE(SIZE AND $FFF<>0);
 GETLOCK(@PAGES_LOCK);
 RELEASEPAGEAREA(DWORD(P) SHR 12,SIZE); { P entsprechend nicht exakter Page-Aligned
  Basis auf Size reflektieren ! }
 FREELOCK(@PAGES_LOCK);
END;
FUNCTION MAPSPACE(BASE,SIZE:DWORD):POINTER;
VAR I,PSIZE,START:DWORD;   
BEGIN
 IF SIZE=0 THEN
 BEGIN
  MAPSPACE:=NIL;
  EXIT;
 END;
 BASE:=BASE AND $FFFFF000; { Wie sonst ?, Jaja, bitte noch verbessern ! }
 PSIZE:=SIZE SHR 12+BYTE(SIZE AND $FFF<>0);
 GETLOCK(@PAGES_LOCK);
 START:=ALLOCPAGEAREA(PSIZE);
 IF START=0 THEN
 BEGIN
  MAPSPACE:=NIL;
  FREELOCK(@PAGES_LOCK);
  EXIT;
 END;
 FOR I:=0 TO PSIZE-1 DO
 BEGIN
  PAGETABLES^[START+I]:=BASE+(I SHL 12)+1+2+512;
 END;
 FREELOCK(@PAGES_LOCK);
 MAPSPACE:=POINTER(START SHL 12);
END;
FUNCTION ALLOCMEM(SIZE:DWORD):POINTER;
VAR START,A,I,PSIZE:DWORD;
BEGIN
 IF SIZE=0 THEN
 BEGIN
  ALLOCMEM:=NIL;
  EXIT;
 END;
 PSIZE:=SIZE SHR 12+BYTE(SIZE AND $FFF<>0);
 GETLOCK(@PAGES_LOCK);
 START:=ALLOCPAGEAREA(PSIZE);
 IF START=0 THEN
 BEGIN
  ALLOCMEM:=NIL;
  FREELOCK(@PAGES_LOCK);
  EXIT;
 END;
 FOR I:=0 TO PSIZE-1 DO
 BEGIN
  A:=ALLOCMEMFRAME;
  IF (A=0) THEN
  BEGIN
   RELEASEPAGEAREA(START,PSIZE);
   FREELOCK(@PAGES_LOCK);
   ALLOCMEM:=NIL;
   EXIT;
  END;
  PAGETABLES^[START+I]:=A+1+2+512;
 END;
 FREELOCK(@PAGES_LOCK);
 ALLOCMEM:=POINTER(START SHL 12);
END;
FUNCTION GETPAGEBITS:DWORD;
BEGIN
 GETPAGEBITS:=12;
END;
