PROGRAM LD;
{$I-}
{$ASMMODE INTEL}
USES DOS,COFF;
VAR PATHS:ARRAY[0..99] OF STRING;
CONST PATHNUMS:LONGINT=0;
PROCEDURE ADDPATH(S:STRING);
BEGIN
 WHILE S[1]='.' DO DELETE(S,1,1);
 WHILE S[1]='\' DO DELETE(S,1,1);
 PATHS[PATHNUMS]:=S;
 INC(PATHNUMS);
END;
CONST SEC_TEXT=0;
      SEC_DATA=1;
      SEC_BSS=2;
CONST RELOCSTAT_READ=0;
      RELOCSTAT_HASP=1;
      RELOCSTAT_DONE=2;
      RELOCSTAT_TOADDR=3;
TYPE PFILE=^TFILE;
     TFILE=RECORD
      FN:STRING[64];
      BASE:LONGINT;
      FPOS:LONGINT;
      LEN:LONGINT;
      SEC:LONGINT;
      NEXT:PFILE;
     END;
TYPE TSECTION=RECORD
      RELOCTAB:LONGINT;
      RELOCCO:LONGINT;
      AKTPOS:LONGINT;
      AKTSIZE:LONGINT;
      GESPOS:LONGINT;
      GESSIZE:LONGINT;
      SECFP:LONGINT;
     END;
CONST SYM_EXTERN=0;
      SYM_INTERN=1;
      SYM_PRIVAT=2;
      SYM_OPRIVAT=3;
      SYM_OTHER=$FFFF;
TYPE PSYMBOL=^TSYMBOL;
     TSYMBOL=RECORD
      NAME:STRING[64];
      FN:STRING[64];
      STRPOS:LONGINT;
      CLASS:WORD;
      INDEX:LONGINT;
      NEXT:PSYMBOL;
      VAR1,VAR2:LONGINT;
      DATAL:WORD;
      EXTRA:POINTER;
     END;
TYPE PRELOC=^TRELOC;
     TRELOC=RECORD
      SECTION:INTEGER;
      POS:LONGINT;
      TYP:WORD;
      STATE:WORD;
      INDEX:LONGINT;
      SYMB:PSYMBOL;
      FN:STRING;
      NEXT:PRELOC;
     END;
CONST SECNM_TEXT:TSECNAME='.text';
      SECNM_DATA:TSECNAME='.data';
      SECNM_BSS:TSECNAME='.bss';
TYPE PPROG=^TPROG;
     TPROG=OBJECT
      SECTIONC:ARRAY[1..3] OF BYTE;
      SECTION:ARRAY[0..2] OF TSECTION;
      CONSTRUCTOR INIT;
      PROCEDURE LINK(S:STRING);
      PROCEDURE WRITE(S:STRING;BSSW,RELA:BOOLEAN);
      PRIVATE
      BUFFER:POINTER;
      BUFFERL:LONGINT;
      AFN:STRING;
      RELOCS:PRELOC;
      FILES:PFILE;
      SYMBOLS:PSYMBOL;
      SYMTAB:LONGINT;
      SYMTABLEN:LONGINT;
      SECTAB:LONGINT;
      SECTABLEN:LONGINT;
      STRTAB:LONGINT;
      SKIP:WORD;
      PROCEDURE WRITERELOCHEADERC(VAR F:FILE);
      PROCEDURE READHEADER(VAR F:FILE);
      PROCEDURE READSECTIONS(VAR F:FILE);
      PROCEDURE READRELOC(VAR F:FILE);
      PROCEDURE ADDRELOC(SEC:INTEGER;POS,SYM:LONGINT;TYP:WORD);
      FUNCTION FINDRELOC(SYM:LONGINT):PRELOC;
      PROCEDURE READSYMBOLS(VAR F:FILE);
      PROCEDURE ADDSYMBOL(INDEX:LONGINT;SYM:RCOFFSYMTABENTRY);
      PROCEDURE SHOWSYMBOLS;
      FUNCTION ADDSYMBOLE(INDEX:LONGINT;S:STRING;STRPOS,CL:LONGINT):PSYMBOL;
      PROCEDURE ADDEXTERN(INDEX:LONGINT;S:STRING;STRPOS:LONGINT);
      PROCEDURE ADDINTERN(INDEX:LONGINT;S:STRING;STRPOS,POS,SEC:LONGINT);
      PROCEDURE UPDATENAMES(VAR F:FILE);
      PROCEDURE UPDATESTR(P:LONGINT;S:STRING);
      PROCEDURE SORTSECTIONS;
      PROCEDURE UPDATESYMBASES;
      PROCEDURE UPDATESYMBASE(P:PSYMBOL);
      PROCEDURE SETRELOCP(INDEX:LONGINT;P:PSYMBOL);
      PROCEDURE ADDOTHER(INDEX:LONGINT;S:STRING;STRPOS:LONGINT;TYP:LONGINT);
      PROCEDURE LISTRELOCS;
      PROCEDURE LINKALL;
      PROCEDURE ADDFILE(SEC,BASE,FPOS,LEN:LONGINT;FN:STRING);
      PROCEDURE UPDATEFILEBASES;
      PROCEDURE LISTFILES;
      PROCEDURE PROCESSFILES(VAR F:FILE);
      FUNCTION GETNEXTFILEH(B:LONGINT):PFILE;
      FUNCTION LOADFILE(S:STRING;FP,L:LONGINT):BOOLEAN;
      PROCEDURE WRITERELOCS(B,L:LONGINT);
      PROCEDURE SAVEFILE(VAR F:FILE);
      PROCEDURE WRITERELOC(P:PRELOC;B:LONGINT);
      PROCEDURE UPDATERELOCS;
      FUNCTION SEARCHSYMBOL(CLASS:WORD;Z:PSYMBOL):PSYMBOL;
      PROCEDURE WRITERELOC6(POS,RPOS:LONGINT;ZP:PSYMBOL);
      PROCEDURE WRITERELOC20(POS,RPOS:LONGINT;ZP:PSYMBOL);
      FUNCTION GETSYMBADDR(ZP:PSYMBOL):LONGINT;
      PROCEDURE ADDPRIVAT(INDEX:LONGINT;S:STRING;STRPOS,POS,SEC:LONGINT);
      PROCEDURE ENDPRIVAT;
      PROCEDURE WRITEBSS(VAR F:FILE);
      PROCEDURE WRITEHEADER(VAR F:FILE);
      PROCEDURE WRITERELOCHEADER(VAR F:FILE);
     END;
PROCEDURE TPROG.WRITEHEADER(VAR F:FILE);
BEGIN
 BLOCKWRITE(F,SECTION[2].GESSIZE,4);
END;
PROCEDURE TPROG.WRITEBSS(VAR F:FILE);
VAR REST:LONGINT;
BEGIN
 GETMEM(BUFFER,64000);
 FILLCHAR(BUFFER^,64000,0);
 REST:=SECTION[2].GESSIZE;
 WRITELN('Gesammtgre des BSS : ',REST);
 WHILE REST>=64000 DO
 BEGIN
  BLOCKWRITE(F,BUFFER^,64000);
  DEC(REST,64000);
 END;
 BLOCKWRITE(F,BUFFER^,REST);
 FREEMEM(BUFFER,64000);
END;
PROCEDURE TPROG.ENDPRIVAT;
VAR P:PSYMBOL;
BEGIN
 P:=SYMBOLS;
 WHILE P<>NIL DO
 BEGIN
  IF P^.CLASS=SYM_PRIVAT THEN P^.CLASS:=SYM_OPRIVAT;
  P:=P^.NEXT;
 END;
END;
FUNCTION TPROG.SEARCHSYMBOL(CLASS:WORD;Z:PSYMBOL):PSYMBOL;
VAR P:PSYMBOL;
BEGIN
 P:=SYMBOLS;
 WHILE P<>NIL DO
 BEGIN
  IF (P^.CLASS=CLASS) AND (P^.NAME=Z^.NAME) THEN
  BEGIN
   SEARCHSYMBOL:=P;
   EXIT;
  END;
  P:=P^.NEXT;
 END;
 SEARCHSYMBOL:=NIL;
END;
FUNCTION TPROG.GETSYMBADDR(ZP:PSYMBOL):LONGINT;
VAR P:PSYMBOL;
    I:WORD;
BEGIN
 WRITELN('S:',DWORD(ZP));
 EXIT;
 IF ZP^.CLASS=SYM_OPRIVAT THEN
 BEGIN
  GETSYMBADDR:=ZP^.VAR2;
  EXIT;
 END;
 EXIT;
 P:=SEARCHSYMBOL(SYM_INTERN,ZP);
 IF P=NIL THEN
 BEGIN
  WRITELN('Symbol nicht gefunden : ',ZP^.NAME);
  CLOSE(OUTPUT);
  ASSIGN(OUTPUT,'');
  REWRITE(OUTPUT);
  WRITELN('Symbol nicht gefunden : ',ZP^.NAME);
  HALT;
 END;
 GETSYMBADDR:=P^.VAR2;
END;
PROCEDURE TPROG.WRITERELOC20(POS,RPOS:LONGINT;ZP:PSYMBOL);
VAR P:POINTER;
    N:LONGINT;
BEGIN
 N:=GETSYMBADDR(ZP);
 N:=N-RPOS-4;
 P:=BUFFER;
 ASM
   MOV EDI,P
   ADD EDI,POS
   MOV EAX,N
   MOV ES:[EDI],EAX
 END;
END;
PROCEDURE TPROG.WRITERELOC6(POS,RPOS:LONGINT;ZP:PSYMBOL);
VAR P:POINTER;
    N:LONGINT;
BEGIN
 N:=GETSYMBADDR(ZP);
 P:=BUFFER;
 ASM
   MOV EDI,P
   ADD EDI,POS
   MOV EAX,ES:[EDI]
   ADD EAX,N
   MOV ES:[EDI],EAX
 END;
END;
PROCEDURE TPROG.UPDATERELOCS;
VAR P:PRELOC;
BEGIN
 P:=RELOCS;
 WHILE P<>NIL DO
 BEGIN
  P^.POS:=P^.POS+SECTION[P^.SECTION].GESPOS;
  P:=P^.NEXT;
 END;
END;
PROCEDURE TPROG.WRITERELOC(P:PRELOC;B:LONGINT);
BEGIN
 CASE P^.TYP OF
  6:WRITERELOC6(P^.POS-B,P^.POS,P^.SYMB);
  20:WRITERELOC20(P^.POS-B,P^.POS,P^.SYMB);
 END;
END;
PROCEDURE TPROG.WRITERELOCS(B,L:LONGINT);
VAR P:PRELOC;
    A:PSYMBOL;
BEGIN
 P:=RELOCS;
 WHILE P<>NIL DO
 BEGIN
  IF P^.POS<0 THEN
  BEGIN
   WRITELN('Error,',P^.POS);
  END;
  IF (P^.POS>=B) AND (P^.POS<B+L) THEN
  BEGIN
   WRITERELOC(P,B);
  END;
  P:=P^.NEXT;
 END;
END;
PROCEDURE TPROG.SAVEFILE(VAR F:FILE);
BEGIN
 BLOCKWRITE(F,BUFFER^,BUFFERL);
 FREEMEM(BUFFER,BUFFERL);
END;
FUNCTION TPROG.LOADFILE(S:STRING;FP,L:LONGINT):BOOLEAN;
VAR F:FILE;
    I:LONGINT;
BEGIN
 ASSIGN(F,S);
 RESET(F,1);
 IF IORESULT<>0 THEN
 BEGIN
  I:=0;
  WHILE I<PATHNUMS DO
  BEGIN
   ASSIGN(F,PATHS[I]+S);
   RESET(F,1);
   IF IORESULT=0 THEN BREAK ELSE INC(I);
  END;
  IF I=PATHNUMS THEN
  BEGIN
   WRITELN('Could not load ',S);
   LOADFILE:=FALSE;
   EXIT;
  END;
 END;
 GETMEM(BUFFER,L);
 SEEK(F,FP);
 BLOCKREAD(F,BUFFER^,L);
 CLOSE(F);
 BUFFERL:=L;
 LOADFILE:=TRUE;
END;
FUNCTION TPROG.GETNEXTFILEH(B:LONGINT):PFILE;
VAR P:PFILE;
BEGIN
 P:=FILES;
 WHILE P<>NIL DO
 BEGIN
  IF (P^.BASE=B) THEN
  BEGIN
   GETNEXTFILEH:=P;
   EXIT;
  END;
  P:=P^.NEXT;
 END;
 GETNEXTFILEH:=NIL;
END;
PROCEDURE TPROG.WRITERELOCHEADERC(VAR F:FILE);
VAR P:PRELOC;
    COUNT:DWORD;
BEGIN
 P:=RELOCS;
 COUNT:=0;
 WHILE P<>NIL DO
 BEGIN
  IF P^.TYP=6 THEN INC(COUNT);
  P:=P^.NEXT;
 END;
 BLOCKWRITE(F,COUNT,4);
 WRITELN('Eintrge im RELOCHEADER ! : ',COUNT);
END;
PROCEDURE TPROG.WRITERELOCHEADER(VAR F:FILE);
VAR P:PRELOC;
BEGIN
 P:=RELOCS;
 WHILE P<>NIL DO
 BEGIN
  IF P^.TYP=6 THEN
  BEGIN
   WRITELN('Reallocheader-Entry : ',P^.POS);
   BLOCKWRITE(F,P^.POS,4);
  END;
  P:=P^.NEXT;
 END;
END;
PROCEDURE TPROG.PROCESSFILES(VAR F:FILE);
VAR ABASE:LONGINT;
    P:PFILE;
    AFP:LONGINT;
    RLEN:LONGINT;
BEGIN
 ABASE:=0;
 P:=GETNEXTFILEH(ABASE);
 WHILE P<>NIL DO
 BEGIN
  WRITELN('Process : ',P^.FN);
  WRITELN('Base    : ',P^.BASE);
  WRITELN('Len     : ',P^.LEN);
  AFP:=0;
  RLEN:=P^.LEN;
  WHILE RLEN>64000 DO
  BEGIN
   IF LOADFILE(P^.FN,P^.FPOS+AFP,64000) THEN
   BEGIN
    WRITERELOCS(ABASE+AFP,64000);
    SAVEFILE(F);
   END ELSE WRITELN('err during load');
   DEC(RLEN,64000);
   INC(AFP,64000);
  END;
  IF RLEN>0 THEN
  BEGIN
   IF LOADFILE(P^.FN,P^.FPOS+AFP,RLEN) THEN
   BEGIN
    WRITERELOCS(ABASE+AFP,RLEN);
    SAVEFILE(F);
   END ELSE WRITELN('Fehler beim Laden : ',P^.FN);
  END;
  ABASE:=ABASE+P^.LEN;
  P:=GETNEXTFILEH(ABASE);
 END;
END;
PROCEDURE TPROG.WRITE(S:STRING;BSSW,RELA:BOOLEAN);
VAR W:FILE;
BEGIN
 WRITELN('Writefile : ',S);
 ASSIGN(W,S);
 REWRITE(W,1);
 WRITELN('Gesammtgre des BSS : ',SECTION[2].GESSIZE);
 IF NOT BSSW THEN WRITEHEADER(W);
 IF RELA THEN WRITERELOCHEADERC(W);
 IF IORESULT<>0 THEN
 BEGIN
  WRITELN('Fail');
  EXIT;
 END;
 PROCESSFILES(W);
 WRITELN('...');
 IF BSSW THEN WRITEBSS(W);
 IF RELA THEN WRITERELOCHEADER(W); { Header folgt jetzt dem Rest ! }
 CLOSE(W);
END;
PROCEDURE TPROG.LISTFILES;
VAR P:PFILE;
BEGIN
 P:=FILES;
 WHILE P<>NIL DO
 BEGIN
  WRITELN('Datei : ',P^.FN);
  WRITELN(' Sektion         : ',P^.SEC);
  WRITELN(' Speicheradresse : ',P^.BASE);
  WRITELN(' Dateiadresse    : ',P^.FPOS);
  WRITELN(' Gre           : ',P^.LEN);
  P:=P^.NEXT;
 END;
END;
PROCEDURE TPROG.UPDATEFILEBASES;
VAR P:PFILE;
BEGIN
 P:=FILES;
 WHILE P<>NIL DO
 BEGIN
  P^.BASE:=P^.BASE+SECTION[P^.SEC].GESPOS;
  P:=P^.NEXT;
 END;
END;
PROCEDURE TPROG.ADDFILE(SEC,BASE,FPOS,LEN:LONGINT;FN:STRING);
VAR N:PFILE;
BEGIN
 NEW(N);
 N^.NEXT:=FILES;
 FILES:=N;
 N^.LEN:=LEN;
 N^.FN:=FN;
 N^.FPOS:=FPOS;
 N^.SEC:=SEC;
 N^.BASE:=BASE;
END;
PROCEDURE TPROG.LINKALL;
BEGIN
 SORTSECTIONS;
 UPDATESYMBASES;
 UPDATEFILEBASES;
 UPDATERELOCS;
END;
PROCEDURE TPROG.LISTRELOCS;
VAR P:PRELOC;
BEGIN
 P:=RELOCS;
 WHILE P<>NIL DO
 BEGIN
  WRITELN('Reloc :',P^.STATE,'\',P^.INDEX,' (',P^.FN,')',' \',P^.POS);
  P:=P^.NEXT;
 END;
END;
PROCEDURE TPROG.SETRELOCP(INDEX:LONGINT;P:PSYMBOL);
VAR PP:PRELOC;
BEGIN
 PP:=RELOCS;
 WHILE PP<>NIL DO
 BEGIN
  IF (PP^.STATE=RELOCSTAT_READ) AND (PP^.INDEX=INDEX) THEN
  BEGIN
   PP^.SYMB:=P;
   PP^.STATE:=RELOCSTAT_HASP;
  END;
  PP:=PP^.NEXT;
 END;
END;
PROCEDURE TPROG.UPDATESYMBASE(P:PSYMBOL);
BEGIN
 CASE P^.CLASS OF
  SYM_INTERN,SYM_OPRIVAT:
  BEGIN
   P^.VAR2:=P^.VAR2+SECTION[P^.VAR1].GESPOS;
  END;
 END;
END;
PROCEDURE TPROG.UPDATESYMBASES;
VAR P:PSYMBOL;
BEGIN
 P:=SYMBOLS;
 WHILE P<>NIL DO
 BEGIN
  UPDATESYMBASE(P);
  P:=P^.NEXT;
 END;
END;
PROCEDURE TPROG.SORTSECTIONS;
VAR I:WORD;
    GP:LONGINT;
BEGIN
 GP:=0;
 FOR I:=0 TO 2 DO
 BEGIN
  SECTION[I].GESSIZE:=SECTION[I].AKTPOS+SECTION[I].AKTSIZE;
  SECTION[I].GESPOS:=GP;
  GP:=GP+SECTION[I].GESSIZE;
 END;
END;
PROCEDURE TPROG.UPDATESTR(P:LONGINT;S:STRING);
VAR A:PSYMBOL;
BEGIN
 A:=SYMBOLS;
 WHILE A<>NIL DO
 BEGIN
  IF (A^.STRPOS=P) THEN
  BEGIN
   WRITELN('Update name for ',P,' = ',S);
   A^.NAME:=S;
   A^.STRPOS:=0;
  END;
  A:=A^.NEXT;
 END;
END;
PROCEDURE TPROG.UPDATENAMES(VAR F:FILE);
VAR C:CHAR;
    START:LONGINT;
    S:STRING;
BEGIN
 SEEK(F,STRTAB+4);
 START:=4;
 S:='';
 WHILE NOT EOF(F) DO
 BEGIN
  BLOCKREAD(F,C,1);
  IF (C=#0) AND (S<>'') THEN
  BEGIN
   UPDATESTR(START,S);
   S:='';
   START:=FILEPOS(F)-STRTAB;
  END ELSE S:=S+C;
 END;
END;
PROCEDURE TPROG.ADDOTHER(INDEX:LONGINT;S:STRING;STRPOS,TYP:LONGINT);
VAR P:PSYMBOL;
BEGIN
 P:=ADDSYMBOLE(INDEX,S,STRPOS,SYM_OTHER);
 P^.VAR1:=TYP;
END;
PROCEDURE TPROG.ADDPRIVAT(INDEX:LONGINT;S:STRING;STRPOS,POS,SEC:LONGINT);
VAR P:PSYMBOL;
BEGIN
 P:=ADDSYMBOLE(INDEX,S,STRPOS,SYM_PRIVAT);
 P^.VAR1:=SEC;
 P^.VAR2:=SECTION[SEC].AKTPOS+POS;
 SETRELOCP(INDEX,P);
END;
PROCEDURE TPROG.ADDINTERN(INDEX:LONGINT;S:STRING;STRPOS,POS,SEC:LONGINT);
VAR P:PSYMBOL;
BEGIN
 P:=ADDSYMBOLE(INDEX,S,STRPOS,SYM_INTERN);
 P^.VAR1:=SEC;
 P^.VAR2:=SECTION[SEC].AKTPOS+POS;
END;
PROCEDURE TPROG.ADDEXTERN(INDEX:LONGINT;S:STRING;STRPOS:LONGINT);
VAR P:PSYMBOL;
BEGIN
 P:=ADDSYMBOLE(INDEX,S,STRPOS,SYM_EXTERN);
 SETRELOCP(INDEX,P);
END;
FUNCTION TPROG.ADDSYMBOLE(INDEX:LONGINT;S:STRING;STRPOS,CL:LONGINT):PSYMBOL;
VAR P:PSYMBOL;
BEGIN
 NEW(P);
 P^.NEXT:=SYMBOLS;
 SYMBOLS:=P;
 P^.INDEX:=INDEX;
 P^.NAME:=S;
 WRITELN('ADDSYMBOL :'+S+'(',STRPOS,')');
 IF S='' THEN P^.STRPOS:=STRPOS ELSE P^.STRPOS:=0;
 P^.CLASS:=CL;
 P^.EXTRA:=NIL;
 P^.FN:=AFN;
 ADDSYMBOLE:=P;
END;
PROCEDURE TPROG.SHOWSYMBOLS;
VAR P:PSYMBOL;
BEGIN
 P:=SYMBOLS;
 WHILE P<>NIL DO
 BEGIN
  CASE P^.CLASS OF
   SYM_EXTERN:
   BEGIN
    WRITELN('Externes Symbol : (',P^.INDEX,')');
    WRITELN(' Name            : ',P^.NAME);
    WRITELN(' Dateiname       : ',P^.FN);
   END;
   SYM_INTERN:
   BEGIN
    WRITELN('Internes Symbol : (',P^.INDEX,')');
    WRITELN(' Name            : ',P^.NAME);
    WRITELN(' Dateiname       : ',P^.FN);
    WRITELN(' Sektion         : ',P^.VAR1);
    WRITELN(' Position        : ',P^.VAR2);
   END;
   SYM_PRIVAT,SYM_OPRIVAT:
   BEGIN
    WRITELN('Privates Symbol : (',P^.INDEX,')');
    WRITELN(' Name            : ',P^.NAME);
    WRITELN(' Dateiname       : ',P^.FN);
    WRITELN(' Sektion         : ',P^.VAR1);
    WRITELN(' Position        : ',P^.VAR2);
   END;
   SYM_OTHER:
   BEGIN
    WRITELN('Unbekanntes Symbol : (',P^.INDEX,')');
    WRITELN(' Name            : ',P^.NAME);
    WRITELN(' Dateiname       : ',P^.FN);
    WRITELN(' Klasse          : ',P^.VAR1);
    WRITELN(' Strpos          : ',P^.STRPOS);
   END;
  END;
  P:=P^.NEXT;
 END;
END;
PROCEDURE TPROG.ADDSYMBOL(INDEX:LONGINT;SYM:RCOFFSYMTABENTRY);
VAR ST:STRING;
    LEN:BYTE;
    P:PRELOC;
BEGIN
 IF SKIP>0 THEN
 BEGIN
  DEC(SKIP);
  EXIT;
 END;
 MOVE(SYM.STR,ST[1],8);
 LEN:=0;
 WHILE (LEN<8) AND (ST[LEN+1]<>#0) DO INC(LEN);
 ST[0]:=CHAR(LEN);
 CASE SYM.TYP OF
  2:
  BEGIN
   IF (SYM.VALUE=0) AND (SYM.SECTION=0) THEN ADDEXTERN(INDEX,ST,SYM.STRPOS)
    ELSE ADDINTERN(INDEX,ST,SYM.STRPOS,SYM.VALUE,SECTIONC[SYM.SECTION]);
{   P:=FINDRELOC(INDEX);
   IF (P<>NIL) THEN ADDEXTERN(INDEX,ST,SYM.STRPOS) ELSE
   BEGIN
    IF SYM.SECTION=0 THEN
    BEGIN
     ADDOTHER(INDEX,ST,SYM.STRPOS,SYM.TYP);
    END ELSE ADDINTERN(INDEX,ST,SYM.STRPOS,SYM.VALUE,SECTIONC[SYM.SECTION]);
   END;}
  END;
  3:ADDPRIVAT(INDEX,ST,SYM.STRPOS,SYM.VALUE,SECTIONC[SYM.SECTION]);
  ELSE ADDOTHER(INDEX,ST,SYM.STRPOS,SYM.TYP);
 END;
 WRITELN('E: ',SYM.EMPTY);
 WRITELN('T: ',SYM.TYP);
 WRITELN('V: ',SYM.VALUE);
 WRITELN('A: ',SYM.AUX);
 WRITELN('S: ',SYM.SECTION);
 SKIP:=SYM.AUX;
END;
PROCEDURE TPROG.READSYMBOLS(VAR F:FILE);
VAR S:RCOFFSYMTABENTRY;
    CO:WORD;
BEGIN
 SEEK(F,SYMTAB);
 FOR CO:=0 TO SYMTABLEN-1 DO
 BEGIN
  BLOCKREAD(F,S,SIZEOF(S));
  ADDSYMBOL(CO,S);
 END;
END;
FUNCTION TPROG.FINDRELOC(SYM:LONGINT):PRELOC;
VAR P:PRELOC;
BEGIN
 P:=RELOCS;
 WHILE P<>NIL DO
 BEGIN
  IF (P^.STATE=RELOCSTAT_READ) AND (P^.INDEX=SYM) THEN
  BEGIN
   FINDRELOC:=P;
   EXIT;
  END;
  P:=P^.NEXT;
 END;
 FINDRELOC:=NIL;
END;
PROCEDURE TPROG.ADDRELOC(SEC:INTEGER;POS,SYM:LONGINT;TYP:WORD);
VAR P:PRELOC;
BEGIN
 NEW(P);
 P^.NEXT:=RELOCS;
 RELOCS:=P;
 P^.SECTION:=SEC;
 P^.POS:=POS+SECTION[SEC].AKTPOS;
 P^.TYP:=TYP;
 P^.INDEX:=SYM;
 P^.FN:=AFN;
 P^.STATE:=RELOCSTAT_READ;
END;
PROCEDURE TPROG.READRELOC(VAR F:FILE);
VAR I,N:WORD;
    D:RRELOC;
BEGIN
 FOR I:=0 TO 2 DO
 BEGIN
  SEEK(F,SECTION[I].RELOCTAB);
  FOR N:=1 TO SECTION[I].RELOCCO DO
  BEGIN
   BLOCKREAD(F,D,SIZEOF(D));
   ADDRELOC(I,D.ADDR,D.SYMB,D.REL);
  END;
 END;
END;
PROCEDURE TPROG.READSECTIONS(VAR F:FILE);
VAR INFO:RCOFFSECTIONINFO;
    CO:LONGINT;
    FND:WORD;
    IMAGES:LONGINT;
BEGIN
 SEEK(F,SECTAB);
 SECTION[SEC_TEXT].RELOCCO:=0;
 SECTION[SEC_DATA].RELOCCO:=0;
 SECTION[SEC_BSS].RELOCCO:=0;
 IMAGES:=MAXLONGINT;
 FOR CO:=1 TO SECTABLEN DO
 BEGIN
  FND:=$FFFF;
  BLOCKREAD(F,INFO,SIZEOF(INFO));
  IF INFO.SECNAME=SECNM_TEXT THEN FND:=SEC_TEXT ELSE
  IF INFO.SECNAME=SECNM_DATA THEN FND:=SEC_DATA ELSE
  IF INFO.SECNAME=SECNM_BSS THEN FND:=SEC_BSS ELSE
  BEGIN
   WRITELN('Sektionsname ist nicht zulssig in diesem Linker !!!');
   WRITELN(INFO.SECNAME);
   CLOSE(OUTPUT);
   ASSIGN(OUTPUT,'');
   REWRITE(OUTPUT);
   WRITELN('Sektionsname ist nicht zulssig in diesem Linker !!!');
   WRITELN(INFO.SECNAME);
   HALT;
  END;
  SECTIONC[CO]:=FND;
  WRITELN('SECTION LINE NUMBERS : ',INFO.INNOPTR);
  SECTION[FND].RELOCTAB:=INFO.RELPTR;
  SECTION[FND].RELOCCO:=INFO.NRELOC;
  SECTION[FND].AKTPOS:=SECTION[FND].AKTPOS+SECTION[FND].AKTSIZE;
  SECTION[FND].AKTSIZE:=INFO.SIZE;
  SECTION[FND].SECFP:=INFO.FILEPOS;
  IF INFO.SIZE<>0 THEN
  BEGIN
   IF INFO.FILEPOS<IMAGES THEN IMAGES:=INFO.FILEPOS;
  END;
  IF (INFO.SIZE<>0) AND (FND IN [0,1]) THEN ADDFILE(FND,SECTION[FND].AKTPOS,INFO.FILEPOS,INFO.SIZE,AFN);
 END;
 FOR CO:=0 TO 1 DO
 BEGIN
  SECTION[CO].SECFP:=SECTION[CO].SECFP-IMAGES;
 END;
END;
PROCEDURE TPROG.READHEADER(VAR F:FILE);
VAR HEADER:RCOFFMAINHEADER;
BEGIN
 SEEK(F,0);
 BLOCKREAD(F,HEADER,SIZEOF(HEADER));
 SECTAB:=SIZEOF(HEADER)+HEADER.SECHEADERSIZE;
 SECTABLEN:=HEADER.SECTIONS;
 SYMTAB:=HEADER.SYMTAB;
 SYMTABLEN:=HEADER.SYMTABCO;
 STRTAB:=SYMTAB+SYMTABLEN*SIZEOF(RCOFFSYMTABENTRY);
END;
PROCEDURE TPROG.LINK(S:STRING);
VAR F:FILE;
    I:WORD;
BEGIN
 WHILE POS('\',S)<>0 DO DELETE(S,1,POS('\',S));
 AFN:=S;
 ASSIGN(F,S);
 RESET(F,1);
 IF IORESULT<>0 THEN
 BEGIN
  I:=0;
  WHILE I<PATHNUMS DO
  BEGIN
   ASSIGN(F,PATHS[I]+S);
   RESET(F,1);
   IF IORESULT<>0 THEN INC(I) ELSE BREAK;
  END;
  IF I=PATHNUMS THEN
  BEGIN
   WRITELN('File ',S,' konnte nicht gelinkt werden !');
   EXIT;
  END;
 END;
 READHEADER(F);
 READSECTIONS(F);
 READRELOC(F);
 READSYMBOLS(F);
 UPDATENAMES(F);
 ENDPRIVAT;
 CLOSE(F);
END;
CONSTRUCTOR TPROG.INIT;
VAR I:WORD;
BEGIN
 SKIP:=0;
 FOR I:=0 TO 2 DO
 BEGIN
  SECTION[I].AKTPOS:=0;
  SECTION[I].AKTSIZE:=0;
  SECTION[I].GESPOS:=0;
  SECTION[I].GESSIZE:=0;
 END;
 FILES:=NIL;
 RELOCS:=NIL;
 SYMBOLS:=NIL;
END;
VAR PROG:PPROG;
    CO:WORD;
    FN:STRING;
    OFN:STRING;
    OFNN:BOOLEAN;
    SE:SEARCHREC;
    ADDBSS,ADDREL:BOOLEAN;
PROCEDURE ADDRES(S:STRING);
VAR T:TEXT;
BEGIN
 ASSIGN(T,S);
 RESET(T);
 IF IORESULT<>0 THEN EXIT;
 WHILE NOT EOF(T) DO
 BEGIN
  READLN(T,S);
  IF S<>'' THEN
  BEGIN
   IF S[1]<>'-' THEN
   BEGIN
    { Ob das elegant ist ? Oje... }
    WHILE S[1]='.' DO DELETE(S,1,1);
    WHILE S[1]='\' DO DELETE(S,1,1);
    PROG^.LINK(S);
   END
   ELSE
   BEGIN
    IF S[2]='L' THEN ADDPATH(COPY(S,3,LENGTH(S)));
   END;
  END;
 END;
 CLOSE(T);
END;
BEGIN
 OFNN:=FALSE;
 FN:=GETENV('LD_BINARY');
 IF FN='0' THEN ADDBSS:=TRUE;
 IF FN='1' THEN ADDREL:=TRUE;
 WRITELN('Linker fr RS3');
 ASSIGN(OUTPUT,'OUT');
 REWRITE(OUTPUT);
 NEW(PROG,INIT);
 FOR CO:=1 TO PARAMCOUNT DO
 BEGIN
  FN:=PARAMSTR(CO);
  IF OFNN THEN
  BEGIN
   OFN:=FN;
   OFNN:=FALSE;
  END ELSE
  BEGIN
   IF (FN[1]='@') THEN
   BEGIN
    FN:=COPY(FN,2,LENGTH(FN));
    ADDRES(FN);
   END ELSE IF (FN[1]='-') THEN
   BEGIN
    IF (LENGTH(FN)=2) THEN
    BEGIN
     IF (FN[2]='e') THEN
     BEGIN
      WRITELN('Param -e => ADDBSS');
      ADDBSS:=TRUE;
     END;
    END;
    IF (LENGTH(FN)>1) AND (UPCASE(FN[2])='O') THEN
    BEGIN
     IF (LENGTH(FN)>2) THEN
     BEGIN
      OFN:=COPY(FN,3,LENGTH(FN));
     END ELSE OFNN:=TRUE;
    END;
   END
   ELSE IF (UPCASE(FN[LENGTH(FN)])='O') AND
           (UPCASE(FN[LENGTH(FN)-1])='.') THEN
   BEGIN
    FINDFIRST(FN,ANYFILE,SE);
    WHILE DOSERROR=0 DO
    BEGIN
     PROG^.LINK(SE.NAME);
     FINDNEXT(SE);
    END;
   END;
  END;
 END;
 PROG^.LINKALL;
 PROG^.SHOWSYMBOLS;
 PROG^.LISTFILES;
 PROG^.LISTRELOCS;
 IF NOT OFNN THEN OFN:='RES.BB';
 PROG^.WRITE(OFN,ADDBSS,ADDREL);
 WRITELN('Done !');
 CLOSE(OUTPUT);
END.
