{$M 16384,0,0}
PROGRAM LOAD;
CONST BUFFERSIZE=32768;
FUNCTION MEMSIZE:WORD;ASSEMBLER;
ASM
  MOV AH,48h
  MOV BX,65535
  INT 21h
  MOV AX,BX
END;
FUNCTION ALLOCMEM(PARA:WORD):WORD;ASSEMBLER;
ASM
  MOV AH,48h
  MOV BX,PARA
  INT 21h
  JNC @NOERR
  XOR AX,AX
 @NOERR:
END;
PROCEDURE FREEMEM(SEGM:WORD);ASSEMBLER;
ASM
  MOV AH,49h
  MOV ES,SEGM
  INT 21h
END;
VAR F:FILE;
    FS:LONGINT;
    FP:LONGINT;
    SG,ASG:WORD;
    RL:WORD;
    BUFFER:ARRAY[0..BUFFERSIZE-1] OF BYTE;
PROCEDURE READBOOTBLOCK;FAR;
BEGIN
 ASM
   PUSH DS
   PUSH ES
   MOV AX,SEG @DATA
   MOV DS,AX
   MOV ES,AX
 END;
 BLOCKREAD(F,BUFFER,BUFFERSIZE,RL);
 ASM
   POP ES
   POP DS
 END;
END;
PROCEDURE CALLP(P:POINTER);ASSEMBLER;
ASM
  PUSH BP
  MOV CX,SEG READBOOTBLOCK
  MOV BX,OFFSET READBOOTBLOCK
  MOV DX,SEG BUFFER
  MOV SI,OFFSET BUFFER
  MOV DI,BUFFERSIZE
  CALL DWORD PTR [P]
  POP BP
END;
BEGIN
 ASSIGN(F,'KERNEL16.K16');
 RESET(F,1);
 IF IORESULT<>0 THEN
 BEGIN
  WRITELN('KERNEL16.K16 nicht gefunden.');
  HALT;
 END;
 FS:=FILESIZE(F);
 FP:=(FS DIV 16)+ORD(FS MOD 16<>0);
 SG:=ALLOCMEM(FP);
 IF SG=0 THEN
 BEGIN
  WRITELN('Konnte nicht genug Speicher reservieren.');
  CLOSE(F);
  HALT;
 END;
 ASG:=SG;
 REPEAT
  BLOCKREAD(F,PTR(ASG,0)^,32768,RL);
  ASG:=ASG+2048;
 UNTIL RL=0;
 CLOSE(F);
 ASSIGN(F,'BOOT.DAT');
 RESET(F,1);
 IF IORESULT=0 THEN
 BEGIN
  CALLP(PTR(SG,0));
  CLOSE(F);
 END ELSE WRITELN('Konnte BOOT.DAT nicht finden !');
{ ASM
   CLD
   MOV AX,0B800h+160*5
   MOV ES,AX
   MOV DI,0
   MOV CX,160
   MOV AL,'C'
   MOV AH,14
   REP STOSW
 END;}
 FREEMEM(SG);
END.
